2017-07-06 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/peeph.def,
	  src/stm8/peep.c:
	  Improve accuracy and fix bugs in peephole optimizer.

2017-07-05 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCopt.c,
	  src/SDCCsymt.c:
	  Minor code cleanup, gets rid of a few LLVM warnings.

2017-07-03 Philipp Klaus Krause <pkk AT spth.de>

	* sdas/asstm8/stm8pst.c:
	  Support for break debug instruction, patch by Reto Schneider.

2016-12-12 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCast.c:
	  add cast to left and right subtree only if they both can be casted.
	* support/regression/tests/bug-2611.c:
	  add a new test case.

2017-06-29 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCgen.c,
	  support/regression/tests/bug-2627.c:
	  Fix bug #2627.
	* src/stm8/gen.c:
	  Enable use of execution count in stm8 register allocation cost calculations.

2017-06-28 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCicode.h,
	  src/SDCCopt.c:
	  Execution frequency handling infrastructure.

2017-06-26 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCralloc.hpp,
	  .version,
	  src/*/ralloc2.cc:
	  Speed up register allocator.

2017-06-25 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCralloc.hpp,
	  src/SDCCbitv.h,
	  src/SDCCbitv.c,
	  src/*/ralloc2.cc:
	  Speed up register allocator a bit.

2017-06-24 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  More efficient >= 32-bit increment for (partially) spilt local variables.

2017-06-23 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Improve 16-bit register-to-register transfer,
	  consider cycle cost for register allocation.
	* src/stm8/peeph.def:
	  Improve 16-bit addition with on-stack operand.

2017-06-17 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c,
	  src/stm8/peeph.def:
	  More efficient comparisons.

2017-06-14 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/bug-2621.c:
	  Disable test for ds390, which doesn't have long long.

2017-06-13 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/stm8.c:
	  More efficient equality comparisons.
	* support/regression/tests/bug-2621.c:
	  Test for bug #2612.

2017-06-12 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/stm8.c:
	  More efficient equality comparisons, fix bug #2612.

2017-05-31 Philipp Klaus Krause <pkk AT spth.de>

	* device/non-free/lib/pic14/Makefile.in,
	  device/non-free/lib/pic14/Makefile.subdir,
	  src/Makefile.in,
	  src/port.mk:
	  Sort directory listings towards are reproducible build, patch by Bernhard M. Wiedemann.

2017-05-30 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCC.lex,
	  src/SDCCmain.c,
	  src/SDCCicode.c,
	  doc/sdccman.lyx:
	  Deprecate --nojtbound and the corresponding pragma.

2017-05-15 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c:
	  Fix bug #2617.

2017-05-15 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c:
	  Fix a z80 codegen bug #2615 in and (triggered by recent register allocation changes when using --reserve-regs-iy).

2017-05-15 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c:
	  Fix a gbz80 codegen bug in comparisons (triggered by recent register allocation changes).

2017-05-13 Maarten Brock <sourceforge.brock AT dse.nl>

	* support/regression/tests/test-p99-conformance.c: renamed p99-conformance.c
	  decreased flex10 to flex2,
	  removed SKIP_FLEXIBLE, SKIP_LONG_LONG for mcs51

2017-05-10 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCdwarf2.c:
	  Fix encoding DWARF info for _Bool, explicitly specify for char.

2017-05-09 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/main.c,
	  src/z80/gen.c:
	  Better code for switch statements.

2017-05-08 Maarten Brock <sourceforge.brock AT dse.nl>

	* support/regression/tests/inline.c: oops, wrong place to skip bug_2591

2017-05-08 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/peeph-z80.def,
	  src/z80/ralloc.c,
	  src/z80/ralloc2.cc:
	  Improve handling of 8-bit parameters.

2017-05-07 Maarten Brock <sourceforge.brock AT dse.nl>

	* support/regression/fwk/lib/extern1.c: renamed bug2591 to bug_2591
	* support/regression/tests/inline.c: skip bug_2591 for old buggy GCC

2017-05-06 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCopt.c:
	  Optimize computations on shift counts.
	* src/stm8/gen.c:
	  Fix bug in register handling in shifts.
	* src/z80/gen.c:
	  Optimize computations on shift counts, fix bug in register handling of
	  wide shifts.

2017-05-06 Maarten Brock <sourceforge.brock AT dse.nl>

	* doc/sdccman.lyx: fixed typo
	* sim/ucsim/gui.src/Makefile.in: use $(AR)
	* src/mcs51/gen.c: cosmetic
	* src/SDCC.lex,
	* src/stm8/main.c,
	* src/z80/main.c: make __smallc a target specific keyword 
	* src/SDCCicode.c (geniCodeAdd): take generic pointers into account
	* src/z80/ralloc2.cc (assign_operands_for_cost): fix warning, remove TABs
	* support/regression/fwk/lib/extern1.c,
	* support/regression/tests/inline.c: added bug2591 test
	* support/regression/tests/bug-2601.c: test with several pointer sizes
	* support/regression/tests/bug-2590.c,
	* support/regression/tests/smallc.c,
	* support/regression/tests/z88dk.c: test __smallc only on stm8 & z80-like

2017-05-05 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/bug-2188.c,
	  support/regression/tests/gcc-torture-execute-930526-1.c:
	  Add extern declaration to make test compile where functions aren't inlined.

2017-05-05 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/stm8/gen.c (genMove_o): fixed bug #2607

2017-05-04 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCpeeph.c:
	  Be more forgiving about omitted whitespace after comma in peephole matching
	  (whitespace handling had become stricter in the fix to #2600).
	* src/z80/peep.c:
	  Slightly more accurate analysis of register reads, also wrt. whitespaces.
	* src/z80/gen.c:
	  Unify emitted asm syntax wrt. space after comma.

2017-05-02 Philipp Klaus Krause <pkk AT spth.de>

	* doc/sdccman.lyx:
	  Minor fix in list of supported data types.

2017-05-01 Philipp Klaus Krause <pkk AT spth.de>

	* doc/sdccman.lyx:
	  Document separation of _Bool/bool and __bit for mcs51 and ds390,
	  fix typos,
	  automatic version number.

2017-04-29 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCmain.c,
	  doc/sdccman.lyx,
	  .version:
	  Resurrect SDCC macro zombie for old SiLabs IDE support.
	* sdcc.spec:
	  Update list of targets in description.

2017-04-28 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCast.c,
	  src/SDCCicode.c,
	  support/regression/tests/bug-2601.c,
	  support/regression/tests/bug3537338.c,
	  support/regression/tests/gcc-torture-execute-20021120-1.c:
	  Fix bug #2602.
	* src/SDCCsymt.h,
	  src/SDCCsymt.c:
	  Minor improvements for const-correctness.
	* src/SDCCpeeph.c:
	  Fix bug #2600.

2017-04-28 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/bug-2590.c:
	  Enable for all z80-related backends.
	* support/regression/tests/bug-2601.c:
	  Disable for ds390.

2017-04-27 Philipp Klaus Krause <pkk AT spth.de>

	* doc/sdccman.lyx:
	  Update manual for --std-sdcc99 vs. --std-c11 change.
	* device/lib/tlcs90/crt0.s:
	  Fix bug #2583.

2017-04-27 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/SDCCsymt.c (newEnumType): fixed bug 2545
	* support/regression/tests/enum.c: added test
	* support/regression/tests/bug-2590.c: disabled for non-z80

2017-04-26 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/ds390/gen.c (assignBit): disabled to fix a warning
	* src/SDCCicode.c (geniCodeLeftShift): fixed bug, replaced TABs
	* src/SDCCralloc.hpp (create_cfg): fixed warning, replaced TABs
	* src/SDCCsymt.c (computeType): fixed bug #2585
	* src/stm8/ralloc2.cc (assign_operands_for_cost): fixed warning, replaced TABs
	* src/z80/gen.c (genLeftShift, genRightShift): fixed warning
	* src/z80/peep.c (z80SurelyWrites): fixed warning
	* support/regression/tests/gcc-torture-execute-20020201-1.c
	* support/regression/tests/bug-2585.c: new, added

2017-04-24 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCast.c,
	  support/regression/tests/bug-2601.c:
	  Fix bug #2601.

2017-04-13 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/peep.c:
	  Minor improvement in Z180 support from z88dk patch.

2017-04-12 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/smallc.c:
	  Disable Small-C test for mcs51.

2017-04-11 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCast.c,
	  support/regression/tests/bug-2596.c:
	  Fix bug #2598 by not inlining calls to functions with variable arguments.

2017-04-10 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCmem.c:
	  Fix bug #2591.
	* support/regression/tests/smallc.c:
	  Do not try to test __smallc for host.
	* src/SDCCsymt.c:
	  Always specify signedness for char in debug dumps.
	* support/regression/tests/bug-2539.c:
	  Test for bug #2539.
	* src/z80/peeph-z80.def,
	  src/z80/peeph-tlcs90.def,
	  src/z80/peeph-r2k.def:
	  Fix bug #2597.
	* src/SDCCglue.c:
	  Fix bug #2574 (patch by Sebastian).
	* src/mcs51/gen.c,
	  support/regression/tests/gcc-torture-execute-921202-2.c:
	  Fix bug #2542.

2017-04-06 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCmem.c,
	  support/regression/tests/z88dk.c,
	  support/regression/tests/smallc.c,
	  doc/sdccman.lyx:
	  Support for __smallc callees.

2017-04-06 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCast.c:
	  Fix bug #2570.
	* src/SDCCmem.h,
	  src/SDCCmem.c,
	  src/z80/gen.c:
	  Fix bug #2595.

2017-04-03 Philipp Klaus Krause <pkk AT spth.de>

	* doc/sdccman.lyx:
	  Update documentation on _Bool / bool support.

2017-03-17 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/bug3027957.c:
	  Disable fixed-address test for host.

2017-03-17 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/SDCCicode.c (geniCodeAdd): Fix bug #2568 fix

2017-03-15 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCast.h,
	  src/SDCCast.c,
	  src/SDCCcse.c:
	  Fix bug #2593.
	* support/regression/tests/absolute.c,
	  support/regression/tests/bug-2304.c,
	  support/regression/tests/bug2686159.c,
	  support/regression/tests/bug3027957.c:
	  Fix bug #2584.
	* src/SDCCicode.c,
	  support/regression/tests/bug-2568.c:
	  Fix bug #2568.

2017-03-15 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/SDCCast.c (checkZero): fix bug #2586

2017-03-14 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c,
	  support/regression/tests/bug-2582.c:
	  Fix bug #2582.

2017-03-14 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/SDCC.y: fixed bug #2587
	* support/regression/tests/for.c: change to catch bug #2587
	* support/regression/tests/bug-2590.c: disable test on host

2017-03-13 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c,
	  support/regression/tests/bug-2376.c:
	  Fix bug #2376.

2017-03-08 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCopt.c,
	  support/regression/tests/bug-2590.c:
	  Fix bug #2590.

2017-02-10 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c:
	  Omit some unnecessary register saving on wide shifts.

2017-02-09 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c:
	  Optimize wide right shifts, part of RFE #524.
	* device/lib/rand.c,
	  support/regression/tests/rand.c:
	  Fix default seed.

2017-02-08 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/rand.c:
	  Replace LCG by xorshift for rand().
	* src/z80/gen.c:
	  Optimize wide left shifts, part of RFE #524.

2017-02-04 Philipp Klaus Krause <pkk AT spth.de>

	* device/include/pic14/math.h,
	  device/include/pic16/math.h,
	  device/lib/pic14/libm/Makefile.am,
	  device/lib/pic14/libm/Makefile.in,
	  device/lib/pic16/libm/Makefile.am,
	  device/lib/pic16/libm/Makefile.in,
	  src/pic14/gen.c,
	  src/pic14/glue.c,
	  support/regression/compact-results.py,
	  support/regression/ports/pic14/support.c,
	  support/regression/tests/absolute.c,
	  support/regression/tests/bug1723128.c,
	  support/regression/tests/bug2686159.c,
	  support/regression/tests/gcc-torture-execute-20021120-1.c,
	  support/regression/tests/gcc-torture-execute-pr19606.c:
	  Various pic14-related fixes: Patches 00, 01, 02, 04, 05, 07, 09, 11, 14, 15 by Martin Habets via sdcc-devel.

2017-01-13 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/SDCCast.c (expandInlineFuncs,fixupInline): Fix bug #2559
	* support/regression/tests/bug-2559.c: Re-enable test

2017-01-12 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Improve efficiency of wide left-shifts.

2017-01-10 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/SDCCicode.c (geniCodeDerefPtr): Fix bug #2575

2016-12-29 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/wchar.c:
	  Test some more wide character functionality.

2016-12-28 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/SDCCglobl.h,
	* src/SDCCmain.c: applied patch #276, adds -MD option, Thanks Anders Dellien

2016-12-19 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/mbrlen.c,
	  support/regression/tests/wchar.c:
	  Fix bug #2566.

2016-12-18 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/main.c:
	  Save space by omitting an unused part of the interrupt table.

2016-12-17 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c,
	  src/stm8/peeph.def:
	  Minor code improvements, mostly for bit-fields.

2016-12-12 Philipp Klaus Krause <pkk AT spth.de>

	* doc/sdccman.lyx:
	  Document STM8 trap handler syntax.

2016-12-12 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCast.c
	* src/SDCCerr.c
	  Fix incorrect error messages.

2016-11-27 Philipp Klaus Krause <pkk AT spth.de>

	* device/include/wchar.h,
	  device/lib/btowc.c,
	  device/lib/incl.mk,
	  device/lib/mbrlen.c,
	  device/lib/mbstowcs.c,
	  device/lib/wcscmp.c,
	  device/lib/wcstombs.c,
	  device/lib/wctob.c,
	  device/lib/wcslen.c,
	  support/regression/tests/string.c,
	  support/regression/tests/wchar.c:
	  Improvements and fixes in wide character library support.

2016-11-26 Philipp Klaus Krause <pkk AT spth.de>

	* device/include/stdlib.h,
	  device/lib/incl.mk,
	  device/lib/mbstowcs.c,
	  device/lib/wcstombs.c,
	 .version:
	  Multibyte/wide string conversion functions.
	* src/stm8/gen.c:
	  Optimize comparisons with (partial) 1 and -1.

2016-11-17 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCClospre.cc,
	  src/SDCClospre.hpp:
	  More fine-grained handling of volatile to allow more optimizations in lospre.

2016-11-17 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/ralloc.c,
	  src/z80/ralloc.c:
	  Fix some comments on spilling.
	* support/regression/tests/bug-2559.c

2016-11-07 Philipp Klaus Krause <pkk AT spth.de>

	* configure.ac,
	  configure,
	  src/SDCCasm.c,
	  src/SDCCasm.h,
	  src/SDCCglue.c,
	  src/SDCCmain.c,
	  src/port.h,
	  src/xa51,
	  support/regression/ports/xa51,
	  support/regression/Makefile.in:
	  Kill incomplete, unmaintained xa51 backend.

2016-11-07 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCicode.c
	  Fix a bug in zeror-divider check.

2016-11-02 Philipp Klaus Krause <pkk AT spth.de>

	* device/include/stdbool.h,
	  src/ds390/gen.c,
	  support/regression/tests/bitopcse.c,
	  support/regression/tests/bool.c,
	  support/regression/tests/bug2942247.c,
	  support/regression/tests/bug3404101.c,
	  support/regression/tests/bug3565757.c:
	  bool for ds390.

2016-11-03 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCicode.c,
	  src/SDCCloop.c,
	  src/SDCCopt.c,
	  src/port.h,
	  src/*/main.c:
	  Replace all muldiv uses by hasNativeMulFor().

2016-10-23 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c,
	  support/regression/tests/bug-2554.c:
	  Fix a stack corruption issue in stm8 ! code generation, bug #2554.

2016-10-23 Ben Shi <powerstudio1st AT 163 DOT com>

	* sdas/linksrc/lkbank.c
	* sdas/linksrc/lksym.c
          Fix a buffer overflow error in revision #9786.

2016-10-22 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/*.c,
	  support/regression/ports/*/spec.mk:
	  Cleanup handling of __reentrant in the regression tests, RFE #517.

2016-10-22 Ben Shi <powerstudio1st AT 163 DOT com>

        * sdas/linksrc/lksym.c
          Fix a buffer overflow error in previous commit.

2016-10-21 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCBBlock.c,
	  src/SDCClabel.c:
	  Fix a bug in BBlock label handling, allows reenabling jump-to-jump optimization for jump tables.

2016-10-17 Ben Shi <powerstudio1st AT 163 DOT com>

	* sdas/linksrc/lkbank.c
	  Fix bug #2549.

2016-10-11 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCClabel.c:
	  Temporarily disable jump-to-jump optimization for jump tables RFE #514, since it causes a hc08/z80 regression.

2016-10-02 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCcse.c:
	  Optimize out negation by inverting jump condition, part of RFE #516.

2016-10-02 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCClabel.c,
	  src/SDCCset.h,
	  src/SDCCset.c:
	  Implement jump-to-jump optimization for jump tables RFE #514.
	* src/SDCCcse.c:
	  Optimize bitwise and of _Bool and comparison results, RFE #513.

2016-09-25 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/mcs51/gen.c (shiftLLong): support sizes 1,2,4,8,
	  refactored genlshOne, genlshTwo, genlshFour into genlshFixed,
	  (genLeftShiftLiteral): support long long

2016-09-24 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCast.c,
	  support/regression/tests/bug-2548.c,
	  support/regression/tests/bug-2551.c:
	  Fix bugs #2548, #2551 by disabling a broken AST optimization.

2016-09-19 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/stm8/gen.c
	  Fix a bug in bitwise-and operation (genAnd()).

2016-09-17 Maarten Brock <sourceforge.brock AT dse.nl>

	* config.vcxproj,
	* src/sdcc.vcxproj,
	* src/sdcc.vcxproj.filters: moved SDCC.lex and SDCC.y to config project
	* src/mcs51/gen.c (gencjneshort): proper support for long long
	* src/mcs51/peeph.def: restart 3.b
	* src/SDCCsymt.c (initCSupport): MSVC doesn't support casting compound lit
	* src/SDCCval.c (csdOfVal): we still use MSVC 2010, no mid-code declarations
	* support/regression/tests/bug-2205.c: removed unused disabled warning
	* support/regression/tests/gcc-torture-execute-20020506-1.c: intermediate
	  functions should not be named test*
	* support/regression/tests/gcc-torture-execute-961122-1.c: fixed no-return
	  warning

2016-09-17 Ben Shi <powerstudio1st AT 163 DOT com>

	* device/lib/isinf.c
	* device/lib/isnan.c
	  Improve comapabililty and efficiency.
 
2016-09-15 Ben Shi <powerstudio1st AT 163 DOT com>

	* device/lib/isinf.c
	* device/lib/isnan.c
	  Improve compatibility.

2016-09-14 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/mcs51/gen.c (isLiteralBit): fixed for long long,
	  (genReceive):	fixed stack smashing bug
	* support/regression/tests/test-p99-conformance.c: decreased restrict_buffer

2016-09-12 Philipp Klaus Krause <pkk AT spth.de>

	* device/include/stdbool.h,
	  src/mcs51/gen.c:
	  Standard-compliant _Bool for mcs51.

2016-09-08 Philipp Klaus Krause <pkk AT spth.de>

	* device/include/stdint.h:
	  Enable C99 typedefs for 64-bit types.

2016-09-07 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/mcs51/gen.c
	  Improve longlong compatibility of mcs-51 on 32-bit hosts.

2016-09-03 Philipp Klaus Krause <pkk AT spth.de>

	* src/mcs51/gen.c:
	  Fixes for mcs51 long long on 32-bit hosts.

2016-08-30 Philipp Klaus Krause <pkk AT spth.de>

	* src/mcs51/gen.c:
	  Fixes for mcs51 long long on 32-bit hosts.

2016-08-28 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/gcc-torture-execute-20020506-1.c:
	  Disable test for ds390 that accidentially got enabled when enabled for mcs51.

2016-08-26 Philipp Klaus Krause <pkk AT spth.de>

	* src/mcs51/peep.c,
	  support/regression/tests/bug-2477.c,
	  support/regression/tests/gcc-torture-execute-20001031-1.c,
	  support/regression/tests/gcc-torture-execute-20020506-1.c,
	  support/regression/tests/gcc-torture-execute-20060127-1.c,
	  support/regression/tests/gcc-torture-execute-941015-1.c,
	  support/regression/tests/gcc-torture-execute-950512-1.c,
	  support/regression/tests/gcc-torture-execute-950612-1.c,
	  support/regression/tests/gcc-torture-execute-960402-1.c,
	  support/regression/tests/gcc-torture-execute-960801-1.c,
	  support/regression/tests/gcc-torture-execute-20000717-2.c,
	  support/regression/tests/gcc-torture-execute-20020402-3.c,
	  support/regression/tests/gcc-torture-execute-20050111-1.c,
	  support/regression/tests/gcc-torture-execute-950704-1.c:
	  Fix mcs51 peephole handling of long long parameters.
	* support/regression/tests/test-p99-conformance.c:
	  Disable test for older GCC, where it fails.

2016-08-25 Philipp Klaus Krause <pkk AT spth.de>

	* src/mcs51/gen.c,
	  support/regression/tests/gcc-torture-execute-20020508-?.c:
	  Fix long long right shift for mcs51.

2016-08-25 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/_strchr.c:
	  Explicitly cast away const to silence a warning.
	* support/regression/tests/gcc-torture-execute-20020508-?.c:
	  Disable some failing long long tests for mcs51.
	* src/mcs51/gen.c:
	  Fix pushing of long long received parameters for mcs51.

2016-08-24 Ben Shi <powerstudio1st AT 163 DOT com>

	* device/include/math.h
	* device/lib/Makefile.in
	* device/lib/incl.mk
	* device/lib/isinf.c
	* device/lib/isnan.c
	* device/lib/make51lib.bat
	  Support of new library functions isnan() and isinf().
	* src/SDCCval.c
	* device/lib/_fsdiv.c
	  Make float division more compitable with inf and nan results.
	* src/SDCCast.c
	* src/SDCCerr.c
	  Change zero-div from error to warning level.
	* support/regression/tests/bug-2516.c 
	  Add a new test case for inf and nan.

2016-08-23 Philipp Klaus Krause <pkk AT spth.de>

	* src/mcs51/gen.h,
	  src/mcs51/peep.c,
	  support/regression/tests/gcc-torture-execute-20000314-2.c,
	  support/regression/tests/gcc-torture-execute-pr42269-2.c,
	  support/regression/tests/gcc-torture-execute-20060110-2.c,
	  support/regression/tests/gcc-torture-execute-20001031-1.c,
	  support/regression/tests/gcc-torture-execute-20011126-1.c,
	  support/regression/tests/gcc-torture-execute-20020201-1.c,
	  support/regression/tests/gcc-torture-execute-20020219-1.c,
	  support/regression/tests/gcc-torture-execute-20020402-3.c,
	  support/regression/tests/gcc-torture-execute-20020506-1.c,
	  support/regression/tests/gcc-torture-execute-20020508-1.c,
	  support/regression/tests/gcc-torture-execute-20020508-2.c,
	  support/regression/tests/gcc-torture-execute-20020508-3.c,
	  support/regression/tests/gcc-torture-execute-20030307-1.c,
	  support/regression/tests/gcc-torture-execute-20050104-1.c,
	  support/regression/tests/gcc-torture-execute-20050111-1.c,
	  support/regression/tests/gcc-torture-execute-941015-1.c,
	  support/regression/tests/gcc-torture-execute-950503-1.c:
	  long long fix for deadMove() on ret.

2016-08-22 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCsymt.c,
	  src/mcs51/gen.c,
	  support/regression/tests/gcc-torture-execute-961122-1.c,
	  support/regression/tests/gcc-torture-execute-961206-1.c,
	  support/regression/tests/gcc-torture-execute-991016-1.c,
	  support/regression/tests/gcc-torture-execute-991216-1.c,
	  support/regression/tests/gcc-torture-execute-991216-2.c,
	  support/regression/tests/gcc-torture-execute-pr20187-1.c,
	  support/regression/tests/gcc-torture-execute-pr40057.c,
	  support/regression/tests/gcc-torture-execute-pr42269-2.c,
	  support/regression/tests/gcc-torture-execute-pr42544.c,
	  support/regression/tests/test-p99-conformance.c:
	  support/regression/tests/gcc-torture-execute-20000121-1.c,
	  support/regression/tests/gcc-torture-execute-20000314-2.c,
	  support/regression/tests/gcc-torture-execute-20000412-2.c,
	  support/regression/tests/gcc-torture-execute-20000523-1.c,
	  support/regression/tests/gcc-torture-execute-20000717-2.c,
	  support/regression/tests/gcc-torture-execute-20001112-1.c,
	  support/regression/tests/gcc-torture-execute-20001221-1.c,
	  support/regression/tests/gcc-torture-execute-20060110-2.c,
	  support/regression/tests/gcc-torture-execute-20060127-1.c,
	  support/regression/tests/gcc-torture-execute-20071213-1.c,
	  support/regression/tests/gcc-torture-execute-920829-1.c,
	  support/regression/tests/gcc-torture-execute-921029-1.c,
	  support/regression/tests/gcc-torture-execute-921202-2.c,
	  support/regression/tests/gcc-torture-execute-930111-1.c:
	  More long long support for mcs51.

2016-08-21 Philipp Klaus Krause <pkk AT spth.de>

	* src/mcs51/gen.c,
	  src/mcs51/gen.h,
	  src/mcs51/ralloc.c,
	  The basics of long long support for mcs51.

2016-08-20 Philipp Klaus Krause <pkk AT spth.de>

	* doc/sdccman.lyx:
	  Fix double underscores in manual.

2016-08-19 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/test-p99-conformance.c:
	  Enable a test for newer GCC, comment on other GCC issues.

2016-08-18 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCC.y,
	  src/SDCCerr.h,
	  src/SDCCerr.c,
	  doc/sdccman.lyx,
	  support/regression/tests/for.c,
	  test-p99-conformance.c:
	  RFE #165: C99 compliance: for (int i=0; ...

2016-08-17 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/test-p99-conformance.c:
	  Disable a subtest for host, since it fails on older GCC, disable a subtest for backends that don't have long long.

2016-08-14 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/test-p99-conformance.c,
	  support/regression/fwk/lib/extern1.c:
	  Enable inlining test for host.

2016-08-14 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/test-p99-conformance.c:
	  Document SDCC bug correspondance to P99 conformance tests.

2016-08-13 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/test-p99-conformance.c:
	  Some P99 conformance tests.

2016-08-12 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* sim/ucsim/sim.src/mem.cc: rewrote some of the memory cell classes
	  to work properly on big endian architectures

2016-08-10 Ben Shi <powerstudio1st AT 163 DOT com>

	* sim/ucsim/charscl.h
	  Fix the failure of building ucsim on MacOS.
	* support/regression/tests/gcc-torture-execute-string-opt-18.c
	* support/regression/tests/string.c
	  Disable several tests on MacOS.

2016-08-10 Philipp Klaus Krause <pkk AT spth.de>

	* device/include/string.h,
	  device/lib/tlcs90/Makefile.in,
	  device/lib/tlcs90/memmove.s:
	  pop af correctness for tlcs90.

2016-08-06 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* support/regression/get_ticks.py: parse the byte count more robustly
	  (buffering on stderr vs stdout sometimes jumbling text)

2016-08-05 Erik Petrich <epetrich AT ivorytower.normna.ok.us>

	* src/SDCCcse.c (ifxOptimize): fixed bug #2484
	* src/z80/gen.c (ld_cost): fixed bug #2399

2016-08-04 Erik Petrich <epetrich AT ivorytower.normna.ok.us>

	* src/SDCCast.c (decorateTree, optimizeCompare): fixed bug #2503
	  and an unreported bug similar to bug #2529
	* support/regression/tests/bug-2503: added test
	* src/SDCClospre.hpp (forward_lospre_assignment): fixed bug #2510

2016-08-03 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/SDCCcflow.c (eBBSuccessors),
	* src/SDCCloop.c (addPostLoopBlock): fixed bug #2453
	* support/regression/tests/bug-2453: added test

2016-08-03 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/tlcs90/setjmp.s,
	  device/lib/tlcs90/memmove.s:
	  Avoid messing up interrupt flags via pop af.

2016-08-02 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/_strstr.c:
	  Fix a warning.
	* src/SDCCmain.c:
	  Fix usage info, patch #274.
	* src/SDCCtree_dec.hpp:
	  Fix isolation of redundant nodes in the tree-decomposition.

2016-08-02 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/SDCCcse.c (cseBBlock): Recompute data flow if any outgoing
	  expressions have been changed (fixed bug #2495)
	* src/hc08/gen.c (genCopy),
	* src/hc08/ralloc.c (packPointerOp): fixed bug #2357
	* support/regression/tests/bug-2357.c: re-enabled test for hc08/s08

2016-08-01 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/stm8/gen.c (regFree): Y is not free when using extended stack

2016-07-31 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/hc08/gen.c (genMinus): mark A as modified for reverse subtraction
	* src/z80/gen.c (genPointerGet,genUnpackBits): preserve pointer
	  register pair if not dead

2016-07-30 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* sim/ucsim/fwio.cc: try defining WINVER instead of _WIN32_WINNT
	* sim/ucsim/cmd.src/Makefile.in,
	* sim/ucsim/gui.src/Makefile.in,
	* sim/ucsim/sim.src/Makefile.in,
	* sim/ucsim/main_in.mk: omit -D option to ar, not supported by all ar

2016-07-29 Maarten Brock <sourceforge.brock AT dse.nl>

	* SDCC.props: added ExecutablePath
	* src/ds390/gen.c,
	* src/SDCCutil.c,
	* src/SDCCval.c,
	* src/stm8/gen.c,
	* src/stm8/main.c,
	* src/z80/peep.c: fixed warnings

2016-07-29 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCicode.c:
	  Enable an optimization that was blocked on bug #2450.
	* src/SDCCtree_dec.hpp,
	  src/SDCCralloc.hpp:
	  Fix bug #2467 (fix previously was blocked on bug #2450).
	* src/z80/peeph-tlcs90.def:
	  Remove leftover z80 peepholes that break on tlcs90.

2016-07-29 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/SDCCast.c (processBlockVars): fix bug #2450
	* support/regression/tests/inline.c: add test for bug #2450
	* src/hc08/gen.c (aopForSym): remove work-around

2016-07-29 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/bug-2529.c
	  Regression test for bug #2517.

2016-07-29 Ben Shi <powerstudio1st AT 163 DOT com>

	* sim/ucsim/cmd.src/cmd_exec.cc
	* sim/ucsim/cmd.src/cmd_get.cc
	* sim/ucsim/cmd.src/command.cc
	* sim/ucsim/fuio.cc
	* sim/ucsim/s51.src/interrupt.cc
	* sim/ucsim/s51.src/uc51.cc
	* sim/ucsim/sim.src/mem.cc
	* sim/ucsim/stm8.src/itc.cc
	* sim/ucsim/utils.h
	  Fix build failures on cygwin.
	* src/SDCCicode.c
	* src/SDCCicode.h
	  Fix bug #2517.

2016-07-29 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* sim/ucsim/fwio.cc: added _WIN32_WINNT def for GetConsoleWindow()
	* sim/ucsim/fio.cc: handle case S_IRGRP and S_IROTH not defined
	* sim/ucsim/doc/Makefile.in: copy *.svg files instead of *.gif

2016-07-28 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/SDCCast.c (decorateType): fixed bug #2529

2016-07-27 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* device/lib/expf.c: ensure exponent not random before normalization

2016-07-27 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/bug-2385.c:
	  Disable a test for tlcs90, so all tests compile for tlcs90.

2016-07-26 Daniel Drotos <drdani AT mazsola.iit.uni-miskolc.hu>

	* sim/ucsim/.version, sim/ucsim/Makefile.in, sim/ucsim/NEWS,
	  sim/ucsim/README, sim/ucsim/TODO, sim/ucsim/app.cc,
	  sim/ucsim/appcl.h, sim/ucsim/avr.src/Makefile.in,
	  sim/ucsim/avr.src/avr.cc, sim/ucsim/avr.src/avrcl.h,
	  sim/ucsim/avr.src/savr.cc, sim/ucsim/c.sh, sim/ucsim/chars.cc,
	  sim/ucsim/charscl.h, sim/ucsim/cmd.src/Makefile.in,
	  sim/ucsim/cmd.src/bp.cc, sim/ucsim/cmd.src/bpcl.h,
	  sim/ucsim/cmd.src/cmd_bp.cc, sim/ucsim/cmd.src/cmd_bpcl.h,
	  sim/ucsim/cmd.src/cmd_conf.cc, sim/ucsim/cmd.src/cmd_confcl.h,
	  sim/ucsim/cmd.src/cmd_exec.cc, sim/ucsim/cmd.src/cmd_execcl.h,
	  sim/ucsim/cmd.src/cmd_get.cc, sim/ucsim/cmd.src/cmd_getcl.h,
	  sim/ucsim/cmd.src/cmd_gui.cc, sim/ucsim/cmd.src/cmd_guicl.h,
	  sim/ucsim/cmd.src/cmd_info.cc, sim/ucsim/cmd.src/cmd_infocl.h,
	  sim/ucsim/cmd.src/cmd_mem.cc, sim/ucsim/cmd.src/cmd_memcl.h,
	  sim/ucsim/cmd.src/cmd_set.cc, sim/ucsim/cmd.src/cmd_setcl.h,
	  sim/ucsim/cmd.src/cmd_show.cc, sim/ucsim/cmd.src/cmd_showcl.h,
	  sim/ucsim/cmd.src/cmd_stat.cc, sim/ucsim/cmd.src/cmd_statcl.h,
	  sim/ucsim/cmd.src/cmd_timer.cc, sim/ucsim/cmd.src/cmd_timercl.h,
	  sim/ucsim/cmd.src/cmd_uc.cc, sim/ucsim/cmd.src/cmd_uccl.h,
	  sim/ucsim/cmd.src/cmdconf.cc, sim/ucsim/cmd.src/cmdconfcl.h,
	  sim/ucsim/cmd.src/cmdgui.cc, sim/ucsim/cmd.src/cmdguicl.h,
	  sim/ucsim/cmd.src/cmdlex.l, sim/ucsim/cmd.src/cmdmem.cc,
	  sim/ucsim/cmd.src/cmdmemcl.h, sim/ucsim/cmd.src/cmdpars.y,
	  sim/ucsim/cmd.src/cmdset.cc, sim/ucsim/cmd.src/cmdsetcl.h,
	  sim/ucsim/cmd.src/cmdstat.cc, sim/ucsim/cmd.src/cmdstatcl.h,
	  sim/ucsim/cmd.src/cmduc.cc, sim/ucsim/cmd.src/cmduccl.h,
	  sim/ucsim/cmd.src/cmdutil.cc, sim/ucsim/cmd.src/cmdutil.h,
	  sim/ucsim/cmd.src/command.cc, sim/ucsim/cmd.src/commandcl.h,
	  sim/ucsim/cmd.src/get.cc, sim/ucsim/cmd.src/getcl.h,
	  sim/ucsim/cmd.src/info.cc, sim/ucsim/cmd.src/infocl.h,
	  sim/ucsim/cmd.src/newcmd.cc, sim/ucsim/cmd.src/newcmdcl.h,
	  sim/ucsim/cmd.src/newcmdposix.cc,
	  sim/ucsim/cmd.src/newcmdposixcl.h, sim/ucsim/cmd.src/set.cc,
	  sim/ucsim/cmd.src/setcl.h, sim/ucsim/cmd.src/show.cc,
	  sim/ucsim/cmd.src/showcl.h, sim/ucsim/cmd.src/timer.cc,
	  sim/ucsim/cmd.src/timercl.h, sim/ucsim/conf, sim/ucsim/configure,
	  sim/ucsim/configure.ac, sim/ucsim/ddconfig_in.h,
	  sim/ucsim/doc/Makefile.in, sim/ucsim/doc/analyzer.html,
	  sim/ucsim/doc/burst.gif, sim/ucsim/doc/chip.gif,
	  sim/ucsim/doc/chip.svg, sim/ucsim/doc/cmd.html,
	  sim/ucsim/doc/cmd.txt, sim/ucsim/doc/cmd_bp.html,
	  sim/ucsim/doc/cmd_dump.html, sim/ucsim/doc/cmd_exec.html,
	  sim/ucsim/doc/cmd_general.html, sim/ucsim/doc/cmd_memory.html,
	  sim/ucsim/doc/cmd_removed.html, sim/ucsim/doc/cmd_set.html,
	  sim/ucsim/doc/commref.html, sim/ucsim/doc/conf.mk,
	  sim/ucsim/doc/cpu-mem.gif, sim/ucsim/doc/cpu-mem.jpg,
	  sim/ucsim/doc/cpu-mem.svg, sim/ucsim/doc/cpu.gif,
	  sim/ucsim/doc/cpu.html, sim/ucsim/doc/cpu_types.html,
	  sim/ucsim/doc/decoded.gif, sim/ucsim/doc/decoded.jpg,
	  sim/ucsim/doc/decoded.svg, sim/ucsim/doc/index.html,
	  sim/ucsim/doc/interrupt.gif, sim/ucsim/doc/interrupt.html,
	  sim/ucsim/doc/invoke.html, sim/ucsim/doc/memory.html,
	  sim/ucsim/doc/mulcons.html, sim/ucsim/doc/new.gif,
	  sim/ucsim/doc/news.html, sim/ucsim/doc/obsolete.html,
	  sim/ucsim/doc/serial.html, sim/ucsim/doc/serial1.gif,
	  sim/ucsim/doc/serial1.svg, sim/ucsim/doc/serial2.gif,
	  sim/ucsim/doc/serial2.svg, sim/ucsim/doc/share-chip.gif,
	  sim/ucsim/doc/share-chip.svg, sim/ucsim/doc/simif.html,
	  sim/ucsim/doc/syntax.html, sim/ucsim/doc/term_cpuopt.gif,
	  sim/ucsim/doc/term_cpuopt.html, sim/ucsim/doc/timers.gif,
	  sim/ucsim/doc/timers.html, sim/ucsim/doc/uCsim.txt,
	  sim/ucsim/doc/wins.gif, sim/ucsim/doc/wins.html,
	  sim/ucsim/error.cc, sim/ucsim/errorcl.h, sim/ucsim/eventcl.h,
	  sim/ucsim/example, sim/ucsim/example/Makefile,
	  sim/ucsim/example/config.cmd, sim/ucsim/example/run.cmd,
	  sim/ucsim/example/simif.c, sim/ucsim/example/simif.sh,
	  sim/ucsim/example/simif_fin.txt, sim/ucsim/fio.cc,
	  sim/ucsim/fiocl.h, sim/ucsim/ftest.cc, sim/ucsim/fuio.cc,
	  sim/ucsim/fuiocl.h, sim/ucsim/fwio.cc, sim/ucsim/fwiocl.h,
	  sim/ucsim/globals.cc, sim/ucsim/gstring.cc, sim/ucsim/gstring.h,
	  sim/ucsim/gstring_LICENSE, sim/ucsim/gstring_REAME,
	  sim/ucsim/gstring_append.cc, sim/ucsim/gstring_basic.cc,
	  sim/ucsim/gstring_copyright.html, sim/ucsim/gstring_explode.cc,
	  sim/ucsim/gui.src/Makefile.in, sim/ucsim/hc08.src/Makefile.in,
	  sim/ucsim/hc08.src/hc08.cc, sim/ucsim/hc08.src/hc08cl.h,
	  sim/ucsim/hc08.src/hc08mac.h, sim/ucsim/hc08.src/regshc08.h,
	  sim/ucsim/hc08.src/shc08.cc, sim/ucsim/hc08.src/simhc08.cc,
	  sim/ucsim/main_in.mk, sim/ucsim/option.cc, sim/ucsim/optioncl.h,
	  sim/ucsim/p.sh, sim/ucsim/packages_in.mk, sim/ucsim/pobj.cc,
	  sim/ucsim/pobjcl.h, sim/ucsim/pobjt.h, sim/ucsim/put(c),
	  sim/ucsim/s51.src/Makefile.in, sim/ucsim/s51.src/arith.cc,
	  sim/ucsim/s51.src/bit.cc, sim/ucsim/s51.src/inc.cc,
	  sim/ucsim/s51.src/interrupt.cc, sim/ucsim/s51.src/interruptcl.h,
	  sim/ucsim/s51.src/jmp.cc, sim/ucsim/s51.src/logic.cc,
	  sim/ucsim/s51.src/mov.cc, sim/ucsim/s51.src/pca.cc,
	  sim/ucsim/s51.src/pcacl.h, sim/ucsim/s51.src/port.cc,
	  sim/ucsim/s51.src/portcl.h, sim/ucsim/s51.src/s51.cc,
	  sim/ucsim/s51.src/serial.cc, sim/ucsim/s51.src/serialcl.h,
	  sim/ucsim/s51.src/sim51.cc, sim/ucsim/s51.src/timer0.cc,
	  sim/ucsim/s51.src/timer0cl.h, sim/ucsim/s51.src/timer1.cc,
	  sim/ucsim/s51.src/timer2.cc, sim/ucsim/s51.src/timer2cl.h,
	  sim/ucsim/s51.src/types51.h, sim/ucsim/s51.src/uc251.cc,
	  sim/ucsim/s51.src/uc390.cc, sim/ucsim/s51.src/uc390cl.h,
	  sim/ucsim/s51.src/uc390hw.cc, sim/ucsim/s51.src/uc51.cc,
	  sim/ucsim/s51.src/uc51cl.h, sim/ucsim/s51.src/uc51r.cc,
	  sim/ucsim/s51.src/uc52.cc, sim/ucsim/s51.src/uc89c51r.cc,
	  sim/ucsim/s51.src/uc89c51rcl.h, sim/ucsim/s51.src/wdt.cc,
	  sim/ucsim/sim.src/Makefile.in, sim/ucsim/sim.src/arg.cc,
	  sim/ucsim/sim.src/argcl.h, sim/ucsim/sim.src/brk.cc,
	  sim/ucsim/sim.src/brkcl.h, sim/ucsim/sim.src/hw.cc,
	  sim/ucsim/sim.src/hwcl.h, sim/ucsim/sim.src/itsrc.cc,
	  sim/ucsim/sim.src/itsrccl.h, sim/ucsim/sim.src/mem.cc,
	  sim/ucsim/sim.src/memcl.h, sim/ucsim/sim.src/obsolete.cc,
	  sim/ucsim/sim.src/obsolete.h, sim/ucsim/sim.src/sim.cc,
	  sim/ucsim/sim.src/simcl.h, sim/ucsim/sim.src/simif.cc,
	  sim/ucsim/sim.src/simifcl.h, sim/ucsim/sim.src/stack.cc,
	  sim/ucsim/sim.src/stackcl.h, sim/ucsim/sim.src/test_mem_speed.cc,
	  sim/ucsim/sim.src/uc.cc, sim/ucsim/sim.src/uccl.h,
	  sim/ucsim/sim.src/var.cc, sim/ucsim/sim.src/varcl.h,
	  sim/ucsim/st7.src/Makefile.in, sim/ucsim/st7.src/glob.cc,
	  sim/ucsim/st7.src/regsst7.h, sim/ucsim/st7.src/sst7.cc,
	  sim/ucsim/st7.src/st7.cc, sim/ucsim/st7.src/st7cl.h,
	  sim/ucsim/stm8.src/Makefile.in, sim/ucsim/stm8.src/glob.cc,
	  sim/ucsim/stm8.src/glob.h, sim/ucsim/stm8.src/inst.cc,
	  sim/ucsim/stm8.src/instcl.h, sim/ucsim/stm8.src/itc.cc,
	  sim/ucsim/stm8.src/itccl.h, sim/ucsim/stm8.src/regsstm8.h,
	  sim/ucsim/stm8.src/rst.cc, sim/ucsim/stm8.src/rstcl.h,
	  sim/ucsim/stm8.src/serial.cc, sim/ucsim/stm8.src/serialcl.h,
	  sim/ucsim/stm8.src/simstm8.cc, sim/ucsim/stm8.src/simstm8cl.h,
	  sim/ucsim/stm8.src/sstm8.cc, sim/ucsim/stm8.src/stm8.cc,
	  sim/ucsim/stm8.src/stm8cl.h, sim/ucsim/stm8.src/stm8mac.h,
	  sim/ucsim/stm8.src/test, sim/ucsim/stm8.src/test/Makefile,
	  sim/ucsim/stm8.src/test/conf.cmd, sim/ucsim/stm8.src/test/s0.c,
	  sim/ucsim/stm8.src/test/s1.c, sim/ucsim/stm8.src/test/s1.mk,
	  sim/ucsim/stm8.src/test/s2.c, sim/ucsim/stm8.src/test/s2.mk,
	  sim/ucsim/stm8.src/test/s3.c, sim/ucsim/stm8.src/test/s3.mk,
	  sim/ucsim/stm8.src/test/sdcc.mk, sim/ucsim/stm8.src/test/stm8.h,
	  sim/ucsim/stm8.src/test/t1.c, sim/ucsim/stm8.src/test/t1.mk,
	  sim/ucsim/stm8.src/test/t2.c, sim/ucsim/stm8.src/test/t2.mk,
	  sim/ucsim/stm8.src/test/t3.c, sim/ucsim/stm8.src/test/t3.mk,
	  sim/ucsim/stm8.src/test/t4.c, sim/ucsim/stm8.src/test/t4.mk,
	  sim/ucsim/stm8.src/timer.cc, sim/ucsim/stm8.src/timercl.h,
	  sim/ucsim/stypes.h, sim/ucsim/tlcs.src, sim/ucsim/tlcs.src/(c).1,
	  sim/ucsim/tlcs.src/Makefile.in, sim/ucsim/tlcs.src/clean.mk,
	  sim/ucsim/tlcs.src/conf.mk, sim/ucsim/tlcs.src/glob.cc,
	  sim/ucsim/tlcs.src/glob.h, sim/ucsim/tlcs.src/inst_arith.cc,
	  sim/ucsim/tlcs.src/inst_bit.cc, sim/ucsim/tlcs.src/inst_block.cc,
	  sim/ucsim/tlcs.src/inst_cpu_others.cc,
	  sim/ucsim/tlcs.src/inst_jump.cc, sim/ucsim/tlcs.src/inst_move.cc,
	  sim/ucsim/tlcs.src/inst_rot_sh.cc,
	  sim/ucsim/tlcs.src/mulibyte_instructions.txt,
	  sim/ucsim/tlcs.src/regression.txt, sim/ucsim/tlcs.src/simtlcs.cc,
	  sim/ucsim/tlcs.src/simtlcscl.h, sim/ucsim/tlcs.src/stlcs.cc,
	  sim/ucsim/tlcs.src/test, sim/ucsim/tlcs.src/test/Makefile,
	  sim/ucsim/tlcs.src/test/b2385.c,
	  sim/ucsim/tlcs.src/test/b2385.mk, sim/ucsim/tlcs.src/test/c,
	  sim/ucsim/tlcs.src/test/conf.cmd,
	  sim/ucsim/tlcs.src/test/dummy.h, sim/ucsim/tlcs.src/test/run.cmd,
	  sim/ucsim/tlcs.src/test/run.sh, sim/ucsim/tlcs.src/test/sdcc.mk,
	  sim/ucsim/tlcs.src/test/t0.c, sim/ucsim/tlcs.src/test/t0.mk,
	  sim/ucsim/tlcs.src/test/t1.c, sim/ucsim/tlcs.src/test/t1.mk,
	  sim/ucsim/tlcs.src/test/t2.c, sim/ucsim/tlcs.src/test/t2.mk,
	  sim/ucsim/tlcs.src/test/t3.c, sim/ucsim/tlcs.src/test/t3.mk,
	  sim/ucsim/tlcs.src/tlcs.cc, sim/ucsim/tlcs.src/tlcscl.h,
	  sim/ucsim/ucsim.cc, sim/ucsim/utils.cc, sim/ucsim/utils.h,
	  sim/ucsim/xa.src/Makefile.in, sim/ucsim/xa.src/glob.cc,
	  sim/ucsim/xa.src/glob.h, sim/ucsim/xa.src/regsxa.h,
	  sim/ucsim/xa.src/sxa.cc, sim/ucsim/xa.src/xa.cc,
	  sim/ucsim/xa.src/xacl.h, sim/ucsim/z80.src/Makefile.in,
	  sim/ucsim/z80.src/inst_r2k.cc, sim/ucsim/z80.src/lr35902.cc,
	  sim/ucsim/z80.src/lr35902cl.h, sim/ucsim/z80.src/r2k.cc,
	  sim/ucsim/z80.src/r2kcl.h, sim/ucsim/z80.src/regsz80.h,
	  sim/ucsim/z80.src/sz80.cc, sim/ucsim/z80.src/test,
	  sim/ucsim/z80.src/test/Makefile, sim/ucsim/z80.src/test/c,
	  sim/ucsim/z80.src/test/conf.cmd, sim/ucsim/z80.src/test/dummy.h,
	  sim/ucsim/z80.src/test/run.cmd, sim/ucsim/z80.src/test/run.sh,
	  sim/ucsim/z80.src/test/sdcc.mk, sim/ucsim/z80.src/test/t0.c,
	  sim/ucsim/z80.src/test/t0.mk, sim/ucsim/z80.src/test/t1.c,
	  sim/ucsim/z80.src/test/t1.mk, sim/ucsim/z80.src/test/t2.c,
	  sim/ucsim/z80.src/test/t2.mk, sim/ucsim/z80.src/z80.cc,
	  sim/ucsim/z80.src/z80cl.h, sim/ucsim/z80.src/z80mac.h: ucsim
	  version 0.6-pre4

2016-07-25 Daniel Drotos <drdani AT mazsola.iit.uni-miskolc.hu>

	* device/lib/tlcs90/crt0.s,
	  device/lib/tlcs90/crt0_org.s: dirty
	  hacked crt0 so compiled simple programs will run at least

2016-07-25 Daniel Drotos <drdani AT mazsola.iit.uni-miskolc.hu>

	* support/regression/Makefile.in,
	  support/regression/fwk/include/testfwk.h,
	  support/regression/ports/tlcs90,
	  support/regression/ports/tlcs90/spec.mk,
	  support/regression/ports/tlcs90/support.c,
	  support/regression/ports/tlcs90/uCsim.cmd,
	  support/regression/tests/bug-2305.c,
	  support/regression/tests/bug3379723.c: regression test prepared
	  for tlcs90

2016-07-25 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/SDCCmem.c (printAllocInfoSeg),
	* src/port.h,
	* src/avr/main.c,
	* src/ds390/main.c,
	* src/hc08/main.c,
	* src/mcs51/main.c,
	* src/pic14/main.c,
	* src/pic16/main.c,
	* src/stm8/main.c,
	* src/xa51/main.c,
	* src/z80/main.c: Display correct stack offsets when stack grows down

2016-07-24 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/SDCCopt.c (optimizeOpWidth): don't narrow types cast to bit/sbit either

2016-07-23 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCval.h,
	  src/SDCCval.c,
	  src/stm8/main.c,
	  src/stm8/gen.c:
	  Generate code for 16 bit multiplication by literal based on CSD representation.

2016-07-23 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCsymt.h,
	  src/SDCCsymt.c,
	  src/SDCCopt.c,
	  device/lib/stm8/__mulsint2slong.s:
	  support/regression/tests/muldiv.c:
	  Support routine for unsigned 16x16->32 multiplication.

2016-07-23 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/stm8/memcpy.s:
	  Fix issue in loop counter in stm8 memcpy().
	* src/port.h,
	  src/SDCCsymt.c,
	  src/*/main.c:
	  Introduce backend option for 16x16->32 multiplication.
	* support/regression/tests/muldiv.c:
	  Prepare test for unsigned 16x16->32 multiplication.

2016-07-23 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/lib/_strchr.c,
	* device/lib/_strrchr.c,
	* device/lib/_strstr.c: reverted commit 9631, these files should not
	  generate warning 196
	* sdas/asstm8/stm8mch.c: fixed incw cycle count

2016-07-22 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/stm8/memcpy.s,
	  support/regression/tests/memory.c:
	  Fix an issue in stm8 unrolled memcpy().
	* device/lib/stm8/__mulsint2slong.s:
	  Optimize multiplication routine for small operands.
	* src/SDCCopt.c:
	  Optimize multiplication with anded operands.

2016-07-21 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/stm8/Makefile.in,
	  device/lib/stm8/__mulsint2slong.s,
	  src/SDCCcse.c,
	  src/SDCCopt.c,
	  src/SDCCsymt.c,
	  src/SDCCsymt.h,
	  support/regression/tests/muldiv.c,
	  Support for separate 16x16->32 multiplication routine, RFE #507.

2016-07-21 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCopt.c:
	  Narrow arithmetic operations when results are cast to narrower type: RFE #506.

2016-07-21 Ben Shi <powerstudio1st AT 163 DOT com>

	* sdas/astlcs90/t90mch.c
	  Fix a potential defect.

2016-07-20 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/stm8/Makefile.in,
	  device/lib/stm8/strcpy.s:
	  Partially unrolled, slightly faster strcpy() for stm8.
	* src/stm8/gen.c,
	  src/SDCCsymt.c:
	  More efficient handling of boolean values.
	* device/lib/r2k/Makefile.in:
	  Fix bug #2526.
	* src/stm8/main.c:
	  Remove unused vars.

2016-07-18 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Slight improvement in code generation.

2016-07-17 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/main.c,
	  src/stm8/gen.c:
	  Special case for int multiplication by 7 and 100.

2016-07-16 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/stm8/memcpy.s:
	  Improve stm8 memcpy().
	* support/regression/tests/memory.c:
	  Better memcpy() test coverage.

2016-07-15 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/stm8/memcpy.s:
	  Improve stm8 memcpy().

2016-07-14 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/stm8/memcpy.s:
	  Partially unroll stm8 memcpy() for speed.
	* device/lib/stm8/strcmp.s:
	  Partially unroll stm8 strcmp() for speed.

2016-07-11 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/main.c,
	  src/z80/gen.c:
	  Fix bug #2522.
	* device/lib/stm8/memcpy.s,
	  device/lib/stm8/strcmp.s,
	  device/lib/*/Makefile.in,
	  device/lib/Makefile.in,
	  device/lib/incl.mk:
	  Provide handwritten memcpy(), strcmp() to improve stm8 Dhrystone scores.
	* sdas/astlcs90/t90mch.c:
	  Fix TLCS-90 assembler relocation issue for ld, reopened bug #2520.
	* src/stm8/peeph.def:
	  Some peepholes to remove redundant stm8 loads, to improve stm8 DMIPS by another 0.42%

2016-07-10 Philipp Klaus Krause <pkk AT spth.de>

	* sdas/astlcs90/t90mch.c:
	  Fix TLCS-90 assembler relocation issue for adc, bug #2520.

2016-07-06 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/gcc-torture-execute-920612-1.c
	  Disabled in test-host with gcc-6.

2016-06-30 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCicode.c
	  Check pointer qualifier in geniCodeReturn().
	* device/lib/_strstr.c
	* device/lib/_strchr.c
	* device/lib/_strrchr.c
	* support/regression/tests/gcc-torture-execute-920429-1.c
	  Suppress warning 196.

2016-06-26 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/ds390/gen.c
	  Fix a bug in genCmp().
	* support/regression/tests/dhrystone.c
	  Enabled for ds390.

2016-06-21 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCicode.c:
	  Fix bug #1841.
	* device/include/stdbool.h:
	  Minor cleanup.

2016-06-19 Philipp Klaus Krause <pkk AT spth.de>

	* doc/sdccman.lyx,
	  src/SDCCglobl.h,
	  src/SDCCmain.c,
	  src/SDCCsymt.c:
	  Remove obsolete SDCC macro, --short-is-8-bits option.

2016-06-18 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/mcs51/gen.c
	  Fix a bug in jump table of switch/case when --acall-ajmp is specified.
	* src/mcs51/peeph.def
	  Remove empty lines.

2016-06-18 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/ports/mcs51-huge/spec.mk
	* support/regression/ports/mcs51-xstack-auto/spec.mk
	  Make "make" more compatible.

2016-06-17 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/ports/ucr2k/support.asm:
	  Fix regression test putchar() for r2k.

2016-06-16 Philipp Klaus Krause <pkk AT spth.de>

	* device/include/stdio.h,
	  device/lib/ds390/putchar.c,
	  device/lib/puts.c,
	  support/regression/tests/bug1115321.c,
	  support/regression/tests/dhrystone.c:
	  Make putchar() prototype standard-compliant, fix bug #2505.

2016-06-16 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/*/Makefile.in,
	  device/lib/*/putchar.s,
	  support/regression/ports/*/support.asm,
	  support/regression/tests/dhrystone.c:
	  Remove z80 putchar() from library.

2016-06-15 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/dhrystone.c:
	  Introduce a regression test based on the Dhrystone benchmark.

2016-06-13 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/stm8/gen.c
	  Fix a bug in emitCall().

2016-06-12 Maarten Brock <sourceforge.brock AT dse.nl>

	* Small Device C Compiler 3.6.0 released
	* .version, doc/sdccman.lyx: changed sdcc version to 3.6.1

2016-06-04 Maarten Brock <sourceforge.brock AT dse.nl>

	* .version,
	* doc/INSTALL.txt,
	* doc/sdccman.lyx:  version 3.6.0

2016-06-03 Philipp Klaus Krause <pkk AT spth.de>

	* src/hc08/gen.c:
	  Work around an allocation issue.

2016-05-29 Maarten Brock <sourceforge.brock AT dse.nl>

	* .version,
	* doc/INSTALL.txt,
	* doc/sdccman.lyx: version 3.6.0 rc1, use coloured links
	* sdcc.spec: version 3.6.0
	* doc/Makefile.in: silence makeindex
	* sim/ucsim/cmd.src/cmdset.cc,
	* sim/ucsim/hc08.src/hc08cl.h,
	* sim/ucsim/sim.src/hw.cc,
	* sim/ucsim/sim.src/hwcl.h,
	* sim/ucsim/st7.src/st7cl.h,
	* sim/ucsim/stm8.src/stm8cl.h,
	* sim/ucsim/z80.src/z80cl.h: cosmetics
	* sim/ucsim/st7.src/st7.cc (cl_st7::disass): fixed get_disasm_info call

2016-05-25 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Implement genAddrOf for both X and Y in use (to make all regression tests compile for low --max-allocs-per-node).

2016-05-21 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/hc08/ralloc.c: fixed bug #2489
	* support/regression/tests/wchar.c: re-enable hc08/s08 tests

2016-05-17 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/peep.c:
	  Basic flag handling in notUsed(), more accurate notUsed().
	* src/stm8/peeph.def:
	  Enable dead load optimization (with fixed flag handling).

2016-05-17 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCpeeph.c:
	  Improve labelIsReturnOnly() accuracy.
	* src/stm8/peeph.def:
	  Disable dead load optimization, introduce jump-to-return optimization.

2016-05-16 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/peeph.def:
	  Use more jumps on false for stm8 peepholes.
	* src/stm8/gen.c:
	  More efficient comparisons.

2016-05-15 Philipp Klaus Krause <pkk AT spth.de>

	* Makefile.in:
	  Fix distclean failures.

2016-05-14 Maarten Brock <sourceforge.brock AT dse.nl>

	* support/sdbinutils/binutils/arlex.c,
	* support/sdbinutils/binutils/arparse.c,
	* support/sdbinutils/binutils/arparse.h,
	* support/sdbinutils/binutils/defparse.c,
	* support/sdbinutils/binutils/defparse.h,
	* support/sdbinutils/binutils/mcparse.c,
	* support/sdbinutils/binutils/mcparse.h,
	* support/sdbinutils/binutils/rcparse.c,
	* support/sdbinutils/binutils/rcparse.h,
	* support/sdbinutils/binutils/sysinfo.c,
	* support/sdbinutils/binutils/sysinfo.h,
	* support/sdbinutils/binutils/syslex.c: added, as in upstream git

2016-05-13 Philipp Klaus Krause <pkk AT spth.de>

	* sdas/linksrc/lkelf.c:
	  Enable ELF symbol table output, (from patch #255 by Peter Dons Tychsen).

2016-05-12 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Minor code cleanup, also gets rid of a GCC warning.

2016-05-10 Ben Shi <powerstudio1st AT 163 DOT com>

	* configure
	* configure.ac
	* src/SDCCmain.c
	  Call setrlimit() in a more compatible way.

2016-05-07 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/lib/hc08/_setjmp.c,
	* device/lib/s08/_setjmp.c: svn eol-style native
	* support/regression/tests/gcc-torture-execute-pr28982a.c,
	* support/regression/tests/bug-2197.c: enabled for mcs51
	* src/mcs51/gen.c (genFunction, genEndFunction): implemented RFE 81 to
	  disable interrupts before stacking
	* sim/ucsim/s51.src/uc390.cc: use IDMx/MCON instead of SA/ACON
	* sim/ucsim/s51.src/uc390hw.cc: do not lock out all IDM settings
	* src/ds390/main.c (_ds390_genIVT): MCON requires Timed Access

2016-05-06 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/compact-results.py
	  Roll back to previous version.

2016-05-05 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/include/setjmp.h: ds390 needs 5 bytes
	* device/lib/_setjmp.c: added ds390 version
	* device/lib/ds390/setjmp.c: updated, but still a dummy
	* device/lib/hc08/_setjmp.c,
	* device/lib/s08/_setjmp.c: fixed stack pointer bug
	* sim/ucsim/cmd.src/Makefile.in,
	* sim/ucsim/gui.src/Makefile.in,
	* sim/ucsim/main_in.mk,
	* sim/ucsim/sim.src/Makefile.in: drop -u to prevent warning on ar 2.26
	* sim/ucsim/s51.src/uc390cl.h: added ixram
	* sim/ucsim/s51.src/uc390.cc: check full ixram range,
	* sim/ucsim/s51.src/uc51.cc,
	* sim/ucsim/s51.src/uc89c51r.cc: show @R0, @R1 and 8 stack bytes
	* sim/ucsim/sim.src/mem.cc (cl_memory::dump): allow decrementing range
	* sim/ucsim/stm8.src/inst.cc (cl_stm8::flag_cvh): fixed warnings
	* src/SDCC.y: critical is not a part of the calling convention
	* support/regression/tests/bug663539.c: fix to fool the python script
	* support/regression/tests/gcc-torture-execute-20010409-1.c: use longjmp()
	  instead of return() to mimic exit()
	* support/regression/tests/setjmp.c: enabled for all regular targets

2016-05-05 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/compact-results.py
	  Fix spots in previous commit.

2016-05-04 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/collate-results.py
	* support/regression/compact-results.py
	  Detect and report aborted test cases.

2016-05-03 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/collate-results.py
	* support/regression/compact-results.py
	* support/regression/Makefile.in
	  Detect and report 'segment fault' in test-host.
	* support/regression/tests/gcc-torture-execute-20010409-1.c
	  Disable for gcc-5 in test-host.

2016-05-01 Ben Shi <powerstudio1st AT 163 DOT com>

	* Enlarge stack size to 4MB in run time.

2016-04-30 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCasm.c:
	  Hex number case consistency, RFE #142.

2016-04-29 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c,
	  doc/sdccman.lyx,
	  .version:
	  Reorganize interrupt handling for z80-related backends, fix bugs #2339, #2131.

2016-04-29 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCC.y
	* src/SDCCerr.c
	* src/SDCCerr.h
	  Make the warning in previous commit more generic.

2016-04-28 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCC.y
	* src/SDCCerr.c
	* src/SDCCerr.h
	  Add warning for inlined _z88dk_* functions.

2016-04-28 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCC.y
	* src/SDCCerr.c
	  Allow typedef function types.
	* support/regression/tests/bug-2497.c
	  Add a new test case.

2016-04-27 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/ds390/gen.c (genFarPointerSet): no inline variable definitions
	* src/ds390/main.c (_ds390_genAssemblerPreamble, _ds390_genIVT): add MCON,
	  (_ds390_genXINIT): added _ds390_genXRAMCLEAR

2016-04-25 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCC.y
	* src/SDCCsymt.c
	* src/SDCCsymt.h
	  Check local defined structs more strictly.

2016-04-24 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCast.c
	  Change the signess of the literal operand in bitwise operation.
	* support/regression/tests/bug-1929.c
	  Add a new test case.
	* support/regression/tests/gcc-torture-execute-20020506-1.c
	  Modify test case.

2016-04-21 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/sdbinutils/bfd/doc/Makefile.am,
	  support/sdbinutils/bfd/doc/Makefile.in,
	  support/sdbinutils/binutils/Makefile.am,
	  support/sdbinutils/binutils/Makefile.in:
	  Revert changes of wrong bugfix.

2016-04-20 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/z80/peeph-r2k.def
	* src/z80/peeph-tlcs90.def
	* src/z80/peeph-z80.def
	  Fix potential bugs.

2016-04-19 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/sdbinutils/bfd/doc/Makefile.am,
	  support/sdbinutils/bfd/doc/Makefile.in,
	  support/sdbinutils/binutils/Makefile.am,
	  support/sdbinutils/binutils/Makefile.in:
	  Fix a distclean bug. Now the "make distclean" command deletes
	  these unnecessary files:
	    support/sdbinutils/bfd/doc/bfd.info*
	    support/sdbinutils/binutils/arlex.c
	    support/sdbinutils/binutils/arparse.c
	    support/sdbinutils/binutils/arparse.h
	    support/sdbinutils/binutils/defparse.c
	    support/sdbinutils/binutils/defparse.h
	    support/sdbinutils/binutils/mcparse.c
	    support/sdbinutils/binutils/mcparse.h
	    support/sdbinutils/binutils/rcparse.c
	    support/sdbinutils/binutils/rcparse.h
	    support/sdbinutils/binutils/sysinfo.c
	    support/sdbinutils/binutils/sysinfo.h
	    support/sdbinutils/binutils/syslex.c

2016-04-18 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/include/setjmp.h: use C89 compatible comments
	* device/lib/ds390/setjmp.c: preliminary setjmp/longjmp implementation
	* device/lib/gbz80/Makefile.in,
	* device/lib/gbz80/setjmp.s,
	* device/lib/hc08/Makefile.in
	* device/lib/hc08/_setjmp.c
	* device/lib/s08/Makefile.in
	* device/lib/s08/_setjmp.c: implemented setjmp/longjmp for gbz80, hc08, s08
	* support/regression/tests/setjmp.c: enabled for all but ds390
	* device/lib/hc08/_divuint.c,
	* device/lib/s08/_divuint.c: removed mcs51 asm
	* device/lib/pic16/libc/stdlib/atof.c,
	* device/lib/pic16/libc/stdlib/x_ftoa.c: fixed since char is now unsigned
	* src/SDCCval.c (reorderIlist): properly fixed bug #2423
	* src/z80/peeph-gbz80.def: added rule 2
	* support/regression/tests/bug-2423.c: remove disabled pragma
	* support/regression/tests/float_single.c: enabled EXPF as it seems to pass

2016-04-18 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c:
	  Fix handling of register pair hl in block copy pointer assignment.

2016-04-18 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/peeph-z80.def:
	  Optimize jumps on boolean bitfields.
	* src/z80/gen.c:
	  Improve unpacking of signed bitfields.

2016-04-18 Molnar Karoly <molnarkaroly AT users.sf.net>

	* device/lib/pic14/bootstrap.sh,
	  device/lib/pic16/bootstrap.sh,
	  device/non-free/lib/pic16/bootstrap.sh:
	  Deleted the execute rights, to prevent accidental execution.

2016-04-17 Molnar Karoly <molnarkaroly AT users.sf.net>

	* device/lib/pic14/configure,
	  device/lib/pic14/configure.ac,
	  device/lib/pic14/Makefile.am,
	  device/lib/pic14/Makefile.in,
	  device/lib/pic16/Makefile.am,
	  device/lib/pic16/Makefile.in,
	  device/non-free/lib/pic14/Makefile.in,
	  device/non-free/lib/pic16/Makefile.am,
	  device/non-free/lib/pic16/Makefile.in:
	  Renamed the "device/lib/pic14/.checksupport" directory to
	  "device/lib/pic14/.checkdevices".
	  Fix a distclean bug. Now the "make distclean" command deletes
	  these unnecessary directories and files:
	    device/lib/pic14/.checkdevices/*
	    device/lib/pic14/a.*
	    device/lib/pic16/.checkdevices/*
	    device/lib/pic16/a.*
	    device/lib/pic16/pics.supported
	    device/non-free/lib/pic14/.checkdevices/*
	    device/non-free/lib/pic14/a.*
	    device/non-free/lib/pic14/pics.supported
	    device/non-free/lib/pic16/.checkdevices/*
	    device/non-free/lib/pic16/a.*
	    device/non-free/lib/pic16/pics.supported

2016-04-17 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/wchar.c:
	  Enable test for mcs51.
	* doc/sdccman.lyx:
	  Update manual, clearly mark 8051-specifics as such in Chapter 3.

2016-04-17 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCglue.c
	  Fix a pointer printing bug, when a 4-byte generic pointer is printed on ds390.

2016-04-16 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/include/mcs51/compiler.h: added INTERRUPT, INTERRUPT_USING, NOP
	  macros, copied from SiLabs' compiler_defs.h
	* device/include/mcs51/EFM8BB1.h: new, added, from RFE 271, thanks
	  Kharitonov Dmitry

2016-04-14 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c,
	  support/regression/tests/gcc-torture-execute-20000717-2.c,
	  support/regression/tests/gcc-torture-execute-20050104-1.c,
	  support/regression/tests/gcc-torture-execute-921202-2.c,
	  support/regression/tests/gcc-torture-execute-950612-1.c,
	  support/regression/tests/gcc-torture-execute-961122-1.c,
	  support/regression/tests/gcc-torture-execute-20060110-2.c,
	  support/regression/tests/gcc-torture-execute-950704-1.c,
	  support/regression/tests/longlong.c:
	  Fixes to gbz80 carry flag handling, particularly relevant to long long.

2016-04-14 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCerr.c
	* src/SDCCerr.h
	* src/SDCCsymt.c
	  Check tagged anonymous struct/union.

2016-04-13 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c,
	  support/regression/tests/bug-2492.c:
	  Fix bug #2492.

2016-04-13 Molnar Karoly <molnarkaroly AT users.sf.net>

	* device/include/pic14/pic14devices.txt,
	  device/non-free/include/pic14/*.h,
	  device/non-free/include/pic16/*.h,
	  device/non-free/lib/pic14/libdev/*.c,
	  device/non-free/lib/pic16/libdev/*.c:
	  Refreshed the device files.

2016-04-12 Philipp Klaus Krause <pkk AT spth.de>

	* device/include/uchar.h,
	  device/include/wchar.h,
	  device/lib/c16rtomb.c,
	  device/lib/mbrtoc16.c,
	  device/lib/mbsinit.c,
	  device/lib/incl.mk,
	  support/regression/tests/wchar.c:
	  Implement c16rtomb(), mbrtoc16(), mbsinit().
	* device/lib/*/mul.s
	  Integer multiplication improvement by Kio (RFE #422).

2016-04-12 Molnar Karoly <molnarkaroly AT users.sf.net>

	* device/lib/pic14/configure.ac,
	  device/lib/pic14/Makefile.in,
	  device/lib/pic14/libm/Makefile.in,
	  device/lib/pic14/libsdcc/enhanced/Makefile.in,
	  device/lib/pic14/libsdcc/enhanced-no-xinst/Makefile.in,
	  device/lib/pic14/libsdcc/regular/Makefile.in:
	  Fixed bug: #2482 Link error with pic16f1827

2016-04-11 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c:
	  Enable iy register content tracking optimization.
	* device/include/stdlib.h,
	  device/lib/mbtowc.c,
	  device/lib/incl.mk,
	  support/regression/tests/wchar.c:
	  Implement mbtowc().
	* device/include/wchar.h,
	  device/lib/mbrlen.c:
	  Implement mbrlen().

2016-04-10 Molnar Karoly <molnarkaroly AT users.sf.net>

	* src/pic14/gen.c,
	  src/pic16/gen.c:
	  Fixed typo from "psuedo" to "pseudo".

	* src/pic14/gen.c:
	  Fixed bug in genCall() function: The PAGESEL instructions must
	  be given unconditionally. (In this context: "Each function has
	  its own code section.")

	* src/pic14/pcode.c,
	  src/pic16/pcode.c,
	  src/pic14/ralloc.c,
	  src/pic16/ralloc.c:
	  Fix potential buffer overflow.

	* src/pic14/glue.c:
	  Minor code formatting.

2016-04-09 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/gcc-torture-execute-20020506-1.c
	* support/regression/tests/gcc-torture-execute-20041011-1.c
	* support/regression/tests/gcc-torture-execute-20050111-1.c
	* support/regression/tests/gcc-torture-execute-20060127-1.c
	* support/regression/tests/gcc-torture-execute-920604-1.c
	* support/regression/tests/gcc-torture-execute-921029-1.c
	* support/regression/tests/gcc-torture-execute-941015-1.c
	  Enabled.

2016-04-07 Philipp Klaus Krause <pkk AT spth.de>

	* device/include/errno.h,
	  device/include/uchar.h,
	  device/include/wchar.h,
	  device/lib/mbrtoc32.c,
	  device/lib/c32rtomb.c,
	  device/lib/mbrtowc.c,
	  device/lib/wcrtomb.c,
	  device/lib/incl.mk,
	  support/regression/tests/wchar.c:
	  Implement mbrtoc32, c32rtomb(), mbrtowc(), wcrtomb().

2016-04-07 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCC.lex,
	  src/SDCCerr.h,
	  src/SDCCerr.c:
	  Fix bug #2488 by implementing hexadecimal floating constants.
	* device/include/stdlib.h,
	  device/lib/mblen.c,
	  device/lib/wctomb.c,
	  device/lib/incl.mk,
	  support/regression/tests/string.c:
	  Implement mblen(), wctomb().

2016-04-06 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/string.c:
	  Check more of wide strings, do not depend on implementation-defined
	  behaviour in char escape.

2016-04-06 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/gcc-torture-execute-950512-1.c
	* support/regression/tests/gcc-torture-execute-961122-1.c
	* support/regression/tests/gcc-torture-execute-960402-1.c
	  Enabled.

2016-04-05 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/string.c
	  Improve test case.
	* src/SDCCast.c
	* src/SDCCicode.c
	* src/z80/gen.c
	  Improve longlong compatibility.

2016-04-03 Molnar Karoly <molnarkaroly AT users.sf.net>

	* device/lib/pic14/bootstrap.sh,
	  device/lib/pic14/Makefile.in,
	  device/lib/pic14/libm/Makefile.in,
	  device/lib/pic14/libsdcc/enhanced/Makefile.am,
	  device/lib/pic14/libsdcc/enhanced/Makefile.in,
	  device/lib/pic14/libsdcc/enhanced-no-xinst/Makefile.am,
	  device/lib/pic14/libsdcc/enhanced-no-xinst/Makefile.in,
	  device/lib/pic14/libsdcc/regular/Makefile.am,
	  device/lib/pic14/libsdcc/regular/Makefile.in:
	  Workaround the Linux Mint bug: #2482 Link error with pic16f1827

	* device/lib/pic16/*,
	  device/non-free/lib/pic16/*:
	  Downgraded the autoconf version from 1.15 to 1.11.6.

2016-04-01 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCglue.c,
	  src/SDCCval.c:
	  Support wide string literals in initialization of global arrays.
	* src/SDCCast.c,
	  Support wide string literals in initialization of local arrays.
	* doc/sdccman.lyx:
	  Update documentation on standard compliance.

2016-04-01 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/gcc-torture-execute-950512-1.c
	  Enabled.
	* src/z80/gen.c
	  Improve longlong comptability on different hosts.

2016-03-31 Philipp Klaus Krause <pkk AT spth.de>

	* doc/sdccman.lyx:
	  Remove user-visible feature macros for signed / unsigned char.
	* device/include/limits.h:
	  Fix multibyte sequence limit.
	* support/regression/tests/bitvars.c,
	  support/regression/tests/funsigned-char.c:
	  Detect char signedness portably.
	* src/SDCCsymt.h,
	  src/SDCCval.c,
	  src/SDCCglue.c,
	  doc/sdccman.lyx,
	  support/regression/tests/string.c:
	  Support wide string literals outside of array initialization.

2016-03-31 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/gcc-torture-execute-pr19606.c
	  Disabled in test-host.

2016-03-29 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/gcc-torture-execute-20060127-1.c
	* support/regression/tests/gcc-torture-execute-921029-1.c
	* support/regression/tests/gcc-torture-execute-941015-1.c
	* support/regression/tests/gcc-torture-execute-pr19606.c
	  Disabled.
 
2016-03-29 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/bug3475656.c
	* support/regression/tests/gcc-torture-execute-20000314-2.c
	* support/regression/tests/gcc-torture-execute-20000523-1.c
	* support/regression/tests/gcc-torture-execute-20001108-1.c
	* support/regression/tests/gcc-torture-execute-20020201-1.c
	* support/regression/tests/gcc-torture-execute-20020226-1.c
	* support/regression/tests/gcc-torture-execute-20020508-1.c
	* support/regression/tests/gcc-torture-execute-20020508-2.c
	* support/regression/tests/gcc-torture-execute-20020508-3.c
	* support/regression/tests/gcc-torture-execute-20060110-1.c
	* support/regression/tests/gcc-torture-execute-20060110-2.c
	* support/regression/tests/gcc-torture-execute-20060127-1.c
	* support/regression/tests/gcc-torture-execute-20101013-1.c
	* support/regression/tests/gcc-torture-execute-920710-1.c
	* support/regression/tests/gcc-torture-execute-920829-1.c
	* support/regression/tests/gcc-torture-execute-921029-1.c
	* support/regression/tests/gcc-torture-execute-941015-1.c
	* support/regression/tests/gcc-torture-execute-950704-1.c
	* support/regression/tests/gcc-torture-execute-960801-1.c
	* support/regression/tests/gcc-torture-execute-961213-1.c
	* support/regression/tests/gcc-torture-execute-pr19606.c
	* support/regression/tests/gcc-torture-execute-pr27285.c
	  Enable more longlong test cases.

2016-03-28 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCglue.c:
	  Disable assertions to mask ds390 issue on non-OpenBSD for now.

2016-03-28 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCicode.c
	  Fix a long long issue on 32-bit machines.
	* support/regression/tests/gcc-torture-execute-950511-1.c
	* support/regression/tests/bug-2477.c
	  Enabled.

2016-03-27 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/inline.c:
	  Disable failing test for OpenBSD host.
	* src/SDCCglue.c:
	  Add assertions to help track down pointer size bugs.

2016-03-27 Ben Shi <powerstudio1st AT 163 DOT com>

	* sdas/asstm8/stm8pst.c
	  Apply part of patch #255 by Peter Dons Tychsen.

2016-03-24 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/z80/gen.c
	  Improve long long compatibility among different host machines.

2016-03-22 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCast.c
	* src/SDCCglue.c
	* src/SDCCval.c
	* src/SDCCval.h
	* src/pic16/glue.c
	* src/z80/gen.c
	  Improve long long compatibility among different host machines.

2016-03-19 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/z80/gen.c
	  Improve compatibility of SDCC between 32-bit and 64-bit machines.

2016-03-15 Molnar Karoly <molnarkaroly AT users.sf.net>

	* src/pic14/pcode.c:
	  Fixed bug: "#2481 wrong asm code for pic16f1827 (or even others?)"

2016-03-12 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/SDCCpeeph.c (labelIsUncondJump): also search backwards
	* src/mcs51/peeph.def: added rules 257.a-i for jump-to-jump optimization,
	  added	rules 259.c-f to remove dead jumps, implements RFE 491
	* src/SDCCerr.c,
	* src/SDCCerr.h: changed W_UNKNOWN_FEXT to E_UNKNOWN_FEXT
	* src/SDCCmain.c (processFile): also accept .h sources, implement RFE 460

2016-03-12 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/z80/gen.c
	  Rollback to previous version.
	* support/regression/tests/bug-2477.c
	  Disable this test case.

2016-03-11 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/z80/gen.c
	  Fix a bug in genRet(): long long return value is cut to long.
	* support/regression/tests/bug-2477.c
	  Add a new test case.

2016-03-10 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/stm8/gen.c
	  Fix a bug in genAnd(): conflict register assignment.
	* support/regression/tests/bug-2480.c
	  Add a new test case.

2016-03-06 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/SDCC.y: MSVC does not accept declarations in for loop

2016-03-05 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/non-free/lib/pic16/missing: copied from device/lib/pic16/missing
	* src/SDCCgen.c (genInline): also check for colon in single literal char
	* support/cpp/libcpp/macro.c (create_iso_definition): fixed warning
	* support/regression/compact-results.py: use 'T' for clock ticks

2016-03-05 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCgen.c
	  Fix a bug: colon should not be treated as a label suffix in a literal
	  string in inline-asm.

2016-03-05 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCerr.c
	* src/SDCCval.c
	  Remove warning #212 W_LONGLONG_LITERAL.

2016-03-04 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCicode.c
	  Fix long long issues.
	* support/regression/tests/longlong.c
	  Add more tests.

2016-02-27 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/scripts/sdcc.nsi
	  Install large-stack-auto related files into windows distribution.

2016-02-26 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCicode.c
	* src/SDCCicode.h
	* src/SDCCval.c
	* src/SDCCval.h
	  Fix potential precision loss of long long operands.

2016-02-21 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCast.c
	* src/SDCCast.h
	  Make sure the parameter list is not reversed before calling parmProcess().
	* support/regression/tests/bug-2473.c
	  Add a new test case.

2016-02-20 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCast.c
	  Fix bug #2471.

2016-02-19 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCerr.c
	  Make the error message of error E_CONST_EXPECTED more understandable.

2016-02-18 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCglue.c
	  Add check of non-constant in a global variable's initial value.

2016-02-13 Molnar Karoly <molnarkaroly AT users.sf.net>

	* src/pic14/gen.c,
	* src/pic14/glue.c,
	* src/pic14/pcode.c,
	* src/pic14/pcode.h:
	Fixed bug: "#2470 wrong asm code for PIC14 interrupt - interrupt not working"

2016-02-09 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/lib/Makefile.in: added and enabled large-mcs51-stack-auto
	* support/regression/ports/mcs51-large-stack-auto,
	* support/regression/ports/mcs51-large-stack-auto/spec.mk,
	* support/regression/Makefile.in: added test-mcs51-large-stack-auto
	* support/regression/tests/bug2094505.c: disabled for mcs51-large-stack-auto

2016-02-08 Maarten Brock <sourceforge.brock AT dse.nl>

	* debugger/mcs51/simi.c,
	* debugger/mcs51/simi.h: applied patch 268, Thanks Peter Dons Tychsen
	* device/include/stdlib.h: suppress unused variable warning
	* src/SDCCsymt.c (checkSClass): globals and statics in code don't need an
	  initializer but may be implicitly cleared
	* support/regression/tests/gcc-torture-execute-20000412-1.c: added disabled
	  testcase for this
	* support/regression/tests/bug-2041.c: also check with xdata starting at 1
	* support/regression/tests/bug-2089.c: fix warnings
	* support/regression/tests/bug-2423.c: suppress warning 147, show weird 203

2016-02-07 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/ds390/gen.c
	  Fix a bug in genFarPointerSet() when the result and the right operand are
	  both in DPTR.
	* support/regression/tests/bug-2041.c
	  Add a new test case.

2016-02-06 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCClospre.hpp,
	  src/SDCCnaddr.hpp,
	  src/SDCCralloc.hpp:
	  Workaround boost bug #11880 to make SDCC compile with boost 1.60.

2016-02-05 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCast.c
	  Fix a bug in comparison operation.
	* support/regression/tests/memory.c
	  Enable more tests.

2016-02-04 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCicode.c
	  Allow array members of structs can be accessed in pointer form.
	* support/regression/tests/bug-2468.c
	  Add a test case.

2016-02-03 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCClospre.hpp:
	  Fix compare operator, patch #267 by Peter Dons Tychsen.
	* device/lib/pic16/libsdcc/char/divschar.c,
	  device/lib/pic16/libsdcc/char/modschar.c:
	  Fix signedness of pic16 char support routines.

2016-02-01 Ben Shi <powerstudio1st AT 163 DOT com>
 
	* src/SDCCast.c
	  Try to find a common type for the left and right in '?:' .
	* support/regression/tests/bug-2461.c
	  Add a new test case.

2016-02-01 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCglobl.h,
	  src/SDCCmain.c,
	  src/SDCCsymt.c,
	  src/SDCCval.c,
	  doc/sdccman.lyx:
	  Make char unsigned by default.

2016-02-01 Philipp Klaus Krause <pkk AT spth.de>

	* device/include/stdlib.h:
	  Fix declaration of aligned_alloc() for C11.

2016-02-01 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCC.y
	  Fix a bug: type mismatch between function definition and declaration.
	* support/regression/tests/bug-2419.c
	  Add a new test case.

2016-01-31 Molnar Karoly <molnarkaroly AT users.sf.net>

	* src/pic14/device.c,
	  src/pic14/gen.c,
	  src/pic14/glue.c,
	  src/pic14/pcode.c,
	  src/pic14/pcodepeep.c,
	  src/pic14/ralloc.c,
	  src/pic16/device.c,
	  src/pic16/device.h,
	  src/pic16/gen.c,
	  src/pic16/genarith.c,
	  src/pic16/genutils.c,
	  src/pic16/glue.c,
	  src/pic16/glue.h,
	  src/pic16/graph.c,
	  src/pic16/main.c,
	  src/pic16/pcode.c,
	  src/pic16/pcode.h,
	  src/pic16/pcodepeep.c,
	  src/pic16/ralloc.c,
	  src/pic16/ralloc.h:
	  Use "Safe_alloc(...)" instead of "Safe_calloc(1, ...)".
	  Use SNPRINTF(X, sizeof(X), ...) instead of sprintf(X, ...).
	  Some code simplification, e.g.:
	    sprintf (s, "%s", aop->aopu.aop_dir);
	    rs = Safe_calloc (1, strlen (s) + 1);
	    strcpy (rs, s);
	    return rs;
	      .
	      .
	      .
	    return Safe_strdup(aop->aopu.aop_dir);

2016-01-28 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/Makefile.in:
	  Change handling of test filenames for regression tests, patch #266 by
	  Peter Dons Tychsen.
	* src/SDCCast.c,
	  support/regression/tests/bug-2458.c:
	  Changed result type propagation for logic operations, variant of proposed
	  fix by Peter Dons Tychsen for bug #2458.

2016-01-26 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCsymt.c:
	  Fix handling of __z88dk_fastcall in specifier merging.

2016-01-26 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/SDCCval.c (strVal): free utf_8 and suppress warning

2016-01-25 Molnar Karoly <molnarkaroly AT users.sf.net>

	* src/pic14/pcode.c,
	  src/pic14/ralloc.c:
	  More use the logical constants.

2016-01-25 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/main.c:
	  Improve DWARF support for stm8 ELF, picked from patch #255 by Peter Dons
	  Tychsen.
	* src/SDCCsymt.c:
	  Fix handling of preserved regs in specifier merging.

2016-01-24 Molnar Karoly <molnarkaroly AT users.sf.net>

	* src/pic16/pcode.c,
	  src/pic16/pcodepeep.c:
	  More use the logical constants.

2016-01-24 Molnar Karoly <molnarkaroly AT users.sf.net>

	* src/pic14/gen.c,
	  src/pic14/glue.c,
	  src/pic14/pcode.c,
	  src/pic14/pcoderegs.c,
	  src/pic14/ralloc.c:
	  More use the logical constants.

2016-01-24 Molnar Karoly <molnarkaroly AT users.sf.net>

	* src/pic14/gen.c,
	  src/pic14/pcode.c,
	  src/pic14/pcode.h:
	  Add support the ASRF, LSLF and LSRF instructions
	  (enhanced intructions of pic14): feature-requests #484

	* src/pic14/gen.c,
	  src/pic14/gen.h:
	  On more place I exchanged the "char *" to "const char *".

2016-01-24 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCC.y
	* src/SDCCast.c
	* src/SDCCast.h
	* src/SDCCutil.c
	* src/SDCCutil.h
	  Format inline asm coding style.

2016-01-23 Ben Shi <powerstudio1st AT 163 DOT com>

	* configure
	* configure.ac
	* debugger/mcs51/configure
	* debugger/mcs51/configure.ac
	* support/cpp/configure
	* support/cpp/configure.ac
	* support/packihx/configure
	* support/packihx/configure.ac
	  Try to use C99 first.
	* src/SDCC.lex
	  Remove a duplicate function definition.
	* src/SDCC.y
	  Change to C99 style.

2016-01-22 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCsymt.c,
	  src/SDCCglue.h,
	  src/SDCCglue.c:
	  Do not display meaningless __reentrent to users.

2016-01-22 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c,
	  src/z80/peep.c:
	  Make estimate for preserved regs on function pointers less conservative.
	* src/SDCCsymt.c:
	  Consider preserved regs for type of function pointer.

2016-01-22 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/peep.c:
	  More accurate handling of conditional jumps, handle ex (sp), ix and
	  ex (sp), iy.

2016-01-21 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCC.y:
	  Seems we have to worry about more than MSVC wrt. C99, patch #265 by Peter
	  Dons Tychsen.

2016-01-21 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCC.lex,
	  src/SDCC.y,
	  src/SDCCerr.c,
	  src/SDCCerr.h,
	  src/SDCCsymt.h,
	  src/*/main.c,
	  src/z80/gen.c:
	  Implement declaration of preserved registers, RFE #483.
	* src/z80/peep.c
	  Handle preserved register information in peephole optimization.
	* device/include/stdlib.h,
	  device/include/string.h:
	  Preserved register information on standard functions.
	* doc/sdccman.lyx:
	  Document syntax for specifying preserved registers.

2016-01-20 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/peep.c:
	  More exact handling of ex, support for decimal shifts.

2016-01-18 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCdebug.c:
	  Debug info for block-copy-initialized global variables, patch #262 by
	  Peter Dons Tychsen.
	* src/SDCCdwarf2.c:
	  Fix handling of declared, but unused global vairables in debug output,
	  patch #263 by Peter Dons Tychsen.
	* src/z80/peep.c:
	  More accurate handling of functions returning long long for peephole
	  optimizer.
	* src/SDCCmain.c:
	  Fix stream for help output, patch #264 by Peter Dons Tychsen.

2016-01-18 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCicode.c
	  Apply a modified version of patch #261 by Peter Dons Tychsen.
	* support/regression/bug-2455.c
	  Improve test case.

2016-01-18 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCicode.c:
	  Fix pointer dereference issue, patch #261 by Peter Dons Tychsen.

2016-01-17 Molnar Karoly <molnarkaroly AT users.sf.net>

	* device/non-free/include/pic14/*.h,
	  device/non-free/include/pic16/*.h,
	  device/non-free/lib/pic14/libdev/*.c,
	  device/non-free/lib/pic16/libdev/*.c:
	  Updated the device files.

2016-01-17 Molnar Karoly <molnarkaroly AT users.sf.net>

	* src/pic14/pcode.c,
	  src/pic14/pcode.h,
	  src/pic16/ralloc.c,
	  src/pic16/ralloc.h,
	  src/pic16/pcodepeep.c,
	  src/pic16/ralloc.c,
	  src/pic16/ralloc.h:
	  On more place I exchanged the "char *" to "const char *".

	* src/regression/Makefile:
	  Added the option to CFLAGS: --no-warn-non-free

2016-01-16 Molnar Karoly <molnarkaroly AT users.sf.net>

	* src/pic14/gen.c,
	  src/pic14/pcode.c:
	  Each function has its own code section.

	* src/pic16/pcode.c:
	  Fix a gcc warning.

2016-01-15 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCicode.c
	  Fix bug #2455.
	* support/regression/bug-2455.c
	  Add a new test case.

2016-01-14 Molnar Karoly <molnarkaroly AT users.sf.net>

	* device/lib/pic14/configure,
	  device/lib/pic14/configure.ac,
	  device/lib/pic16/configure.ac:
	  Do away with the automake warning:
	  "option 'subdir-objects' is disabled"

	* device/lib/pic16/Makefile.in,
	  device/lib/pic16/aclocal.m4,
	  device/lib/pic16/configure,
	  device/lib/pic16/depcomp,
	  device/lib/pic16/install-sh,
	  device/lib/pic16/missing,
	  device/lib/pic16/debug/Makefile.in,
	  device/lib/pic16/libc/Makefile.in,
	  device/lib/pic16/libio/Makefile.am,
	  device/lib/pic16/libio/Makefile.in,
	  device/lib/pic16/libio/adc.ignore,
	  device/lib/pic16/libio/i2c.ignore,
	  device/lib/pic16/libio/usart.ignore,
	  device/lib/pic16/libm/Makefile.in,
	  device/lib/pic16/libsdcc/Makefile.in,
	  device/lib/pic16/startup/Makefile.in,
	  device/non-free/include/pic16/pic18fam.h:
	  Improve of update to gputils-1.4.2-1.

2016-01-12 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/peep.c:
	  More accurate handling of Z80/Z180 I/O in peepholes.

2016-01-11 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/ds390/ralloc.c
	* src/mcs51/ralloc.c
	  Improve positionRegs().
	* src/mcs51/gen.c
	  Roll back to previous version.
	* support/regression/tests/bug-2263.c
	* support/regression/tests/bug-2403.c
	  Add new test cases.

2016-01-10 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/peep.c:
	  More accurate handling of Z80/Z180 I/O in peepholes.

2016-01-10 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/mcs51/gen.c
	  Fix a bug in genOr() when all operands are in registers.
	* support/regression/tests/bug-2448.c
	  Add a new test case.

2016-01-09 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/cinc2h.pl,
	  support/optimize_pic16devices.pl,
	  support/z80-disasm.pl:
	  Some minor repairs.

	* device/include/pic14/pic14devices.txt,
	  device/include/pic14/pic16regs.h,
	  device/include/pic16/pic16devices.txt,
	  device/include/pic16/pic18fregs.h,
	  device/lib/pic16/configure,
	  device/lib/pic16/libio/Makefile.am,
	  device/lib/pic16/libio/Makefile.in,
	  device/lib/pic16/libio/adc.ignore,
	  device/lib/pic16/libio/i2c.ignore,
	  device/lib/pic16/libio/usart.ignore,
	  device/non-free/include/pic14/*.h,
	  device/non-free/include/pic16/*.h,
	  device/non-free/lib/pic14/libdev/devices.txt,
	  device/non-free/lib/pic14/libdev/*.c,
	  device/non-free/lib/pic16/Makefile.in,
	  device/non-free/lib/pic16/aclocal.m4,
	  device/non-free/lib/pic16/configure,
	  device/non-free/lib/pic16/processors.ac,
	  device/non-free/lib/pic16/libdev/Makefile.am,
	  device/non-free/lib/pic16/libdev/Makefile.in,
	  device/non-free/lib/pic16/libdev/*.c,
	  doc/sdccman.lyx:
	  Updated to gputils-1.4.2-1.

2016-01-06 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCicode.c:
	  Optimize comparisons of cheap variables to expensive constants more.
	* src/SDCCast.c:
	  Use cheaper types for implicitly introduced constants.

2016-01-05 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCast.c:
	  Do not try to output debug info in case of fatal errors - patch #260 by
	  Peter Dons Tychsen
	* src/z80/gen.c,
	  support/regression/tests/bug-2452.c:
	  Fix gbz80 right shift bug #2452.

2016-01-05 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCicode.c
	  Fix bug: members of pointer arrays are always treated as r-values.
	* support/regression/tests/gcc-torture-execute-930526-1.c
	  Improve test case.
	* support/sdbinutils/binutils/arlex.c
	  Removed.

2016-01-04 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/peep.c:
	  Fix handling of nop in z80MightRead, patch #259 by alvin.
	* src/SDCCicode.c:
	  Optimize comparisons of cheap variables to expensive constants.

2016-01-03 Philipp Klaus Krause <pkk AT spth.de>

	* sdas/linksrc/lkarea.c:
	  Fix handling of NOLOAD for STM8 in linker, patch by Peter Dons Tychsen.
	* src/SDCCralloc.hpp:
	  Fix compare operator for register assignments.

2016-01-02 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/sdbinutils/binutils/arparse.c
	* support/sdbinutils/binutils/arparse.h
	  Delete intermediate files.

2016-01-02 Maarten Brock <sourceforge.brock AT dse.nl>

	* all.vcxproj,
	* config.vcxproj,
	* sdas/as6808/as_hc08.vcxproj,
	* sdas/as8051/asx8051.vcxproj,
	* sdas/as8xcxxx/sdas390.vcxproj,
	* sdas/asgb/asgb.vcxproj,
	* sdas/linksrc/aslink.vcxproj,
	* src/avr/avr.vcxproj,
	* src/ds390/ds390.vcxproj,
	* src/hc08/hc08.vcxproj,
	* src/mcs51/mcs51.vcxproj,
	* src/pic14/pic14.vcxproj,
	* src/pic16/pic16.vcxproj,
	* src/sdcc.vcxproj,
	* src/xa51/xa51.vcxproj,
	* src/z80/z80.vcxproj,
	* src/z80/z80a.vcxproj,
	* support/cpp/sdcpp.vcxproj,
	* support/librarian/librarian.vcxproj,
	* support/makebin/makebin.vcxproj,
	* support/packihx/packihx.vcxproj: applied patch 252 by Peter Dons Tychsen
	  to remove UpgradeFromVC60.props

2015-12-30 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCdwarf2.c:
	  Fix memory bug in DWARF output, patch by Peter Dons Tychsen.
	* sdas/asxxsrc/asdbg.c:
	  Fix 0 pointer access when specifying -y or -j without -o.

2015-12-30 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCsymt.c
	  Make comparePtrType() less strict.
	* support/regression/tests/bug-2271.c
	  Improve test case.

2015-12-28 Ben Shi <powerstudio1st AT 163 DOT com>

	* doc/sdccman.lyx
	  Suggest msys2 along with msys while building wih MSVC.
	* sdas/asxxsrc/assym.c
	  Apply patch #253.

2015-12-26 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/stm8/gen.c
	  Add absent call to dwWriteFunction() while --debug is specified.
  
2015-12-24 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCC.y
	  Fix a bug in the front end. (pointer array parameters)
	* support/regression/tests/bug-2271.c
	  Add a test case.

2015-12-21 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/main.c:
	  Option for ELF output in STM8 backend.

2015-12-20 Philipp Klaus Krause <pkk AT spth.de>

	* sdas/linksrc/lkelf.c,
	  sdas/linksrc/lkmain.c:
	  STM8 ELF linker support from patch #251.

2015-12-18 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCmain.c:
	  Always use preprocessor in standard mode.
	* device/include/stdlib.h:
	  Fix declaration order for inlined aligned_alloc().

2015-12-17 Ben Shi <powerstudio1st AT 163 DOT com>

	* Makefile.in
	  Fix the conflict in parallel build caused by component dependency.

2015-12-16 Ben Shi <powerstudio1st AT 163 DOT com>

	* sim/ucsim/cmd.src/cmdset.cc
	  Apply a modified version of patch #250. 

2015-12-14 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCast.c:
	  Avoid redundant call to processParms().
	* support/regression/tests/bug-2436.c
	  Add a new test case.

2015-12-10 Philipp Klaus Krause <pkk AT spth.de>

	* device/include/wchar.h:
	  A basic wchar.h with for types that are useful even with no wide character
	  functions around.

2015-12-05 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCC.y
	* src/SDCCerr.c
	* src/SDCCerr.h
	  Fix a bug of type definition of a function by typedef.

2015-12-02 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCerr.c
	* src/SDCCerr.h
	  Fix defects in previous commit.

2015-12-01 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCC.y
	* src/SDCCerr.c
	* src/SDCCerr.h
	  Remove warning #220 (W_ANONYMOUS_MEMBER).

2015-11-28 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCpeeph.c:
	  Fix operandsNotRelated() bug #2435.
	* device/include/stddef.h,
	  device/include/stdlib.h,
	  src/SDCC.lex,
	  src/SDCCmain.c,
	  src/SDCCval.c,
	  src/SDCCval.h,
	  support/regression/tests/charconst.c,
	  support/regression/tests/string.c:
	  Make wchar_t UTF-32.
	* support/cpp/Makefile.in:
	  Fix call to make.

2015-11-26 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/gcc-torture-execute-20050111-1.c
	* support/regression/tests/gcc-torture-execute-950511-1.c
	  Disable test cases.

2015-11-24 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCicode.c
	* src/SDCCval.c
	* src/SDCCval.h
	  Improve long long multiplication.
	* support/regression/tests/gcc-torture-execute-20050111-1.c
	* support/regression/tests/gcc-torture-execute-950511-1.c
	* support/regression/tests/longlong.c
	  Improve test cases.

2015-11-14 Philipp Klaus Krause <pkk AT spth.de>

	* doc/Makefile.in,
	  doc/sdccman.lyx:
	  Fix bookmarks and hyperlinks in manual, bug #2405.
	* src/SDCCglue.c:
	  Drop build time in asm output to ease reproducible builds.
	* device/lib/*/Makefile.in,
	  device/lib/Makefile.in:
	  Drop build time in sdar calls to make non-pic lib builds reproducible.

2015-11-13 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/cpp/libcpp/include/symtab.h:
	  Fix build failure on MacOS x86-64.
	* support/regression/tests/inline.c:
	  Fix failure in test-host in NetBSD.
	* support/regression/tests/literalop.c:
	  Disable some tests on MacOS x86-64.

2015-11-12 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/include/mcs51/at89c51id2.h: moved

2015-11-12 Philipp Klaus Krause <pkk AT spth.de>

	* doc/sdccman.lyx:
	  Update standard compliance documentation.

2015-11-09 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/include/mcs51/at89c51ed2.h: applied patch 247
	* device/include/at89c51id2.h: new, added, thanks Victor Munoz
	* src/SDCC.lex: it seems really hard not to declare vars amidst the code
	* src/SDCCast.c (expandInlineFuncs): fix bug 2295: also expand for clauses
	* support/regression/tests/ctype.c: warn about undefined __STDC_VERSION__
	* support/regression/tests/inline.c (bug_2295): new test case

2015-11-09 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCC.lex,
	  src/SDCCval.c:
	  UTF-32 and UTF-16 encodig in strVal().

2015-11-08 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/mcs51/gen.c: added IS_AOP_IMMEDIATE,
	  (gencjneshort): applied modified part of patch 129, thanks Hubert Sack

2015-11-08 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/string.c
	  Separate C11 behaviour from implementation-defined behaviour.

2015-11-07 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCglue.c:
	  Eliminate unused static symbols. (__str_%d generated in stringToSymbol()).
	* support/regression/tests/bug-2089.c:
	  Improve test case.
	* support/regression/ports/mcs51-xstack-auto/spec.mk:
	  Use default sdcc11.
	* support/regression/tests/string.c:
	  Disabled for test-host.

2015-11-07 Philipp Klaus Krause <pkk AT spth.de>

	* support/util/dbuf_string.h,
	  support/util/dbuf_string.c,
	  src/SDCCval.c,
	  src/SDCC.lex:
	  Handling of UTF-16 and UTF-16 string literals in the frontend up to
	  strVal().

2015-11-06 Philipp Klaus Krause <pkk AT spth.de>

	* support/util/dbuf.h,
	  support/util/dbuf.c,
	  support/util/dbuf_string.h,
	  support/util/dbuf_string.c:
	  Allow prepending to dynamic buffers.
	* src/SDCC.lex,
	  src/SDCCerr.h,
	  src/SDCCerr.c:
	  Support C11 u8 prefix for UTF-8-encoded unicode string literals.
	* src/SDCCutil.c,
	  support/regression/tests/string.c:
	  Fix handling of universal escape sequences in UTF-8-encoded string literals.
	* support/regression/tests/iso-8859-1.c:
	  Test support for source encodings other than unicode.

2015-11-06 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/SDCC.y: only emit W_FLEXARRAY_INSTRUCT for c89
	* src/SDCCpeeph.c (labelJTInRange): removed env SDCC_SJMP_JUMPTABLE check,
	  closes patch #29,
	  (readRules): clean up

2015-11-05 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCsymt.c:
	  Print calling convention for functions.
	* src/z80/peep.c:
	  More accurate handling of register arguments in peepholes.

2015-11-05 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/mcs51/ralloc.c (packRegsForOneuse): fixed bug 2373
	* support/regression/tests/bug-2373.c: new, added

2015-11-05 Maarten Brock <sourceforge.brock AT dse.nl>

	* sdcc.sln,
	* src/yacc.vcxproj: deleted yacc project
	* src/sdcc.vcxproj,
	* src/sdcc.vcxproj.filters: moved SDCC.y here for better dependencies
	* SDCC.props: new, added Visual C property sheet for generic settings like
	  boost path (default: c:\local\boost_1_59_0\)
	* src/hc08/hc08.vcxproj,
	* src/sdcc.vcxproj,
	* src/stm8/stm8.vcxproj,
	* src/z80/z80.vcxproj: use SDCC.props
	* sdas/linksrc/lkaomf51.c: output capitals depending on the zflag
	* src/common.h
	* src/stm8/ralloc2.cc (extra_ic_generated),
	* src/z80/ralloc2.cc (default_operand_cost, assign_cost, Ainst_ok,
	  rough_cost_estimate),
	* src/SDCCglue.c (printIvalChar),
	* src/SDCCopt.c (convertToFcall): fixed warnings
	* src/SDCCutil.c (isblank): added for MSVC 2010
	* support/cpp/ansidecl.h: deleted
	* support/cpp/sdcpp.vcxproj,
	* support/cpp/sdcpp.vcxproj.filters: use files in support/sdbinutils/
	* support/sdbinutils/libiberty/getpwd.c: fixed for MSVC

2015-10-30 Ben Shi <powerstudio1st AT 163 DOT com>

	* sdas/linksrc/lkmem.c:
	  Fix defects in previous commit.

2015-10-30 Ben Shi <powerstudio1st AT 163 DOT com>

	* sdas/linksrc/lkarea.c:
	* sdas/linksrc/lkmem.c:
	  Improve the error message in .mem when no enough space for the stack.
	  Suggest the largest spare space (address and size) in the internal RAM.

2015-10-28 Ben Shi <powerstudio1st AT 163 DOT com>

	* sdas/linksrc/lkmem.c:
	  Fix incorrect check of "--xram-size".

2015-10-27 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCglue.c:
	  Bug fix: char s[10] = "ab", bytes beyond "ab" sometimes aren't set to 0.

2015-10-26 Philipp Klaus Krause <pkk AT spth.de>

	* Merge cpp-merge-upstream branch to get improved standard support.

2015-10-26 Philipp Klaus Krause <pkk AT spth.de>

	* .version:
	  Bump version due to improved standard support.

2015-10-24 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/ralloc.c,
	  src/port.h:
	  Spelling fixes.

2015-10-23 Philipp Klaus Krause <pkk AT spth.de>

	* support/cpp/Makefile.in:
	  Fix build-dependency of sdcpp on libiberty.
	* support/cpp/sdcpp.opt,
	  support/cpp/sdcpp-opts.c,
	  support/cpp/libcpp/init.c:
	  Support C11 in preprocessor.
	* src/SDCCmain.c:
	  Fix standard support, add support for c95 and sdcc11 dialects.

2015-10-22 Ben Shi <powerstudio1st AT 163 DOT com>

	* SDCC.y:
	  Add checks for NULL pointers.

2015-10-19 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCast.c:
	* src/SDCCglue.c:
	* src/SDCCglue.h:
	  Eliminate redundant string literals to be generated.
	* support/regression/tests/bug-2089.c:
	  Add a new test case.

2015-10-18 Philipp Klaus Krause <pkk AT spth.de>

	* support/cpp/libcpp/*:
	  Reformat to reduce diff to upstream cpp.

2015-10-17 Philipp Klaus Krause <pkk AT spth.de>

	* support/cpp/libcpp/*:
	  Reformat to reduce diff to upstream cpp.

2015-10-11 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCerr.h,
	  src/SDCCerr.c,
	  src/SDCC.lex:
	  Support C95 wide string literals.

2015-10-09 Philipp Klaus Krause <pkk AT spth.de>

	* support/cpp/libcpp/include/*:
	  Reformat to reduce diff to upstream version.

2015-10-10 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/util/dbuf_string.c:
	  Add check for null pointer.

2015-10-09 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/z80/gen.c:
	  Wrap strtoul() to support $-prefix hex numbers.

2015-10-09 Philipp Klaus Krause <pkk AT spth.de>

	* New memory management by merging malloc branch into trunk.

2015-10-09 Ben Shi <powerstudio1st AT 163 DOT com>

	* sdas/linksrc/lkaomf51.c:
	  Add bound check while accessing a buffer in the heap.

2015-10-08 Philipp Klaus Krause <pkk AT spth.de>

	* support/cpp/libcpp/files.c:
	  Drop cpp support for Borland C.

2015-10-07 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/charconst.c,
	  support/regression/tests/escape.c:
	  Disable some tests for host, so we don't need a C11 host.

2015-10-07 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCval.c:
	  Add bound check in reorderIlist().
	* support/regression/bug-2423.c:
	  Add a new test case.

2015-10-06 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCerr.h,
	  src/SDCCerr.c,
	  src/SDCCutil.h,
	  src/SDCCutil.c,
	  src/SDCCval.c,
	  support/regression/tests/charconst.c,
	  support/regression/tests/escape.c:
	  Implement escape sequences for wide character constants, fix universal
	  escape sequences.

2015-10-06 Philipp Klaus Krause <pkk AT spth.de>

	* device/include/uchar.h,
	  src/SDCCval.h,
	  src/SDCCval.c,
	  src/SDCC.lex,
	  src/SDCCutil.c,
	  src/SDCCmain.c,
	  src/SDCCglobl.h,
	  src/SDCCerr.h,
	  src/SDCCerr.c,
	  support/regression/tests/charconst.c:
	  Wide character constants.

2015-10-05 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/malloc.c:
	  Improve comments on heap data structures.

2015-10-04 Philipp Klaus Krause <pkk AT spth.de>

	* device/include/stdlib.h,
	  device/lib/aligned_alloc.c:
	  Implement aligned_alloc().

2015-10-02 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/realloc.c:
	  Fix a bug in realloc() freeing.

2015-10-02 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/free.c,
	  device/lib/realloc.c,
	  device/lib/malloc.c,
	  device/lib/realloc.c,
	  support/regression/tests/malloc.c:
	  Simplify memory management, document search of free list.
	* support/regression/fwk/lib/testfwk.c:
	  Support printing unsigned in test logs

2015-10-02 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCval.c:
	  Loose the condition of warning 116.

2015-09-29 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/stm8/main.c:
	  Support "pragma codeseg" and "pragma constseg" in the stm8 port.

2015-09-28 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/stm8/main.c:
	  Support "--codeseg" and "--constseg" on the stm8 port.

2015-09-22 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/lib/_calloc.c,
	* device/lib/_free.c,
	* device/lib/_heap.c,
	* device/lib/_malloc.c,
	* device/lib/_realloc.c: renamed all _sdcc_* to __sdcc_*,
	  removed register keywords,
	  changed _sdcc_heap_size to __sdcc_last_memheader,
	  removed init_dynamic_memory() and other optimizations
	* support/regression/tests/malloc.c: added test for size overflow

2015-09-21 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/gcc-torture-execute-pr28982a.c:
	  Enabled for the r2k and r3ka ports.

2015-09-20 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/calloc.c,
	  device/lib/malloc.c,
	  device/lib/realloc.c,
	  device/lib/free.c:
	  Use typedefs for memory block header type, use more pointers to __xdata.
	* device/include/stdlib.h,
	  device/include/malloc.h:
	  Move memory management to stdlib.h, fix stdlib.h inclusion.

2015-09-20 Philipp Klaus Krause <pkk AT spth.de>

	* device/include/asm/*/features.h,
	  device/include/malloc.h,
	  device/lib/calloc.c,
	  device/lib/malloc.c,
	  device/lib/realloc.c,
	  device/lib/free.c,
	  support/regression/tests/malloc.c:
	  First version of new, more efficient memory management.

2015-09-20 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/z80/gen.c:
	  Fix bugs in genOr() and genXor() while operands are longlong.
	* support/regression/tests/longlong.c:
	  Enable more tests.

2015-09-16 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCC.y:
	* src/SDCCast.c:
	* src/SDCCerr.c:
	* src/SDCCicode.c:
	  Disable nested critical block / function call, support return in inline
	  critical functions.
	* support/regression/tests/critical.c:
	  Improve test case.
	* support/regression/tests/malloc.c:
	  fix a small spot.

2015-09-15 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/malloc.c:
	  More testing of memory management.

2015-09-14 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/malloc.c:
	  More testing of memory management.

2015-09-13 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/pic16/*
	  Fix delarations to make pic16 lib compile again.

2015-09-12 Philipp Klaus Krause <pkk AT spth.de>

	* src/pic14/genarith.c:
	  Fix bug #2417 by applying patch by Juho Salminen.

2015-09-10 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/bug-2385.c:
	  Regression test for bug #2385.

2015-09-10 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/critical.c:
	  Improve test case.
	* src/SDCC.y:
	  Fix a bug: inline critical functions are inlined as non-critical.

2015-09-09 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/generic.c:
	  More testcases for _Generic.
	* src/z80/gen.c,
	  support/regression/tests/critical.c:
	  Fix bug #2416.

2015-09-04 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/peep.c:
	  Fix handling of bcpl in notUsed().

2015-09-03 Philipp Klaus Krause <pkk AT spth.de>

	* src/pic14/peeph.def:
	  Fix bug #2415.
	* src/stm8/peeph.def:
	  Implement some rules for bit complement.
	* src/SDCCval.c,
	  support/regression/tests/generic.c:
	  Fix bug #2411.
	* src/pic16/main.c:
	  Use zero-initializing crt0 by default.

2015-08-27 Ben Shi <powerstudio1st AT 163 DOT com>

	* sim/ucsim/packages_in.mk:
	  Fix a bug: simulator sz80 is not built if only z80 port is enabled.

2015-08-22 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/stm8/peep.c:
	  Fix a bug in peephole rule condition notUsed().

2015-08-22 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/bug-2188.c:
	* src/SDCCast.c:
	  Apply patch #248 by Pavel Pisa <pisa@cmp.felk.cvut.cz>.

2015-08-19 Ben Shi <powerstudio1st AT 163 DOT com>

	* configure.ac:
	* configure:
	  Correct build failure on sparc64-netbsd.

2015-08-19 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/condopptr.c:
	  Add more test.
	* src/SDCC.y:
	  Improve conditional expression.
	* configure.ac:
	* configure:
	  Correct spots in previous commit.

2015-08-17 Ben Shi <powerstudio1st AT 163 DOT com>

	* configure.ac:
	* configure:
	  Extend stack size on cygwin64.

2015-08-15 Ben Shi <powerstudio1st AT 163 DOT com>

        * src/SDCCast.c:
          Fix a bug in storage class check.
        * support/regression/tests/gcc-torture-execute-20020402-3.c:
          Enable test case.

2015-08-15 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCast.c,
	  support/regression/tests/array.c:
	  Implement RFE #454 for index[array] access.
	* src/SDCC.y,
	  src/SDCCerr.h,
	  src/SDCCerr.c:
	  Emit warning for non-standard label without statement.
	* support/regression/tests/generic.c:
	  Disable test for host, since older host compilers are still in use.

2015-08-12 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCC.lex,
	  src/SDCC.y,
	  src/SDCCast.c,
	  src/SDCCerr.h,
	  src/SDCCerr.c,
	  support/regression/tests/generic.c,
	  doc/sdccman.lyx:
	  Implement C11 generic selections.

2015-08-11 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCsymt.c,
	  src/SDCCerr.h,
	  src/SDCCerr.c,
	  support/regression/tests/gcc-torture-execute-920721-3.c,
	  support/regression/tests/gcc-torture-execute-pr34176.c,
	  support/regression/tests/implicit_int.c:
	  Diagnostic for implicit int.

2015-08-10 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/peeph-z80.def:
	  Fix bug #2408.
	* src/z80/peeph-r2k.def,
	* src/z80/peeph-tlcs90.def:
	  Synced with z80 peepholes.

2015-08-09 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/peeph-z80.def:
	  Fix bug #2407 using fix suggested by alvin.

2015-08-02 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Cheaper stm8 division workaround (RFE #449).
	* doc/sdccman.lyx:
	  Update standard compliance documentation to reflect recently implemented
	  feature.

2015-08-01 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCsymt.h,
	  src/SDCCsymt.c,
	  src/SDCCralloc.hpp,
	  src/stm8/gen.c:
	  Static code analysis to omit stm8 division workaround when safe to do so
	  (RFE #448).

2015-07-31 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/gcc-torture-execute-stdarg-5.c:
	  Improve test case.

2015-07-26 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Workaround for for stm8 division hardware bug.

2015-07-13 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/cpp/configure.ac:
	* support/cpp/configure:
	* support/cpp/Makefile.in:
	* Makefile.common.in:
	  Fix small spots.

2015-07-13 Ben Shi <powerstudio1st AT 163 DOT com>

	* sdas/linksrc/lklex.c:
	  Support unicode character in sdld's command line.
	* sdas/linksrc/lkbank.c:
	  Remove unsupported ".s28" and ".s37" file extensions.

2015-07-12 Ben Shi <powerstudio1st AT 163 DOT com>

	* configure.in:
	* debugger/mcs51/configure:
	* debugger/mcs51/configure.in:
	* device/lib/pic14/Makefile.in:
	* device/lib/pic14/aclocal.m4:
	* device/lib/pic14/config.h.in:
	* device/lib/pic14/configure.in:
	* device/lib/pic14/libm/Makefile.in:
	* device/lib/pic14/libsdcc/enhanced/Makefile.in:
	* device/lib/pic14/libsdcc/enhanced-no-xinst/Makefile.in:
	* device/lib/pic14/libsdcc/regular/Makefile.in:
	* device/non-free/lib/pic14/configure:
	* device/non-free/lib/pic14/configure.in:
	* sim/ucsim/configure.in:
	* support/cpp/configure:
	* support/cpp/configure.in:
	* support/packihx/configure:
	* support/packihx/configure.in:
	  Move all configure.in to configure.ac and update with autoconf 2.69.

2015-07-10 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/peeph.def:
	  Fix comments.
	* device/lib/stm8/_mulint.s:
	  Faster, smaller integer multiplication.

2015-07-08 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/sdbinutils/bfd/asxxxx.c:
	  Fix a bug in check .rel format while there are comments.

2015-07-06 Ben Shi <powerstudio1st AT 163 DOT com>

	* configure:
	* configure.in:
	* device/include/Makefile.in:
	* support/sdbinutils/Makefile.in:
	* support/sdbinutils/binutils/Makefile.in:
	  Make "make install" and "make uninstall" more clear.

2015-07-05 Philipp Klaus Krause <pkk AT spth.de>

	* support/sdbinutils/binutils/*
	  Fix bug #2394 and do not ship files generated by yacc.

2015-07-03 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCpeeph.c:
	  Patch from z88dk to allow comments in between rule and condition.

2015-07-01 Philipp Klaus Krause <pkk AT spth.de>

	* Merge upstream binutils 2.25 by merging binutils branch into trunk.

2015-07-01 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/mcs51/peep.c:
	  Add NULL pointer check.

2015-06-30 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCmain.c:
	  Adjust buffer sizes RFE #441.

2015-06-29 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCmain.c,
	  doc/sdccman.lyx,
	  support/regression/tests/version.c:
	  Implement patchlevel macro RFE #441.

2015-06-28 Philipp Klaus Krause <pkk AT spth.de>

	* support/sdbinutils/*
	  Merge upstream binutils 2.25.

2015-06-28 Philipp Klaus Krause <pkk AT spth.de>

	* support/sdbinutils/*
	  Import more parts of upstream binutils 2.23.2.

2015-06-27 Philipp Klaus Krause <pkk AT spth.de>

	* support/sdbinutils/*
	  Import more parts of upstream binutils 2.23.2.

2015-06-26 Ben Shi <powerstudio1st AT 163 DOT com>

	* device/include/float.h:
	  Hide sdcc library private macros.
	* support/sdbinutils/include/objalloc.h:
	* support/sdbinutils/libiberty/objalloc.c:
	  Apply patches from GNU.

2015-06-25 Ben Shi <powerstudio1st AT 163 DOT com>

	* configure:
	* configure.in:
	* device/non-free/include/Makefile.in:
	  Fix the bug "make uninstall" left empty directory. 
	* src/SDCCBBlock.c:
	  Apply patch #158 to fix bug #1693.
	* support/regression/tests/version.c:
	  Fix the failure in "make test-host".

2015-06-24 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCmain.c,
	  doc/sdccman.lyx,
	  support/regression/tests/version.c:
	  Implement version macros RFE #441.

2015-06-24 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/collate-results.py:
	  Fix the bug that an abnormal stop in reg-rest can not be detected.

2015-06-24 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/ralloc.c:
	  Fix bug #2389.
	* src/SDCCglue.c,
	  src/SDCCmain.c,
	  src/SDCCutil.c,
	  src/SDCCutil.h:
	  Remove build date from version string to make reproducible builds easier.

2015-06-24 Maarten Brock <sourceforge.brock AT dse.nl>

	* Small Device C Compiler 3.5.0 released
	* .version, doc/sdccman.lyx: changed sdcc version to 3.5.1

2015-06-20 Maarten Brock <sourceforge.brock AT dse.nl>

	* support/scripts/gen_known_bugs.pl: fixed by Raphael Neider for changed
	  SourceForge pages

2015-06-18 Maarten Brock <sourceforge.brock AT dse.nl>

	* .version,
	* doc/INSTALL.txt,
	* doc/sdccman.lyx: version 3.5.0

2015-06-18 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/SDCCmain.c (preProcess): reverted removal of SDCC macro
	* src/stm8/gen.c (genLeftShiftLiteral): hushed a compiler warning
	* support/regression/tests/gcc-torture-execute-960218-1.c,
	* support/regression/tests/gcc-torture-execute-20030913-1.c: renamed test()
	  to prevent double testing, renamed glob to prevent name conflict	
	* support/scripts/sdcc.nsi: removed dedication to Borut Razem

2015-06-09 Maarten Brock <sourceforge.brock AT dse.nl>

	* support/scripts/repack_release.sh: changed mac osx snapshot source,
	  forced uploading to directories

2015-06-07 Philipp Klaus Krause <pkk AT spth.de>

	* doc/sdccman.lyx:
	  Add section on the use of --allow-unsafe-reads on Z80-based systems.

2015-06-06 Maarten Brock <sourceforge.brock AT dse.nl>

	* .version,
	* doc/INSTALL.txt,
	* doc/sdccman.lyx: version 3.5.0 rc1
	* sdcc.spec: version 3.5.0
	* device/lib/pic14/libsdcc/idata.c: cosmetics
	* support/regression/tests/bug-2274.c: prevented double testing by rename
	* support/regression/tests/gcc-torture-execute-stdarg-5.c: no ASSERT(0)

2015-06-05 Philipp Klaus Krause <pkk AT spth.de>

	* doc/sdccman.lyx,
	  src/SDCCglobl.h,
	  src/SDCClospre.cc,
	  src/SDCCmain.c:
	  Use more generic name for option for unsafe reads.

2015-05-23 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCast.c:
	* src/SDCCglue.c:
	  Support initialization of char array in form 'char arr[] = {"abc"};'.
	* support/regression/tests/bug-2059.c:
	  Add a new test case.

2015-05-21 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCsymt.c:
	  Remove useless code.
	* support/regression/tests/bug-2384.c:
	  Add a new test case.

2015-05-19 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/bug-1918.c:
	  Add a new test case.

2015-05-17 Maarten Brock <sourceforge.brock AT dse.nl>

	* doc/clean.mk: remove *.eps
	* doc/Makefile.in: use dvipdfm instead of pdflatex to enable svg graphics
	* configure.in,
	* configure: require latex and dvipdfm for building doc

2015-05-17 Ben Shi <powerstudio1st AT 163 DOT com>

	* sdas/linksrc/lklex.c:
	  Check illegal object files.

2015-05-15 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCC.y:
	  Fix a potential bug in simplification of nested '*' and '&' in AST.

2015-05-14 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCC.y:
	  simplify nested '&' and '*' in AST.
	* support/regression/tests/bug-2381.c:
	  Add a new test case.

2015-05-13 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCerr.c:
	* src/SDCCerr.h:
	* src/SDCCsymt.c:
	* src/SDCCsymt.h:
	  Add a new warning for duplicate specifiler in c89.

2015-05-08 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCC.y: Turn off warning 219 for declaration (with extern) while keep
	  for definition (without extern).
	* support/regression/tests/bug-2102.c:
	  Improve test case.

2015-05-06 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCC.y: Do not warn if a variable of a struct with a flexible array is
	  declared with extern.
	* src/SDCCerr.c:
	  Change text message of warning 219.
	* support/regression/tests/bug-2102.c:
	  Supress warning 219 and improve test case.
	* support/regression/tests/bug-2274.c:
	  Supress warning 84.

2015-05-04 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/bug-2102.c:
	  Add a new test case.
	* src/SDCCerr.c:
	* src/SDCC.y:
	  Rise warning 219 for creating an instance of a struct with a flexible array.
	* src/SDCCsymt.c:
	  Remove useless code.

2015-05-04 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCC.y:
	  Fix a bug in macro __func__ substitution.

2015-05-03 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/lib/_calloc.c: removed unused struct declarations
	* device/lib/pic16/libc/stdio/vfprintf.c: fixed warnings
	* src/SDCC.y: disabled W_ANONYMOUS_MEMBER
	* src/SDCCsymt.c (compStructSize): disabled W_FLEXARRAY_INSTRUCT
	* src/z80/main.c: fixed gbz80_port peephole pointers, and
	* src/ds390/main.c,
	* src/mcs51/main.c,
	* src/stm8/main.c: added peephole null-pointers, unified layout
	* src/stm8/ralloc.c (stm8_assignRegisters): fixed warning
	* support/regression/tests/bug-2320.c: fixed warning

2015-05-01 Ben Shi <powerstudio1st AT 163 DOT com>

	* sdas/linksrc/lkar.c:
	* sdas/linksrc/lklib.c:
	* sdas/linksrc/lksdcclib.c:
	* src/SDCCmain.c:
	  Remove useless code for Cygwin.
	* support/sdbinutils/bfd/config.bfd:
	* sim/ucsim/cmd.src/cmdutil.cc:
	  Support Cygwin64.

2015-04-29 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/gcc-torture-execute-20001011-1.c:
	  Enabled.
	* support/cpp/libcpp/macro.c:
	* support/cpp/libcpp/include/cpplib.h:
	* support/cpp/libcpp/init.c:
	* src/SDCC.y:
	  Support macro __func__.

2015-04-22 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/peeph-z80.def:
	  Better peephole interaction for early ret statements in functions.

2015-04-22 Ben Shi <powerstudio1st AT 163 DOT com>

	* Makefile.common.in:
	* configure:
	* configure.in:
	* support/regression/Makefile.in:
	* support/regression/ports/ds390/spec.mk:
	* support/regression/ports/hc08/spec.mk:
	* support/regression/ports/mcs51-common/spec.mk:
	* support/regression/ports/pic14/spec.mk:
	* support/regression/ports/pic16/spec.mk:
	* support/regression/ports/s08/spec.mk:
	* support/regression/ports/stm8/spec.mk:
	* support/regression/ports/ucgbz80/spec.mk:
	* support/regression/ports/ucr2k/spec.mk:
	* support/regression/ports/ucr3ka/spec.mk:
	* support/regression/ports/ucz180/spec.mk:
	* support/regression/ports/ucz80/spec.mk:
	* support/valdiag/Makefile.in:
	  Auto detect python in $PATH.
	* support/regression/tests/z88dk.c:
	  Fix build error in reversion #9218.

2015-04-22 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/peep.c,
	  support/regression/tests/bug-2376.c:
	  Fix peephole optimizer bug #2376.

2015-04-21 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCpeeph.c,
	  src/port.h,
	  src/z80/main.c,
	  src/z80/gen.c,
	  src/z80/peep.h,
	  src/z80/peep.c,
	  src/z80/peeph-z80.def:
	  Fix peephole optimizer bug #2374, more efficient calls to _Noreturn
	  functions.

2015-04-20 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c,
	  src/z80/peep.c,
	  support/regression/tests/z88dk.c:
	  Fix peephole optimizer bug #2371.

2015-04-19 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCglobl.h:
	  Silence warning.
	* src/z80/gen.c,
	  device/lib/*/__sdcc_call_hl.s,
	  device/lib/*/__sdcc_call_iy.s,
	  src/SDCCsymt.c:
	  Better handling of calls through function pointers.

2015-04-18 Ben Shi <powerstudio1st AT 163 DOT com>

	* sim/ucsim/configure.in:
	* sim/ucsim/configure:
	* sim/ucsim/packages_in.mk:
	  Do not build disabled ports.

2015-04-17 Ben Shi <powerstudio1st AT 163 DOT com>

	* sdas/linksrc/Makefile.in:
	  Fix the issue that "make install" of sdld* failed on Windows.

2015-04-16 Ben Shi <powerstudio1st AT 163 DOT com>

	* device/include/Makefile.in:
	  Fix the problem that the header files of ds400 are not installed.
	* sdas/linksrc/Makefile.in:
	  Do not install unnecessary sdld* for disabled ports.

2015-04-15 Ben Shi <powerstudio1st AT 163 DOT com>

	* Makefile.common.in:
	* Makefile.in:
	  Partially fix bug #2369.
	* configure:
	* configure.in:
	* device/lib/Makefile.in:
	* src/ds400/Makefile.in:
	* src/ds400/main.c:
	* src/ds400/main.h:
	  Delete the empty stuff src/ds400/ .
	* support/regression/tests/z88dk.c:
	  Fix compiling errors.

2015-04-14 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCC.lex,
	  src/SDCC.y,
	  src/SDCCsymt.h,
	  src/z80/main.c,
	  src/z80/gen.c,
	  support/regression/tests/z88dk.c:
	  Support for __z88dk_callee calling convention on the caller side.

2015-04-11 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/scripts/sdcc.nsi:
	  Remove savr which is disabled by default.

2015-04-10 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/z88dk.c:
	  Fix bug number in comment.

2015-04-10 Ben Shi <powerstudio1st AT 163 DOT com>

	* debugger/mcs51/configure:
	* debugger/mcs51/Makefile.in:
	* debugger/mcs51/configure.in:
	* sim/ucsim/st7.src/Makefile.in:
	* sim/ucsim/z80.src/Makefile.in:
	* sim/ucsim/stm8.src/Makefile.in:
	* sim/ucsim/xa.src/Makefile.in:
	* sim/ucsim/s51.src/Makefile.in:
	* sim/ucsim/avr.src/Makefile.in:
	* sim/ucsim/hc08.src/Makefile.in:
	* sim/ucsim/configure:
	* sim/ucsim/Makefile.in:
	* sim/ucsim/configure.in:
	  Support --program-prefix and --program-suffix.

2015-04-09 Philipp Klaus Krause <pkk AT spth.de>

	* device/include/ctype.h,
	  device/lib/isblank.c:
	  Faster isblank().
	* device/include/stdlib.h,
	  device/lib/atoi.c,
	  device/lib/atol.c,
	  device/lib/atoll.c,
	  device/lib/incl.mk,
	  device/lib/make51lib.bat,
	  support/regression/tests/ato.c:
	  Faster and shorter atoi(), atol(), implemented atoll().
	* src/SDCC.lex,
	  src/SDCC.y,
	  src/SDCCsymt.h,
	  src/port.h,
	  src/SDCCerr.h,
	  src/SDCCerr.c,
	  src/*/main.c,
	  src/z80/gen.c,
	  src/z80/ralloc2.cc,
	  support/regression/tests/z88dk.c:
	  Support for __z88dk_fastcall calling convention.
	* src/stm8/peeph.def:
	  Use relative jump on false instruction for optimizing jumps over 1-byte
	  opcodes.

2015-04-06 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/bug-2368.c:
	  Try to fix the failure in "make test-host" on sparc64-solaris.

2015-04-03 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCerr.c:
	* src/SDCCerr.h:
	* src/SDCCast.c:
	  Add a warning for inline __naked functions.

2015-04-02 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCutils.h:
	* src/SDCCutils.c:
	* src/SDCCmain.c:
	  Support --program-prefix and --program-suffix while calling assembler and
	  linker.
	* src/z80/gen.c:
	* src/z80/mapping.i:
	* src/SDCCasm.c:
	  Add new "globalfunctionlabel".
	* sdas/linksrc/Makefile.in:
	  Fix a spot in 'make install'.

2015-04-01 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCnaddr.hpp,
	  src/SDCCnaddr.cc:
	  Dump tree decomposition used for address space switching on --dump-graphs.

2015-04-01 Ben Shi <powerstudio1st AT 163 DOT com>

	* sdas/as6808/Makefile.in:
	* sdas/as8051/Makefile.in:
	* sdas/as8xcxxx/Makefile.in:
	* sdas/asgb/Makefile.in:
	* sdas/asrab/Makefile.in:
	* sdas/asstm8/Makefile.in:
	* sdas/astlcs90/Makefile.in:
	* sdas/asz80/Makefile.in:
	* sdas/linksrc/Makefile.in:
	* src/Makefile.in:
	* support/cpp/Makefile.in:
	* support/librarian/Makefile.in:
	* support/makebin/Makefile.in:
	* support/packihx/Makefile.in:
	  Fix a bug of --program-suffix on Win32 / Win64.

2015-03-31 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c,
	  support/regression/tests/bug-2368.c:
	  Fixed bug #2368.

2015-03-27 Ben Shi <powerstudio1st AT 163 DOT com>

	* sdas/as6808/Makefile.in:
	* sdas/as8051/Makefile.in:
	* sdas/as8xcxxx/Makefile.in:
	* sdas/asgb/Makefile.in:
	* sdas/asrab/Makefile.in:
	* sdas/asstm8/Makefile.in:
	* sdas/astlcs90/Makefile.in:
	* sdas/asz80/Makefile.in:
	* sdas/linksrc/Makefile.in:
	* src/Makefile.in:
	* support/cpp/Makefile.in:
	* support/librarian/Makefile.in:
	* support/makebin/Makefile.in:
	* support/packihx/Makefile.in:
	* support/scripts/Makefile.in:
	  Support --program-prefix and --program-suffix.

2015-03-26 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/sdbinutils/libiberty/Makefile.in:
	  Disable make install.
	* support/sdbinutils/binutils/Makefile.in:
	* support/sdbinutils/Makefile.in:
	  Support make uninstall.
	* device/non-free/lib/Makefile.in:
	  Apply patch #245 by David Grayson.

2015-03-24 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/peeph-z80.def:
	  Peepholes for optimizing jump on decrement.

2015-03-20 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCglue.c:
	  Improve error messages.

2015-03-19 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCglue.c:
	  Fix a bug in a global char array initialized by a string.
	* src/SDCCast.c:
	  Fix a bug in a local static global array initialization.
	* support/regression/tests/bug-1953.c:
	  Improve test case.
	* doc/sdccman.lyx:
	  Suggest msys while build SDCC with VS2010.

2015-03-16 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c:
	  Fix bug #2288.

2015-03-13 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/lib/z80/crt0.s: cosmetics
	* sdas/asstm8/sdasstm8.vcxproj,
	* sdas/asstm8/sdasstm8.vcxproj.filters: new, added
	* sdcc.sln: added sdasstm8

2015-03-12 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCerr.c:
	* src/SDCCerr.h:
	* src/SDCC.y:
	  Add a new warning: anonymous member in struct/union.

2015-03-11 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCval.c:
	* src/SDCCglue.c:
	  Add a new special case in pointer initialization.
	* support/regression/tests/gcc-torture-execute-const-addr-expr-1.c:
	  Enabled.
	* support/regression/test-1898.c:
	  Add a new test case.

2015-03-06 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCsymt.c:
	* src/SDCCerr.h:
	* src/SDCCerr.c:
	  Add a warning for a flexible array in a struct.

2015-02-25 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Speed up stm8 port by skipping output early in dry runs and making some
	  aop tests more efficient,
	  fix code generation bug in shifts.

2015-02-25 Ben Shi <powerstudio1st AT 163 DOT com>

        * support/regression/tests/bug-2031.c:
          Add a new test case.
        * src/SDCCglue.c:
        * src/SDCCval.c:
        * src/SDCCval.h:
        * pic16/glue.c:
          Enable a global char/int/long variable initialized by an address
		  (const pointer).

2015-02-24 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Fix bug in stm8 comparison code generation.

2015-02-23 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/bug-2357.c:
	  Improve this test case.

2015-02-22 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c,
	  src/z80/main.c:
	  Improve z88dk compability (patch provided by z88dk).

2015-02-20 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/bug-2357.c:
	  A new test case.
	* support/regression/tests/gcc-torture-execute-20000412-1.c:
	  Enabled.
	* src/SDCCerr.c:
	  Change E_CODE_NO_INIT from an error to a warning.
	* src/SDCCast.c:
	  Fix a bug in selecting type of an array index.

2015-02-17 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/bug-1953.c:
	  Disable failed tests.

2015-02-16 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCast.c:
	  Fix a bug in char array initialization with string.
	* support/regression/tests/bug-1953.c:
	  Add a new test case.
	* support/regression/tests/gcc-torture-execute-20000801-4.c:
	  Enabled.

2015-02-13 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCglue.c:
	  Make pointers (of a struct) initialization more generaic.
	* support/regression/tests/bug-2123.c:
	  Add more tests.

2015-02-11 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCglue.c:
	  Improve pointer initialization.
	* support/regression/tests/bug-2123.c:
	  Add a new test case for bug #2123.

2015-02-08 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCval.c:
	  Allow type cast in function pointer initialization.
	* support/regression/tests/bug-2124.c:
	  Add a new test case for bug #2124.

2015-02-06 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/SDCCtree_dec.hpp:
	  Fix bug in weight calculation that affected tree-decompositions with
	  imbalanced nested branches.
	* src/z80/peeph-gbz80.def:
	  Fix handling of (hl-), (hl+) in peepholes.

2015-02-05 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/z80/mappings.i:
	  Fix gbz80 function entry helper.
	* src/SDCCralloc.hpp:
	  Use weight mechanism for deciding which subtree to process first - should
	  reduce memory consumption and improve the heuristic in the register
	  allocator.

2015-02-05 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* doc/Makefile.in: copy *.svg graphic files when using VPATH too

2015-02-04 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* device/lib/*/crtcall.s,
	  device/lib/*/crtenters,
	  device/lib/*/Makefile.in,
	  src/z80/gen.c,
	  src/z80/mappings.i,
	  src/z80/peep.c:
	  Fix name of helper function for function pointers, introduce Alan Cox'
	  proposal for helper function for function header.

2015-02-02 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCast.c:
	  Add check for infinite recursive call of copyAst().

2015-01-30 Philipp Klaus Krause <pkk AT spth.de>

	* doc/sdccman.lyx:
	  Fix references to obsolete keywords.

2015-01-29 Philipp Klaus Krause <pkk AT spth.de>

	* doc/sdccman.lyx:
	  Reorganize documentation of language extensions, in particular named
	  address spaces, separate mcs51isms, remove references to obsolete keywords.

2015-01-28 Philipp Klaus Krause <pkk AT spth.de>

	* doc/sdccman.lyx:
	  Update documentation on C dialect selection.

2015-01-27 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCsymt.c:
	  Fix bug #2349.
	* support/regression/test/bug-2349.c:
	  Add a new test for bug #2349.

2015-01-27 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCC.lex,
	  src/SDCC.y,
	  src/SDCCmem.c,
	  src/SDCCsymt.h,
	  src/stm8/main.c:
	  Apply patch by Pascal for trap handlers.

2015-01-24 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/stm8/gen.c:
	  Fix a bug in genPointerGet(): negative offset is not handled correctly.
	* support/regression/test/bug-2239.c:
	  More tests are added and enabled for stm8.

2015-01-24 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCast.c:
	  Fix bug #2239.
	* support/regression/test/bug-2239.c:
	  Add a new test for bug #2239.

2015-01-20 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCmain.c,
	  .version:
	  Make sdcc dialect of C99 the default.

2015-01-19 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/z80/ralloc.c,
	  src/mcs51/ralloc.c:
	  Fix register packing inline asm interaction bugs #2346, #2268.

2015-01-09 Philipp Klaus Krause <pkk AT spth.de>

	* doc/sdccman.lyx:
	  Classification macros are not required in freestanding implementations.

2015-01-08 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCC.y:
	  Fix a bug which might be a NULL pointer access.
	* device/lib/time.c:
	  Eliminate a warning. (overflow in implicit constant conversion)

2015-01-06 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCast.c:
	  Fix bug #2167 & #1967. (auto struct variables initialization)
	* support/regression/tests/gcc-torture-execute-960326-1.c:
	  Add more test cases.
	* support/regression/tests/gcc-torture-execute-20050613-1.c:
	* support/regression/tests/gcc-torture-execute-20030408-1.c:
	  Enable test.

2015-01-01 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCval.c:
	  Make SDCC_VERY_PEDANTIC default, if --less-pedantic is not specified.

2014-12-30 Maarten Brock <sourceforge.brock AT dse.nl>

	* doc/sdccman.lyx: fixed typo, webdoc #69, thanks Petr Petyovsky
	* sdas/linksrc/aslink.h: added include "sdccconf.h" or "sdcc_vc.h"
	* sdas/linksrc/lkar.c: removed include "sdccconf.h"

2014-12-29 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/include/pic16/limits.h,
	* device/lib/_divsint.c,
	* device/lib/_divslong.c,
	* device/lib/_divuint.c,
	* device/lib/_divulong.c,
	* device/lib/_memset.c,
	* device/lib/_modsint.c,
	* device/lib/_modslong.c,
	* device/lib/_moduint.c,
	* device/lib/_modulong.c,
	* device/lib/_mulint.c,
	* device/lib/_mullong.c,
	* device/lib/hc08/_divuint.c,
	* device/lib/hc08/_divulong.c,
	* device/lib/pic16/libm/asincosf.c,
	* device/lib/pic16/libm/atanf.c,
	* device/lib/pic16/libm/logf.c,
	* device/lib/s08/_divuint.c,
	* device/lib/s08/_divulong.c: replaced deprecated predefined macros
	* device/lib/pic16/libio/i2c/i2copen.c: idem to fix bug 2336
	* src/SDCCast.c (ast_print),
	* src/SDCCicode.c (dbuf_printOperand): fixed warnings
	* support/regression/tests/bug-2313.c: fixed warning

2014-12-29 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/bug-2320.c:
	  Fix test for host.

2014-12-28 Philipp Klaus Krause <pkk AT spth.de>

	* device/include/stdio.h:
	  Fix bug #2338.

2014-12-27 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/ralloc2.cc,
	  support/regression/tests/bug-2320.c:
	  Fixed bug #2320.

2014-12-24 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/pic14/gen.c (aopOp): fix typo in previous commit

2014-12-23 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/stm8/gen.c (aopOp),
	* src/z80/gen.c (aopOp),
	* src/hc08/gen.c (aopOp),
	* src/mcs51/gen.c (aopOp),
	* src/ds390/gen.c (aopOp),
	* src/pic16/gen.c (pic16_aopOp),
	* src/pic14/gen.c (aopOp): only use spill location if isspilt set

2014-12-22 Philipp Klaus Krause <pkk AT spth.de>

	* doc/sdccman.lyx:
	  Cleanup manual.

2014-12-22 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/longlong.c:
	  Modify test cases for large signed / unsigned long long.

2014-12-21 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCmain.c,
	  src/pic14/main.c,
	  src/pic16/main.c,
	  doc/sdccman.lyx,
	  .version:
	  Remove obsolete feature macros.

2014-12-21 Ben Shi <powerstudio1st AT 163 DOT com>

	* src/SDCCast.c:
	  Make AST dump more clear.
	* src/SDCCval.c:
	* src/SDCCval.h:
	* src/SDCCicode.c:
	* src/SDCCcse.c:
	* src/SDCCast.c:
	* src/SDCCglue.c:
	* src/pic16/SDCCglue.c:
	  make valFromLiteral() more accurate by a new unsigned long long parameter.
	* support/regression/tests/longlong.c:
	  Add new test cases for large unsigned long long.

2014-12-19 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/longlong.c:
	  Enable more test cases.
	* src/SDCCast.c:
	* src/SDCCicode.c:
	  Fix a bug: higher 4 bytes of a longlong literal are missing while dumping.
	* src/SDCCval.c:
	  Fix a bug: higher 4 bytes of a longlong value are discarded while casting
	  from a double value.

2014-12-16 Philipp Klaus Krause <pkk AT spth.de>

	* configure.in,
	  doc/Makefile.in:
	  Remove dependency on pdfopt.
	* support/regression/tests/bug-2313.c:
	  Regression test for bug #2313.

2014-12-13 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/pic16/libc/string/strncpy.c,
	  support/regression/tests/bug-2231.c:
	  Fix strncpy() in pic16. Patch by Diego Herranz.

2014-12-12 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/SDCCcse.c (ifxOptimize): fixed bugs #2313/2330

2014-12-04 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/gcc-torture-execute-20080529-1.c,
	  support/regression/tests/longlong.c:
	  Disable tests that fail due to broken gbz80 long long multiplication
	  (bug #2329).
	* support/regression/tests/bug-2231.c,
	  support/regression/tests/float_single.c,
	  support/regression/tests/gcc-torture-execute-stdarg-4.c,
	  support/regression/tests/gcc-torture-execute-stdarg-5.c,
	  support/regression/tests/vaargs.c:
	  Disable failing tests for pic16.

2014-12-03 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/gcc-torture-execute-950511-1.c:
	  Disabled. Since it fails on FreeBSD.

2014-12-02 Ben Shi <powerstudio1st AT 163 DOT com>

	* support/regression/tests/gcc-torture-execute-20050826-1.c:
	* support/regression/tests/gcc-torture-execute-950511-1.c:
	  Enabled for stm8.

2014-12-02 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/_mullonglong.c,
	  support/regression/tests/longlong.c:
	  Make long long multiplication independent of endianness.

2014-12-02 Ben Shi <powerstudio1st AT 163 DOT com>

	* sim/ucsim/stm8.src/stm8.cc:
	  Make stack larger, since some test cases cost large stack space.

2014-12-02 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/ralloc.c,
	  src/z80/ralloc.c:
	  Do not try to use spill locations that are not on the stack in ports that
	  can't handle it.
	* support/regression/tests/longlong.c:
	  Enable some long long tests that pass for stm8 now.

2014-12-01 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCsymt.c:
	  Initialize usl.spillLoc to help track down spill location issues.
	* src/stm8/ralloc.c:
	  Minor cleanup.

2014-11-30 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* configure.in,
	* configure,
	* sdccconf_h.in,
	* sdas/linksrc/lkar.c: Use configure to detect system strndup()
	  (alternate fix for bugs #2310 and #2303)
	* sdas/linksrc/Makefile.in: Removed -std=c99; it caused problems with
	  mingw32 build

2014-11-29 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/include/ctype.h: compare as unsigned chars, added static asserts on
	  EOF
	* device/lib/isdigit.c,
	* device/lib/islower.c,
	* device/lib/isupper.c: include stdio.h to enable the static assert in ctype.h
	* support/regression/tests/gcc-torture-execute-20050613-1.c: split up ASSERTs

2014-11-23 Molnar Karoly <molnarkaroly AT users.sf.net>

	* device/include/pic14/pic14devices.txt:
	  Bugfix, thanks to Franz.

2014-11-23 Ben Shi <powerstudio1st AT 163.com>

	* support/regression/tests/bug-2304.c:
	  Improve this test case.
	* sdas/linksrc/lkmain.c:
	  Add bound check.

2014-11-22 Ben Shi <powerstudio1st AT 163.com>

	* src/stm8/peep.c:
	  Fix potential bugs.

2014-11-22 Ben Shi <powerstudio1st AT 163.com>

	* src/SDCCpeeph.c:
	  Add function notSimilar().
	* src/stm8/peep.c:
	  Make notUsed() more aggressive.
	* src/stm8/peeph.def:
	  Add more rules.

2014-11-21 Philipp Klaus Krause <philipp@informatik.uni-frankfurt.de>

	* src/stm8/main.c:
	  Comment expaining why we can't use the byte at 0 in C.

2014-11-21 Ben Shi <powerstudio1st AT 163.com>

	* device/lib/stm8/heap.s:
	* device/lib/stm8/Makefile.in:
	  Add support for heap operation.
	* support/regression/tests/gcc-torture-execute-920810-1.c:
	* support/regression/tests/malloc:
	  enable test cases which use malloc().

2014-11-19 Ben Shi <powerstudio1st AT 163.com>

	* sdas/linksrc/aslink.h:
	  Change PATH_MAX to a proper value on x86_64, for bug #2316.

2014-11-18 Philipp Klaus Krause <pkk AT spth.de>

	* device/include/iso646.h,
	  support/regression/tests/iso646.c:
	  Fixed bug #2314.

2014-11-15 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/gcc-torture-execute-pr40057.c:
	  Disable test for host, since it fails on NetBSD.

2014-11-14 Philipp Klaus Krause <pkk AT spth.de>

	* support/sdbinutils/bfd/configure,
	  support/sdbinutils/bfd/warning.m4,
	  support/sdbinutils/binutils/configure:
	  Fixed bug #2280 by disabling -Werror.
	* sdas/linksrc/Makefile.in:
	  Fixed bugs #2310 and #2303.
	* support/regression/tests/gcc-torture-execute-20031012-1.c:
	  Disable test that fails on MacOS.

2014-11-13 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* support/regression/tests/gcc-torture-execute-pr42544.c:
	  Disable test for host, since it fails on Solaris.

2014-11-11 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/longlong.c:
	  Disable test that fails on 32-bit hosts.

2014-11-10 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/ralloc.c,
	  src/z80/gen.c,
	  src/stm8/ralloc.c,
	  src/stm8/gen.c,
	  support/regression/tests/longlong.c:
	  Implement unused long long return values.

2014-11-09 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/ralloc2.cc:
	  Fix a long long register allcoation issue.
	* support/regression/tests/gcc-torture-execute-950511-1.c:
	  Disable test that fails on 32-bit hosts.

2014-11-08 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/longlong.c,
	  support/regression/tests/gcc-torture-execute-950512-1.c:
	  Disabled test, since it fails on 32-bit hosts.

2014-11-07 Philipp Klaus Krause  <pkk AT spth.de>

	* device/lib/_modslonglong.c,
	  device/lib/_modulonglong.c,
	  device/lib/Makefile.in,
	  device/lib/*/Makefile.in,
	  doc/sdccman.lyx:
	  Implement % for long long and unsigned long long.
	* doc/Makefile.in:
	  More sensible error behaviour when building documentation.
	* src/SDCCval.c,
	  src/SDCCerr.c:
	  Only warn about long long constants for large values.
	* device/lib/_mullonglong.c:
	  Fix long long multiplication.
	* support/regression/tests/*.c:
	  Enable some long long regression test that pass now.

2014-11-06 Philipp Klaus Krause  <pkk AT spth.de>

	* src/z80/gen.c:
	  More efficient assignment of literals to 16-bit globals and statics.

2014-11-06 Philipp Klaus Krause  <pkk AT spth.de>

	* src/z80/gen.c,
	  support/regression/tests/bug-2306.c:
	  Fixed bug #2306.

2014-11-06 Philipp Klaus Krause  <pkk AT spth.de>

	* src/z80/gen.c,
	  support/regression/tests/bug-2304.c:
	  Fixed bug #2304.
	* src/z80/ralloc.c,
	  support/regression/tests/bug-2305.c:
	  Fixed bug #2305.

2014-10-29 Philipp Klaus Krause  <pkk AT spth.de>

	* support/regression/tests/bug-2254.c:
	  Regression test for bug #2254.

2014-10-22 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Spelling fix inspired by Debian patch 02_fix_spelling.

2014-10-22 Ben Shi <powerstudio1st AT 163.com>

	* device/lib/stm8/Makefile.in:
	* device/stm8/_modslong.s:
	* device/stm8/_divslong.s:
	  Optimized mod & div of signed long.

2014-10-17 Ben Shi <powerstudio1st AT 163.com>

	* device/lib/stm8/Makefile.in:
	* device/stm8/_modulong.s:
	* device/stm8/_divulong.s:
	  Optimized according to their c origination.

2014-10-14 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c:
	  Improve error messages for unimplemented unused return value.

2014-10-14 Ben Shi <powerstudio1st AT 163.com>

	* device/stm8/_modsint.s:
	* device/stm8/_mullong.s:
	  Optimized with more efficient instructions.
	* device/stm8/_mulint.s:
	  Reformat to more readable.

2014-10-13 Philipp Klaus Krause <pkk AT spth.de>

	* device/stm8/_divsint.s:
	  Optimized signed division.

2014-10-11 Ben Shi <powerstudio1st AT 163.com>

	* src/stm8/gen.c:
	  Delete temporary code stm_sub_func().
	* device/stm8/_modsint_stm8.s:
	* device/stm8/_mulint_stm8.s:
	* device/stm8/_divsint_stm8.s:
	* device/stm8/_mullong_stm8.s:
	  Deleted.
	* device/stm8/_modsint.s:
	* device/stm8/_mulint.s:
	* device/stm8/_divsint.s:
	* device/stm8/_mullong.s:
	  Added.
	* device/stm8/Makefile.in:
	  Use the above new added .s files.

2014-10-09 Ben Shi <powerstudio1st AT 163.com>

	* src/stm8/gen.c:
	  Add stm_sub_func() for future more stm8 optimized functions.
	* src/stm8/peeph.def:
	  Remove redundant rules.

2014-10-03 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/cinc2h.pl: Updated to the gputils-1.4.0 .

2014-09-29 Ben Shi <powerstudio1st AT 163.com>

	* device/lib/stm8/_mullong_stm8.s:
	* device/lib/stm8/Makefile.in:
	  stm8 optimized version of _mullong.
	* src/stm8/peeph.def:
	  add new rules to utilize the above optimized functions.

2014-09-25 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/peeph-gbz80.def:
	  Removed or simplification peepholes.

2014-09-24 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCopt.c:
	  Remove negation by inverting jump condition.
	* src/SDCCcse.c:
	  Remove cast at conditional jump.
	* device/include/ctype.h:
	  Simplify classification functions.

2014-09-24 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/SDCCsymt.c (mergeSpec): added check for both static and extern
	  (checkFunction): merge static or extern and check
	* device/include/ctype.h: replaced macros with direct inline versions
	* device/lib/isdigit.c,
	* device/lib/islower.c,
	* device/lib/isupper.c: replaced definitions with extern declaration to give
	  inline versions external linkage

2014-09-22 Ben Shi <powerstudio1st AT 163.com>

	* device/lib/stm8/_modsint_stm8.s:
	* device/lib/stm8/Makefile.in:
	  stm8 optimized version of _modsint.
	* src/stm8/peeph.def:
	  add new rules to utilize the above optimized functions.

2014-09-19 Ben Shi <powerstudio1st AT 163.com>

	* device/lib/stm8/_divsint_stm8.s:
	* device/lib/stm8/_mulint_stm8.s:
	* device/lib/stm8/Makefile.in:
	  stm8 optimized version of div / mul.
	* src/stm8/peeph.def:
	  add new rules to utilize the above optimized functions.

2014-09-19 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c:
	  Fixed double read from __sfr function parameter.

2014-09-17 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/pic14-header-parser.pl:
	  Creates two new groups: "regular", "enhanced"

	* support/scripts/pic16fam-h-gen.pl:
	  Divides into more groups the 14-bit processors:
		"adc", "ccp", "pwm", "i2c", "spi", "usart"

2014-09-17 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/pic14-header-parser.pl,
	  support/scripts/pic16-header-parser.pl:
	  updated

2014-09-15 Molnar Karoly <molnarkaroly AT users.sf.net>

	* device/non-free/include/pic14/*.inc,
	  device/non-free/lib/pic14/libdev/*.c:
	  updated

2014-09-13 Ben Shi <powerstudio1st AT 163.com>

	* src/stm8/main.c:
	  Make libstm8.lib is implicitly linked rather than explicitly designated.

2014-09-04 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl,
	  support/scripts/optimize_pic16devices.pl:
	  Updated unto the Perl 5.16 version.

2014-09-04 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/cinc2h.pl:
	  Updated unto the Perl 5.16 version.

2014-09-03 Ben Shi <powerstudio1st AT 163.com>

	* sdas/asstm8/stm8mch.c:
	  Fix the wrong code of the bit index in BTJF / BTJF.

2014-09-01 Molnar Karoly <molnarkaroly AT users.sf.net>

	* device/include/pic14/pic14devices.txt: Minor bugfix.

2014-08-30 Ben Shi <powerstudio1st AT 163.com>

	* support/regression/tests/gcc-torture-execute-pr28982a.c:
	* support/regression/tests/bug3475630.c:
	  Enabled on the stm8 port.

2014-08-29 Ben Shi <powerstudio1st AT 163.com>

	* support/regression/tests/gcc-torture-execute-pr47337.c:
	  Enable this test case on the stm8 port.

2014-08-20 Ben Shi <powerstudio1st AT 163.com>

	* device/lib/stm8/setjmp.s:
	  Substitute _CODE to CODE to conform with stm8's code generator.
	* sdas/linksrc/lkmain.c:
	  Revert to reversion 9059.

2014-08-18 Ben Shi <powerstudio1st AT 163.com>

	* support/regression/tests/setjmp.c:
	  Enabled for the stm8 port.
	* sdas/linksrc/lkmain.c:
	  Avoid generating invalid instructions on MacOS.

2014-08-17 Ben Shi <powerstudio1st AT 163.com>

	* support/regression/setjmp.c:
	  Disabled for the stm8 port.

2014-08-16 Ben Shi <powerstudio1st AT 163.com>

	* all.vcxproj:
	* support/scripts/sdcc.nsi:
	  Create a new sdldstm8 on Windows.
	* sdas/linksrc/Makefile.in:
	* Makefile.in:
	  Create a spereated sdldstm8 on Unix like.
	* src/stm8/main.c:
	* sdas/linksrc/sdld.c:
	* sdas/linksrc/sdld.h:
	  Let the stm8 port use sdldstm8 instead of sdld.

2014-08-12 Ben Shi <powerstudio1st AT 163.com>

	* sdcc/support/regression/tests/bug-2205.c:
	* sdcc/support/regression/tests/bug-971834.c:
	* sdcc/support/regression/tests/key.c:
	  Make Small changes to fit LLVM/CLANG for host test.

2014-08-10 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/hc08/gen.c (pushSide, genPcall): fixed bug with pointer
	  function call overwriting register parameter with function
	  address. Optimized constant function pointer case.

2014-08-06 Ben Shi <powerstudio1st AT 163.com>

	* sdas/linksrc/lkaomf51.c:
	  Add array bound check to avoid crash.

2014-07-30 Ben Shi <powerstudio1st AT 163.com>

	* sim/ucsim/st7.src/inst.cc:
	  Eliminate warnings.
	* support/regression/tests/gcc-torture-execute-930628-1.c:
	  Enable this case for the stm8 port.

2014-07-29 Ben Shi <powerstudio1st AT 163.com>

	* support/regression/tests/gcc-torture-execute-20030714-1.c:
	  Enable this case for the stm8 port.
	* src/stm8/gen.c:
	  Fix bug #2285: an error in genCast().

2014-07-22 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/optimize_pic16devices.pl,
	  device/include/pic16/pic16devices.txt:
	  Stronger optimization.

2014-07-21 Ben Shi <powerstudio1st AT 163.com>

	* support/regression/tests/gcc-torture-execute-stdarg-4.c:
	* support/regression/tests/gcc-torture-execute-stdarg-5.c:
	  Split the original gcc-torture-execute-stdarg-4.c to inline / non-inline.

2014-07-20 Ben Shi <powerstudio1st AT 163.com>

	* support/regression/tests/gcc-torture-execute-stdarg-4.c:
	* support/regression/tests/gcc-torture-execute-loop-2c.c:
	* support/regression/tests/gcc-torture-execute-unroll-1.c:
	  Add "static" to fit the C99 standard.

2014-07-19 Ben Shi <powerstudio1st AT 163.com>

	* support/regression/tests/gcc-torture-execute-20001121-1.c:
	  Add "static" to fit the C99 standard.

2014-07-15 Ben Shi <powerstudio1st AT 163.com>

	* src/stm8/peep.c
	  Make calculation of instructions' length more accurate.

2014-07-14 Molnar Karoly <molnarkaroly AT users.sf.net>

	* device/non-free/include/pic14/pic16f1yyy.h:
	  Added the missing DEBUG config option to the enhanced midrange MCUs.

2014-07-14 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* support/regression/tests/bug2084206.c:
	  Enable test, since #2198 is fixed.
	* support/regression/tests/gcc-torture-execute-20030714-1.c:
	  Reference bug #2285.

2014-07-12 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/cinc2h.pl: Bugfix and update.

	* device/non-free/include/pic14/pic16c433.h: bugfix

2014-07-12 Molnar Karoly <molnarkaroly AT users.sf.net>

	* device/include/pic14/pic14devices.txt,
	  device/include/pic14/pic16regs.h,
	  device/non-free/include/pic14/pic12lf1554.h,
	  device/non-free/include/pic14/pic12lf1559.h,
	  device/non-free/lib/pic14/libdev/devices.txt,
	  device/non-free/lib/pic14/libdev/pic12lf1554.c,
	  device/non-free/lib/pic14/libdev/pic12lf1559.c,
	  doc/sdccman.lyx:
	  New devices.

2014-07-11 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/stm8/gen.c:
	  Remove workarounds for bug #2198.

2014-07-09 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* sdas/linksrc/lkrloc3.c (adb_hi, adb_lo, relr3),
	  sdas/asxxsrc/asout.c (outrxb): back port some of ASxxxx 5.06 to
	  fix bug 2198

2014-07-08 Molnar Karoly <molnarkaroly AT users.sf.net>

	* device/non-free/include/pic14/pic1xxx.h,
	  device/non-free/lib/pic14/libdev/pic1xxx.c,
	  device/non-free/include/pic16/pic18fxxx.h,
	  device/non-free/lib/pic16/libdev/pic18fxxx.c:
	  updated

	* device/non-free/include/pic14/pic12f1571.h,
	  device/non-free/include/pic14/pic12f1572.h,
	  device/non-free/include/pic14/pic12f1612.h:
	  Added the missing _DEBUG_ON and _DEBUG_OFF config options.
	  (These Microchip bugs in original mpasmx includes.)

2014-07-07 Ben Shi <powerstudio1st AT 163.com>

	* sim/ucsim/stm8.src/inst.cc:
	  Unify all flag affection code to flag_cvh().

2014-07-06 Ben Shi <powerstudio1st AT 163.com>

	* sim/ucsim/stm8.src/inst.cc:
	  Merge inst_sub() to inst_sbc().

2014-07-03 Ben Shi <powerstudio1st AT 163.com>

	* sim/ucsim/stm8.src/inst.cc:
	  Fix potential bugs in inst_dec(), inst_inc() & inst_ldxy(): flags
	  affection.
	  Make inst_addw(), inst_clr() & inst_ldxydst() more understandable.
	* sim/ucsim/stm8.src/stm8.cc:
	  Fix potential bugs in CALLR & CALLF: the stack saved PC value is not
	  accurate.

2014-06-30 Ben Shi <powerstudio1st AT 163.com>

	* sim/ucsim/stm8.src/inst.cc:
	  Fix potential bugs in inst_adc() & inst_add() - flags affection.
	  Fix potential bugs in inst_sll() & inst_rlc() - reg.X & reg.Y might exceed
	  0xffff.
	* sim/ucsim/stm8.src/stm8.cc:
	  Improve code quality.

2014-06-25 Ben Shi <powerstudio1st AT 163.com>

	* sim/ucsim/stm8.src/inst.cc:
	  Fix potential bugs of flags affection in inst_sbc() and inst_cpw().
	* sim/ucsim/stm8.src/stm8.cc:
	  Fix potential bugs of flags affection in RLWA, and improve code quality of
	  TRAP.

2014-06-21 Ben Shi <powerstudio1st AT 163.com>

	* sim/ucsim/stm8.src/inst.cc:
	  Fix potential bugs of flags affection in inst_addw(), inst_sub() and
	  inst_cp().
	* sim/ucsim/stm8.src/stm8.cc:
	  Fix potential bugs of flags affection in simulation of RRWA.

2014-06-20 Ben Shi <powerstudio1st AT 163.com>

	* sim/ucsim/stm8.src/inst.cc:
	  Fix potential bugs of flags affection in inst_addw().

2014-06-17 Ben Shi <powerstudio1st AT 163.com>

	* sim/ucsim/stm8.src/inst.cc:
	  Make the comment more understandable, fix potential bugs in inst_jr().
	  (JRSGT / JRSLE / JRSGE / JRSLT)

2014-06-10 Ben Shi <powerstudio1st AT 163.com>

	* sim/ucsim/stm8.src/inst.cc:
	  Add indirect addressing handling in CLR, CPW & LD.
	  Fix potential bugs in get_dest().

2014-06-03 Philipp Klaus Krause <pkk AT spth.de>

	* sim/ucsim/stm8.src/inst.cc,
	  support/regression/tests/gcc-torture-execute-20021120-1.c:
	  Fix bug #2180 by applying patch #244 by Ben Shi.

2014-06-02 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/Makefile.in:
	  Fix non-standard end-of-line matching (makes device libraries compile on
	  OpenBSD).

2014-05-28 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Fix a bug in code generation for right shift by applying patch #243 by Ben
	  Shi.

2014-05-25 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/ralloc2.cc:
	  Fix complement bug #2275.

2014-05-22 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* sim/ucsim/stm8.src/stm8.cc:
	  Fix flag handling, patch by Ben Shi.
	* src/stm8/gen.c:
	  Enable some shift optimizations that need the flag handling fix.

2014-05-13 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/stm8/ralloc2.cc:
	  Fix detection of free regs for stm8.
	* src/stm8/gen.c:
	  Enable optimizations for bitwise and.

2014-05-08 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/SDCCcse.c:
	  More aggressive optimization of casts to bool following logic operations.

2014-05-04 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/mcs51/gen.c (saveRegisters, unsaveRegisters): fixed bug 1928,
	  (genXpush): small optimization
	* src/mcs51/peep.c (termScanAtFunc): fixed return value,
	  (scan4op: ret): fixed callee_saves
	* src/stm8/gen.c: MSVC is not C99 compliant
	* support/regression/tests/callee_saves.c: new, added

2014-04-30 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  More efficient float negation.

2014-04-30 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/ralloc2.cc,
	  src/stm8/gen.c:
	  More flexible register allocation of operands, fixed bug in intra-register
	  assignment.

2014-04-27 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Improve loading of literals to long globals.

2014-04-23 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/stm8/gen.c:
	  Fix overoptimistic stack coalescing estimate, clamp shifts.

2014-04-22 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/stm8/gen.c:
	  Improve arithmetic right shift.

2014-04-22 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/stm8/gen.c:
	  Various small fixes and improvements.
	* src/stm8/ralloc.c
	  Prepare for register packing for assignment.

2014-04-21 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/z80-disasm.pl: Disassembler for the z80 family.

2014-04-21 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Improve left shift by literal, preparations for patch #234.
	* device/lib/_mulint.c:
	  Speed up integer multiplication by using casts.

2014-04-21 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  More efficient clearing of high bytes of x and y, more efficient right
	  shift.
	* src/SDCCpeeph.c:
	  Better immdInRange, patch by Ben Shi.
	* src/stm8/peeph.def:
	  Peepholes to optimize stack adjustment.

2014-04-21 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/pic16fam-h-gen.pl: updated

2014-04-20 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c,
	  src/stm8/ralloc2.cc:
	  Improve bitwise and, improve choice of shift location.

2014-04-20 Molnar Karoly <molnarkaroly AT users.sf.net>

	* device/non-free/include/pic14/pic16fam.h:
	  Updated and moved here: device/include/pic14/pic16fam.h

2014-04-20 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCpeeph.c,
	  src/stm8/peeph.def:
	  Applied a variant of patch #237 by Ben Shi, implementing RFE #400.
	* src/stm8/gen.c:
	  Use mov for POINTER_SET where it makes sense.

2014-04-16 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/cinc2h.pl,
	  support/scripts/mcs51-disasm.pl,
	  support/scripts/optimize_pic16devices.pl,
	  support/scripts/pic14-header-parser.pl,
	  support/scripts/pic16-header-parser.pl:
	  Updated the copyright date.

2014-04-16 Molnar Karoly <molnarkaroly AT users.sf.net>

	* device/include/pic14/pic14devices.txt,
	  device/include/pic14/pic16regs.h,
	  device/non-free/include/pic14/pic12f1571.h,
	  device/non-free/include/pic14/pic12f1572.h,
	  device/non-free/include/pic14/pic12f1612.h,
	  device/non-free/include/pic14/pic16f1613.h,
	  device/non-free/include/pic14/pic16f1703.h,
	  device/non-free/include/pic14/pic16f1705.h,
	  device/non-free/include/pic14/pic16f1707.h,
	  device/non-free/include/pic14/pic16f1709.h,
	  device/non-free/include/pic14/pic16f1713.h,
	  device/non-free/include/pic14/pic16f1716.h,
	  device/non-free/include/pic14/pic16f1717.h,
	  device/non-free/include/pic14/pic16f1718.h,
	  device/non-free/include/pic14/pic16f1719.h,
	  device/non-free/lib/pic14/libdev/devices.txt,
	  device/non-free/lib/pic14/libdev/pic12f1571.c,
	  device/non-free/lib/pic14/libdev/pic12f1572.c,
	  device/non-free/lib/pic14/libdev/pic12f1612.c,
	  device/non-free/lib/pic14/libdev/pic16f1613.c,
	  device/non-free/lib/pic14/libdev/pic16f1703.c,
	  device/non-free/lib/pic14/libdev/pic16f1705.c,
	  device/non-free/lib/pic14/libdev/pic16f1707.c,
	  device/non-free/lib/pic14/libdev/pic16f1709.c,
	  device/non-free/lib/pic14/libdev/pic16f1713.c,
	  device/non-free/lib/pic14/libdev/pic16f1716.c,
	  device/non-free/lib/pic14/libdev/pic16f1717.c,
	  device/non-free/lib/pic14/libdev/pic16f1718.c,
	  device/non-free/lib/pic14/libdev/pic16f1719.c,
	  doc/sdccman.lyx:
	  New devices.

2014-04-13 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Fix for 32-bit host systems (bug #2267).

2014-04-12 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/*/Makefile.in,
	  device/lib/*/*.s,
	  src/z80/main.c:
	  Do not mangle support function names. Implements RFE #405.
	* src/stm8/gen.c:
	  More efficient comparisons, a modified version of patch #232 by Ben Shi.
	* sdas/asstm8/stm8mch.c:
	  Fix bit handling instructions, patch #239 by Pascal S.

2014-04-11 Maarten Brock <sourceforge.brock AT dse.nl>

	* Small Device C Compiler 3.4.0 released
	* .version, doc/sdccman.lyx: changed sdcc version to 3.4.1

2014-04-02 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/lib/pic16/debug/Makefile.in: regenerated

2014-04-02 Maarten Brock <sourceforge.brock AT dse.nl>

	* Makefile.common.in,
	* Makefile.in: manual edit

2014-04-02 Maarten Brock <sourceforge.brock AT dse.nl>

	* configure
	* debugger/mcs51/aclocal.m4
	* debugger/mcs51/configure
	* device/lib/pic14/aclocal.m4
	* device/lib/pic14/configure
	* device/lib/pic14/depcomp
	* device/lib/pic14/libm/Makefile.in
	* device/lib/pic14/libsdcc/enhanced-no-xinst/Makefile.in
	* device/lib/pic14/libsdcc/enhanced/Makefile.in
	* device/lib/pic14/libsdcc/regular/Makefile.in
	* device/lib/pic14/Makefile.in
	* device/lib/pic16/aclocal.m4
	* device/lib/pic16/configure
	* device/lib/pic16/depcomp
	* device/lib/pic16/install-sh
	* device/lib/pic16/libc/Makefile.in
	* device/lib/pic16/libio/Makefile.in
	* device/lib/pic16/libm/Makefile.in
	* device/lib/pic16/libsdcc/Makefile.in
	* device/lib/pic16/Makefile.in
	* device/lib/pic16/missing
	* device/lib/pic16/startup/Makefile.in
	* device/non-free/lib/pic14/configure
	* device/non-free/lib/pic16/aclocal.m4
	* device/non-free/lib/pic16/configure
	* device/non-free/lib/pic16/depcomp
	* device/non-free/lib/pic16/install-sh
	* device/non-free/lib/pic16/libdev/Makefile.in
	* device/non-free/lib/pic16/Makefile.in
	* device/non-free/lib/pic16/missing
	* sdccconf_in.h
	* sim/ucsim/aclocal.m4
	* sim/ucsim/configure
	* sim/ucsim/ltmain.sh
	* support/cpp/configure
	* support/packihx/configure: regenerated

2014-04-02 Maarten Brock <sourceforge.brock AT dse.nl>

	* configure.in,
	* Makefile.in: manual edit to support option --disable-non-free

2014-04-01 Maarten Brock <sourceforge.brock AT dse.nl>

	* doc/INSTALL.txt,
	* support/scripts/sdcc.nsi: added dedication to Borut Razem
	* doc/README.txt: added STM8 target support

2014-03-31 Philipp Klaus Krause <pkk AT spth.de>

	* Merged sdcc-stm8 branch into trunk.

2014-03-29 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/peeph.def:
	  Patch #233 by Pascal S, and further peepholes for improving io access.

2014-03-29 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c,
	  support/regression/tests/patch-235.c:
	  Fix a bug in long and long long right shift on stm8.

2014-03-28 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Improve ifx code generation.

2014-03-28 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c: Comment for range error check in aopIsLitVal(),
	  improve range checks in snprintf() calls,
	  prepare for refactored version of patch #232.

2014-03-22 Maarten Brock <sourceforge.brock AT dse.nl>

	* .version,
	* doc/INSTALL.txt,
	* doc/sdccman.lyx: version 3.4.0

2014-03-21 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c: Applied patch #227 by Ben Shi to fix jumping on float in y
	  and to speed up jumping on byte in yl.
	* device/lib/z80/setjmp.s:
	  Slightly more efficient longjmp().
	* device/lib/stm8/setjmp.s,
	  support/regression/tests/setjmp.c:
	  Implement setjmp() / longjmp() for stm8.
	* src/z80/ralloc2.cc: Allow use of hl in 16-bit additions with global
	  variables as long as de or bc is free.

2014-03-18 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* doc/sdccman.lyx:
	  Fix example in documentation on named address spaces in ROM.

2014-03-09 Molnar Karoly <molnarkaroly AT users.sf.net>

	* device/non-free/include/pic14/pic*.h,
	  device/non-free/include/pic16/pic18f*.h,
	  device/non-free/lib/pic14/libdev/pic*.c,
	  device/non-free/lib/pic16/libdev/pic18f*.c:
	  Regenerate the DEVICE.[ch] files with the cinc2h.pl program.

2014-03-03 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/SDCCpeeph.c (notVolatileVariable): fixed strchr params

2014-03-01 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/stm8/gen.c: retry to revert previous two changes

2014-02-28 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/stm8/gen.c: reverted previous two changes (not committed)
	* .version,
	* doc/INSTALL.txt,
	* doc/sdccman.lyx: version 3.4.0 rc1
	* sdcc.spec: version 3.4.0

2014-02-27 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Simplify and improve ifx code generation.

2014-02-27 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c: Applied patch #227 by Ben Shi to fix jumping on float in y
	  and to speed up jumping on byte in yl.

2014-02-23 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c: Applied patch #223 by Ben Shi to improve code size for
	  signed bit-fields on stm8.
	* src/stm8/main.c:
	  Applied patch #225 by Pascal S to enable naked functions for stm8.

2014-02-21 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/stm8/peeph.def: Applied patch #222 by Ben Shi (new peephole to make
	  shifts slightly more efficient).
	* src/stm8/gen.c:
	  Applied patch #221 by Ben Shi (fix some bugs in shifts).

2014-02-20 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/SDCCicode.c (geniCodeDivision): Fixed bug 2254

2014-02-19 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/stm8/gen.c:
	  Fix condition for shifting stack operands in a.

2014-02-19 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/stm8/gen.c:
	  Handle signed and unsigned 8-bit operands the same in destructive ifx and.

2014-02-17 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* support/regression/tests/bug-2253.c: reduce array size for
	  ports that do not support large local variables

2014-02-13 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/stm8/gen.c,
	  support/regression/tests/bug-2253.c:
	  Fix and improve division and multiplication, includes fix for #2253.

2014-02-12 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/stm8/gen.c,
	  support/regression/tests/bug-2252.c:
	  Fix bug #2252.
	* src/SDCCpeeph.c:
	  Fix notVolatile() for stm8.
	* src/stm8/peeph.def:
	  Add some peephole rules to eliminate unnecessary loads.

2014-02-09 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c
	  Slightly more efficient complement.

2014-02-08 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c: Fix jump on condition that is stored in register y in
	  reverse order (bug #2251).

2014-02-02 Philipp Klaus Krause <pkk AT spth.de>

	* sdas/asstm8/stm8mch.c,
	  src/stm8/gen.c:
	  Apply patch #215 by Ben Shi to fix bug #2227.
	* src/port.h,
	  sdas/asxxsrc/asmain.c:
	  Fix >= comparisons.

2014-01-12 Philipp Klaus Krause <pkk AT spth.de>

	* sdas/asstm8/stm8pst.c,
	  src/stm8/main.c:
	  Enable .optsdcc for stm8.

2014-01-03 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/SDCCast.c (ast_print): fixed GOTO, warn for undecorated

2014-01-03 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/lib/_gptrget.c,
	* device/lib/_gptrput.c,
	* src/ds390/main.c,
	* src/ds390/gen.c: renamed _ap to acc1, fixed bug 1896
	* support/regression/tests/gcc-torture-execute-loop-5.c: enabled for ds390
	* sdas/asxxsrc/aslex.c (nxtline): fixed bug 2166 and 2206
	* src/SDCClospre.hpp,
	* src/SDCCralloc.hpp: fixed MSVC warnings

2014-01-02 Maarten Brock <sourceforge.brock AT dse.nl>

	* doc/sdccman.lyx: applied patch 62
	* sdas/linksrc/lkarea.c (lnksect): fixed bug 1805
	* sdas/linksrc/lkmain.c (Areas51): use only for mcs51
	* src/hc08/main.c: mark XINIT as (CODE)

2013-12-30 Philipp Klaus Krause <pkk AT spth.de>

	* src/hc08/ralloc2.cc,
	  src/stm8/gen.c,
	  src/stm8/ralloc2.cc:
	  Remove some GETHBIT leftovers.

2013-12-30 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/mcs51/gen.c (genGetHbit): removed
	* src/mcs51/main.c (hasExtBitOp): removed GETHBIT
	* src/SDCCast.c (optimizeGetByte, optimizeGetWord): do not use GETYBTE or
	  GETWORD for byte or word sources
	  (createFunction): allow xstack==NULL
	* src/SDCCmem.c (redoStackOffsets): allow xstack==NULL
	* src/SDCCerr.c (W_CONST_TOO_LARGE): fixed format bug
	* src/SDCCerr.h: cosmetics
	* src/SDCCsymt.c (mergeSpec, checkSClass): fixed bug 2068, loss of register
	  storage class

2013-12-29 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/is*.c
	  Revert and redo commit #8912.

2013-12-27 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/SDCCglue.c (glue): added .optsdcc --all-callee-saves, fixed bug 2090
	* src/SDCCmain.c (preProcess): added -D__SDCC_ALL_CALLEE_SAVES
	* src/SDCCglobl.h: removed xa51 MODEL_PAGE0
	* doc/sdccman.lyx: documented predefined macro

2013-12-26 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* support/scripts/sdcc.nsi: copy either sjlj or seh support dll

2013-12-25 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/lib/abs.c,         device/lib/acosf.c,         device/lib/asincosf.c,
	* device/lib/asinf.c,       device/lib/atan2f.c,        device/lib/atanf.c,
	* device/lib/ceilf.c,       device/lib/cosf.c,          device/lib/coshf.c,
	* device/lib/cotf.c,        device/lib/expf.c,          device/lib/fabsf.c,
	* device/lib/floorf.c,      device/lib/frexpf.c,        device/lib/labs.c,
	* device/lib/ldexpf.c,      device/lib/log10f.c,        device/lib/logf.c,
	* device/lib/modff.c,       device/lib/powf.c,          device/lib/rand.c,
	* device/lib/sincosf.c,     device/lib/sincoshf.c,      device/lib/sinf.c,
	* device/lib/sinhf.c,       device/lib/sqrtf.c,         device/lib/tancotf.c,
	* device/lib/tanf.c,        device/lib/tanhf.c,
	* device/include/math.h: removed const from arguments

	* device/lib/pic14/libm/acosf.c,    device/lib/pic14/libm/asincosf.c,
	* device/lib/pic14/libm/asinf.c,    device/lib/pic14/libm/atan2f.c,
	* device/lib/pic14/libm/atanf.c,    device/lib/pic14/libm/ceilf.c,
	* device/lib/pic14/libm/cosf.c,     device/lib/pic14/libm/coshf.c,
	* device/lib/pic14/libm/cotf.c,     device/lib/pic14/libm/errno.c,
	* device/lib/pic14/libm/expf.c,     device/lib/pic14/libm/fabsf.c,
	* device/lib/pic14/libm/floorf.c,   device/lib/pic14/libm/frexpf.c,
	* device/lib/pic14/libm/ldexpf.c,   device/lib/pic14/libm/log10f.c,
	* device/lib/pic14/libm/logf.c,     device/lib/pic14/libm/modff.c,
	* device/lib/pic14/libm/powf.c,     device/lib/pic14/libm/sincosf.c,
	* device/lib/pic14/libm/sincoshf.c, device/lib/pic14/libm/sinf.c,
	* device/lib/pic14/libm/sinhf.c,    device/lib/pic14/libm/sqrtf.c,
	* device/lib/pic14/libm/tancotf.c,  device/lib/pic14/libm/tanf.c,
	* device/lib/pic14/libm/tanhf.c,
	* device/include/pic14/math.h: removed const from arguments

	* device/lib/pic16/libm/acosf.c,    device/lib/pic16/libm/asincosf.c,
	* device/lib/pic16/libm/asinf.c,    device/lib/pic16/libm/atan2f.c,
	* device/lib/pic16/libm/atanf.c,    device/lib/pic16/libm/ceilf.c,
	* device/lib/pic16/libm/cosf.c,     device/lib/pic16/libm/coshf.c,
	* device/lib/pic16/libm/cotf.c,     device/lib/pic16/libm/errno.c,
	* device/lib/pic16/libm/expf.c,     device/lib/pic16/libm/fabsf.c,
	* device/lib/pic16/libm/floorf.c,   device/lib/pic16/libm/frexpf.c,
	* device/lib/pic16/libm/ldexpf.c,   device/lib/pic16/libm/log10f.c,
	* device/lib/pic16/libm/logf.c,     device/lib/pic16/libm/modff.c,
	* device/lib/pic16/libm/powf.c,     device/lib/pic16/libm/sincosf.c,
	* device/lib/pic16/libm/sincoshf.c, device/lib/pic16/libm/sinf.c,
	* device/lib/pic16/libm/sinhf.c,    device/lib/pic16/libm/sqrtf.c,
	* device/lib/pic16/libm/tancotf.c,  device/lib/pic16/libm/tanf.c,
	* device/lib/pic16/libm/tanhf.c,
	* device/include/pic16/math.h: removed const from arguments

	* device/lib/_memchr.c,     device/lib/_memcmp.c,       device/lib/_memcpy.c,
	* device/lib/_memmove.c,    device/lib/_memset.c,       device/lib/_strcat.c,
	* device/lib/_strchr.c,     device/lib/_strcmp.c,       device/lib/_strcpy.c,
	* device/lib/_strcspn.c,    device/lib/_strlen.c,       device/lib/_strncat.c,
	* device/lib/_strncmp.c,    device/lib/_strncpy.c,      device/lib/_strpbrk.c,
	* device/lib/_strrchr.c,    device/lib/_strspn.c,       device/lib/_strstr.c,
	* device/lib/_strtok.c,
	* device/include/string.h: added const for const pointer arguments

	* device/lib/pic16/libc/string/memchr.c,
	* device/lib/pic16/libc/string/memcmp.c,
	* device/lib/pic16/libc/string/memcpy.c,
	* device/lib/pic16/libc/string/memmove.c,
	* device/include/pic16/string.h: added const for const pointer arguments

	* device/lib/_setjmp.c: small optimization
	* sdas/linksrc/lkarea.c (lnksect2): fixed s_XISEG calculation
	* sdas/linksrc/lkmem.c: cosmetics
	* src/SDCCmain.c: place xstack_loc at same address as xdata_loc by default
	* src/SDCCsymt.c (printFromToType): print in one go for make -j output,
	  (compareFuncType): fixed bug 2134
	* sdas/astlcs90/t90mch.c (machine, 16bit indirect op): fixed warning
	* support/cpp/libiberty/md5.c: synced with support/sdbinutils/libiberty/md5.c

2013-12-25 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* device/lib/tlcs90/Makefile.in: fix assembler level .include
	  when not building within source tree
	* sim/ucsim/utils.cc: properly enable vasprintf() declaration

2013-12-22 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/SDCCval.c (valForStructElem): fixed bug 2122

2013-12-22 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/SDCCmain.c (setDefaultOptions): start xdata at 1 by default, fixes bug
	  2173
	* src/SDCCast.c (decorateType, RETURN): error on returning void expression
	  when not using sdcc extensions	
	* src/stm8/gen.c (genReturn): accept returning void, fixes bug 2158
	* support/regression/tests/gcc-torture-execute-20000314-3.c: reintroduced

2013-12-22 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/mcs51/gen.c (aopGet): fixed for remat non-generic pointers,
	  (genPointerGet, genPointerSet): remat all cast remat pointers
	* src/mcs51/ralloc.c (packRegisters): remat all cast of remat ptr
	* src/SDCCast.c (decorateType, CAST): fix bug 2133, array==pointer
	* src/SDCCmain.c: cosmetics
	* src/SDCCsymt.h: reordered DECLARATOR_TYPE
	* support/regression/tests/bug-2133.c: new, added
	* support/regression/tests/gcc-torture-execute-20021010-2.c,
	* support/regression/tests/gcc-torture-execute-20041112-1.c,
	* support/regression/tests/gcc-torture-execute-960116-1.c,
	* support/regression/tests/staticinit.c: fixed warnings

2013-12-20 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/SDCCerr.c,
	* src/SDCCerr.h: added W_UNRECOGNIZED_ASM
	* src/SDCCglobl.h,
	* src/z80/gen.c: cosmetics
	* src/SDCCpeeph.c (StrStr): added
	  (pcDistance): largest instruction on any target is 4 bytes?
	* src/z80/peep.c (ISINST): use STRNCASECMP,
	  (argCont): use StrStr,
	  (z80instructionSize): use STRNCASECMP, W_UNRECOGNIZED_ASM,
	   fixed some bugs, return 999 when unrecognized
	* support/regression/tests/bug-2222.c: removed memset and un
	* support/regression/tests/gcc-torture-execute-20040313-1.c: enabled for all
	  targets with reduced footprint

2013-12-19 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/stm8/gen.c:
	  Document subw uses that can be enabled once bug #2227 is fixed.
	* device/include/ctype.h:
	  Provide macros that use inline functions to improve efficiency of some
	  common functions.

2013-12-18 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c,
	  support/regression/tests/float_single.c:
	  Fix float comparison, bug #2170.
	* support/regression/tests/gcc-torture-execute-20050826-1.c:
	  Use smaller array for stm8.

2013-12-18 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* support/regression/tests/gcc-torture-execute-20040313-1.c:
	  Enabled test.

2013-12-18 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* device/include/ctype.h,
	  device/include/stdio.h,
	  device/lib/incl.mk,
	  device/lib/_is*.c,
	  device/lib/is*.c,
	  device/lib/tolower.c,
	  device/lib/toupper.c,
	  support/regression/tests/ctype.c:
	  Fix ctype.h and anything in there.

2013-12-18 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* device/lib/z80/crt0.s,
	  device/lib/z180/crt0.s,
	  device/lib/r3ka/crt0.s,
	  device/lib/r2k/crt0.s,
	  device/lib/gbz80/crt0.s:
	  Fix bug #2153.

2013-12-18 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/SDCCast.c (stringToSymbol, createIf): fixed bug 2163
	* support/regression/tests/gcc-torture-execute-string-opt-5.c: enabled for
	  mcs51 with smaller buffer	
	* support/regression/tests/bug-2163.c: new, added

2013-12-18 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* device/lib/tlcs90/t90regs.s,
	  device/lib/tlcs90/crt0.s:
	  crt0 for tlcs90.

2013-12-17 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/stm8/peep.c:
	  Fix bug #2182.
	* src/SDCCralloc.hpp:
	  Enable warning for non-connected live ranges for hc08 and s08.

2013-12-16 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/z80/gen.c: Fix cost for built-in strncpy().

2013-12-16 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/SDCCglue.c (glue): fixed bug 2212
	* src/z80/gen.c (genBuiltInStrncpy): fixed bug 2231
	* support/regression/tests/bug-2231.c: new, added

2013-12-15 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/SDCCicode.c (newiTempOperand): fixed bug 2235
	* support/regression/tests/bug-2235.c: new, added
	* src/SDCCptropt.c (ptrPseudoSymSafe): fixed bug 2216
	* support/regression/tests/bug-2216.c: new, added

2013-12-07 Maarten Brock <sourceforge.brock AT dse.nl>

	* .version, doc/sdccman.lyx: bumped version to 3.3.2
	* src/SDCCast.c (decorateType, NOT): fixed bug 2232
	* src/SDCCmain.c (printVersionInfo): mention GPL
	* support/regression/tests/bool.c: fixed warning

2013-12-06 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/mcs51/gen.c (outBitC, genIfx): fixed both parts of bug 2233
	* support/regression/tests/bool.c: added test

2013-12-02 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/ralloc2.cc:
	  Fix handling of IY during accesses to global variables.

2013-11-23 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCClospre.hpp:
	  Fix use flag initialization in lospre edge splitting.
	* src/SDCCglue.c:
	  Add comment on bug #2089 that allocates strings twice.

2013-11-16 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/lib/_divulong.c: cosmetic, use y0
	* device/lib/_fsadd.c: cosmetic
	* device/lib/clean.mk: clean pic14 and tlcs90
	* device/lib/ds390/tinibios.c (_sdcc_external_startup): do not change stack
	* device/lib/Makefile.in: use TAB's
	* device/non-free/lib/clean.mk: clean pic14
	* device/non-free/lib/pic14/Makefile.in,
	* sdas/as6808/clean.mk,
	* sdas/as8051/clean.mk,
	* sdas/as8xcxxx/clean.mk,
	* sdas/asgb/clean.mk,
	* sdas/asrab/clean.mk,
	* sdas/asstm8/clean.mk,
	* sdas/astlcs90/clean.mk,
	* sdas/asz80/clean.mk,
	* support/sdbinutils/Makefile.in: prevent warnings
	* sim/ucsim/cmd.src/clean.mk: clean cmdpars.* & cmdlex.*
	* src/clean.mk: clean pic14 and stm8
	* src/common.h: cosmetic
	* src/ds390/main.c (_ds390_genAssemblerPreamble): added dpl, dph, acon,
	  (_ds390_genIVT): change addressing mode and stack at __reset_vect,
	  (_ds390_genInitStartup): no need for 10bit stack init here
	* src/port.h: added rtrackUpdate
	* src/SDCCgen.c (emit_raw): try to track constant register contents
	* src/ds390/main.c,
	* src/hc08/main.c,
	* src/pic14/main.c,
	* src/pic16/main.c,
	* src/stm8/main.c,
	* src/z80/main.c (*_port): no register tracking
	* src/mcs51/rtrack.h: renamed rtrackUpdate to _mcs51_rtrackUpdate
	* src/mcs51/rtrack.c: enabled by default,
	  implemented suggested removals
	* src/mcs51/main.c: use _mcs51_rtrackUpdate
	* src/mcs51/gen.c (genSend, genPagedPointerGet): fixed bugs obscured by
	  peephole rules,
	  (genLeftShiftLiteral): disabled assert to fix bug 2224
	* src/z80/z80.vcxproj,
	* src/z80/z80.vcxproj.filters: added peeph-tlcs90.def
	* support/regression/Makefile.in: clean host/spec.mk
	* support/regression/tests/bug-2222.c: enabled test for mcs51

2013-11-15 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* support/regression/tests/bug-2222.c:
	  Do not try to execute code that dereferences 0 pointer.

2013-11-11 Raphael Neider <rneider AT web.de>

	* src/pic14/main.c,
	  src/pic14/main.h,
	  src/pic16/device.h,
	  src/pic16/main.c:
	  add warning if --use-non-free is *not* given while compiling
	  for PIC14 or PIC16 devices; the warning can be disabled by
	  either passing --use-non-free (usually recommended) or
	  by passing --no-warn-non-free (usually not recommended)

	* device/lib/pic14/Makefile.common,
	  device/lib/pic16/Makefile.common,
	  device/non-free/lib/pic14/Makefile.common.in,
	  device/non-free/lib/pic16/Makefile.common,
	  support/regression/ports/pic14/spec.mk,
	  support/regression/ports/pic16/spec.mk:
	  pass --no-warn-non-free to avoid new warnings

	* device/lib/pic14/Makefile.in,
	  device/lib/pic14/aclocal.m4,
	  device/lib/pic14/configure,
	  device/lib/pic14/libm/Makefile.in,
	  device/lib/pic14/libsdcc/enhanced-no-xinst/Makefile.in,
	  device/lib/pic14/libsdcc/enhanced/Makefile.in,
	  device/lib/pic14/libsdcc/regular/Makefile.in,
	  device/lib/pic16/Makefile.in,
	  device/lib/pic16/aclocal.m4,
	  device/lib/pic16/configure,
	  device/lib/pic16/debug/Makefile.in,
	  device/lib/pic16/libc/Makefile.in,
	  device/lib/pic16/libio/Makefile.in,
	  device/lib/pic16/libm/Makefile.in,
	  device/lib/pic16/libsdcc/Makefile.in,
	  device/lib/pic16/startup/Makefile.in,
	  device/non-free/lib/pic16/Makefile.in,
	  device/non-free/lib/pic16/aclocal.m4,
	  device/non-free/lib/pic16/configure,
	  device/non-free/lib/pic16/libdev/Makefile.in:
	  regenerated

2013-09-30 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/tlcs90/stubs.s,
	  device/lib/tlcs90/Makefile.in:
	  TLCS-90 library.

2013-09-29 Philipp Klaus Krause <pkk AT spth.de>

	* device/include/asm/tlcs90,
	  device/include/math.h,
	  device/include/sdcc-lib.h,
	  device/include/stdarg.h,
	  device/lib/tlcs90/Makefile.in,
	  device/lib/tlcs90/divmixed.s,
	  device/lib/tlcs90/modmixed.s,
	  src/z80/gen.c:
	  TLCS-90 library.

2013-09-28 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/peeph-gbz80.def:
	  Remove broken peephole rule.

2013-09-27 Philipp Klaus Krause <pkk AT spth.de>

	* sdas/astlcs90/t90mch.c:
	  Fix handling of 8-bit immediates, patch by Rainer Keuchel.
	* src/stm8/peeph.def:
	  More flexible unreachable jump elimination.
	* configure.in,
	  device/lib/Makefile.in,
	  device/lib/tlcs90,
	  src/z80/main.c:
	  Library for TLCS-90.
	* src/stm8/gen.c:
	  Fix comparisons with operand in y, fix offset in wide pointer read when
	  optimizing for code size, fix and improve stack adjustment.
	* src/z80/peeph-tlcs90.def,
	  src/z80/main.c,
	  src/z80/peep.c:
	  Peephole optimization for TLCS-90.

2013-09-27 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/SDCCicode.c (operandFromSymbol): don't allocate register
	  equivalents for symbols that can't fit in HC08/S08 registers.
	* src/SDCClrange.c (visit): remove TARGET_HC08_LIKE exception.

2013-09-26 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/main.c,
	  src/stm8/peep.c:
	  notUsedFrom() for stm8.
	* src/z80/peeph-r2k.def,
	  src/z80/peeph-z80.def,
	  support/regression/tests/bug-2228.c:
	  Fix bug #2228.
	* sim/ucsim/stm8.src/inst.cc:
	  Fix type name.
	* support/regression/tests/bug-2222.c:
	  Fix use of uninitialized memory.

2013-09-25 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c:
	  Improve handling of global variables in addition (and prepare for
	  subtraction).
	* sim/ucsim/stm8.src/inst.cc:
	  Code cleanup.

2013-09-24 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/include/mcs51/reg51.h: fall back to 8052.h
	* doc/sdccman.lyx: pragma exclude bits
	* src/mcs51/gen.c (genFunction, genEndFunction): applied patch 193 for
	  pragma exclude bits
	* src/port.h: maxextalign warning fixed
	* src/SDCCglobl.h: define true and false for MSVC
	* src/stm8/gen.c (genCmp): fixed warning
	* src/stm8/ralloc2.cc (Ainst_ok): fixed warning

2013-09-24 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCralloc.hpp:
	  Enable warning for non-connected live-ranges.

2013-09-24 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c,
	  src/stm8/gen.c,
	  support/regression/tests/bug-2222.c:
	  Fix bugs #2222, 2223.

2013-09-24 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCralloc.hpp,
	  src/SDCClrange.c:
	  Check more carefully for undead hiding among the living variables.

2013-09-23 Philipp Klaus Krause <pkk AT spth.de>

	* sdas/astlcs90,
	  Makefile.common.in,
	  Makefile.in,
	  configure.in:
	  Integrate Rainer Keuchel's TLCS-90 assembler.

2013-09-23 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/peeph.def:
	  Remove redundant jumps.

2013-09-22 Borut Razem <borut.razem AT gmail.com>

	* device/non-free/lib/pic14/configure.in,
	  device/non-free/lib/pic14/configure,
	  device/non-free/lib/pic16/supported-devices.ac,
	  device/non-free/lib/pic16/configure,
	  device/lib/pic16/configure: fixed bash dependencies

2013-09-21 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  More efficient stack adjustment when optimizing for code size.

2013-09-21 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/mcs51/gen.c (genEndFunction): applied patch 207 to fix bug 2221,
	  Thanks Alex Burton!
	* support/regression/tests/bug-2221.c: new, added

2013-09-20 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Refactor testing for literal bytes, more efficient cast from unsigned.

2013-09-20 Borut Razem <borut.razem AT gmail.com>

	* device/non-free/lib/pic14/configure.in,
	  device/non-free/lib/pic14/configure,
	  device/non-free/lib/pic16/supported-devices.ac,
	  device/non-free/lib/pic16/configure,
	  device/lib/pic16/configure:
	  fixed bug #2220 Detection of 16 bit pic devices supported by gputils
	  is not working correctly on Cygwin environment

2013-09-19 Molnar Karoly <molnarkaroly AT users.sf.net>

	* device/include/pic14/pic14devices.txt,
	  device/include/pic14/pic16regs.h,
	  device/non-free/include/pic14/pic16f1704.h,
	  device/non-free/include/pic14/pic16f1708.h,
	  device/non-free/include/pic14/pic16lf1704.h,
	  device/non-free/include/pic14/pic16lf1708.h,
	  device/non-free/lib/pic14/libdev/devices.txt,
	  device/non-free/lib/pic14/libdev/pic16f1704.c,
	  device/non-free/lib/pic14/libdev/pic16f1708.c,
	  device/non-free/lib/pic14/libdev/pic16lf1704.c,
	  device/non-free/lib/pic14/libdev/pic16lf1708.c,
	  doc/sdccman.lyx:
	  New devices.

2013-09-19 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c:
	  Enable some Rabbit optimizations for the TLCS-90.
	* src/SDCCtree_dec.hpp,
	  src/SDCCralloc.hpp,
	  src/SDCCnaddr.hpp,
	  src/SDCClospre.hpp:
	  Reduce memory footprint in lospre and named address spaces, prepare for
	  reducing memory footprint in register allocation.

2013-09-17 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  More efficient zeroing of longs.
	* src/z80/gen.c:
	  Remove C99 variable declaration.

2013-09-17 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/ralloc.c:
	  Do not allocate spill locations for optimized-out jump conditions.

2013-09-16 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  More efficient casts to long, fix handling of register deadness in shifts.

2013-09-16 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* sim/ucsim/stm8.src/stm8.cc: fix simulation of LDW Y,(n,SP)
	  to properly update N & Z flag bits

2013-09-14 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c,
	  sim/ucsim/stm8.src/inst.cc:
	  More efficient conditional jumps.

2013-09-13 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Assume spilt variables are on non-extended stack during dry runs.

2013-09-12 Philipp Klaus Krause <pkk AT spth.de>

	* Makefile.common.in,
	  configure.in,
	  src/z80/gen.c:
	  Preparations for TLCS-90 port.
	* src/stm8/peeph.def:
	  Peepholes to work around lack of RFE #357.

2013-09-12 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c:
	  Negative stack adjustment efficiency, restore stack pointer from frame pointer.
	* src/stm8/peep.c:
	  Provide our own isblank()-substitute for compilers that lack C99 support.

2013-09-11 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c,
	  src/z80/mappings.i,
	  src/z80/peep.c:
	  Stack adjustment code refactoring.

2013-09-11 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCmain.c,
	  src/port.h,
	  src/z80/main.c,
	  src/z80/peep.c,
	  src/z80/z80.h,
	  src/z80/gen.c,
	  src/z80/peep.c:
	  Preparations for TLCS-90 port.

2013-09-09 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/addrspace.c:
	  Disable test for host regression tests.
	* src/stm8/gen.c:
	  Make it compile on compilers that lack C99 support.

2013-09-08 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCC.y,
	  src/SDCCmem.c,
	  src/SDCCglue.c,
	  doc/sdccman.lyx,
	  support/regression/tests/addrspace.c:
	  Support for const named address spaces (for variables in ROM).
	* src/z80/peeph-z80.def,
	  src/z80/peeph-r2k.def:
	  Check for volatile in peephole 1.

2013-09-05 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Fix bug #2211, fix name of codegen struct (_G vs. G).

2013-09-04 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/bitvars.c,
	  support/regression/tests/bool.c,
	  support/regression/tests/bug1057979.c,
	  support/regression/tests/bug1738367.c,
	  support/regression/tests/bug2084206.c,
	  support/regression/tests/bug2935162.c,
	  support/regression/tests/bug3183823.c,
	  support/regression/tests/bug3290691.c,
	  support/regression/tests/bug3467508.c,
	  support/regression/tests/bug3537338.c,
	  support/regression/tests/float_single.c,
	  support/regression/tests/gcc-torture-execute-20000412-2.c,
	  support/regression/tests/gcc-torture-execute-20030714-1.c,
	  support/regression/tests/gcc-torture-execute-990524-1.c,
	  support/regression/tests/gcc-torture-execute-pr15296.c,
	  support/regression/tests/gcc-torture-execute-string-opt-5.c,
	  support/regression/tests/genptrs.c,
	  support/regression/tests/muldiv.c,
	  support/regression/tests/onebyte.c,
	  support/regression/tests/snprintf.c:
	  Disable tests for the least-broken one of the broken ports.

2013-09-04 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c,
	  support/regression/tests/gcc-torture-execute-20020219-1.c,
	  support/regression/tests/gcc-torture-execute-20050104-1.c,
	  support/regression/tests/gcc-torture-execute-920810-1.c,
	  support/regression/tests/gcc-torture-execute-950612-1.c,
	  support/regression/tests/gcc-torture-execute-pr42269-2.c,
	  support/regression/tests/gcc-torture-execute-950915-1.c,
	  support/regression/tests/gcc-torture-execute-20080529-1.c:
	  Fix returning of long long.

2013-09-04 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Partial workaround for linker bug #2198.
	* support/regression/tests/bug-136564.c,
	  support/regression/tests/bug-927659.c,
	  support/regression/tests/bug1057979.c,
	  support/regression/tests/bug3521024.c,
	  support/regression/tests/funptrs.c,
	  support/regression/tests/gcc-torture-execute-20021120-3.c,
	  support/regression/tests/gcc-torture-execute-20030626-1.c,
	  support/regression/tests/gcc-torture-execute-20070201-1.c,
	  support/regression/tests/gcc-torture-execute-921208-1.c,
	  support/regression/tests/gcc-torture-execute-930513-1.c,
	  support/regression/tests/gcc-torture-execute-960327-1.c,
	  support/regression/tests/gcc-torture-execute-980707-1.c,
	  support/regression/tests/snprintf.c,
	  support/regression/tests/gcc-torture-execute-20021118-2.c,
	  support/regression/tests/gcc-torture-execute-20030626-2.c:
	  Enable tests that pass due to workaround for bug #2198.
	* support/regression/tests/gcc-torture-execute-20030916-1.c:
	  Enable passing test.

2013-09-03 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Implement assertion for linker bug #2198 so it is no longer silent to the
	  user.
	* support/regression/tests/gcc-torture-execute-20030714-1.c:
	  Disable failing test.

2013-09-02 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Pointer indirect long addressing mode.

2013-09-02 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/ralloc2.cc:
	  Tuned register allocation heuristic.

2013-09-01 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Fix loading of upper parts of large values through frame pointer, bug #2209.

2013-08-30 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Slightly more efficient addition and loading through frame pointer.

2013-08-30 Maarten Brock <sourceforge.brock AT dse.nl>

	* support/regression/tests/bug-2205.c: new, added
	* support/regression/tests/*: set svn properties eol and keywords
	* device/lib/clean.mk: add stm8 port to cleaning

2013-08-30 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/ralloc2.cc,
	  support/regression/tests/bug-2208.c:
	  Fix bug #2208.

2013-08-29 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCpeeph.c,
	  src/ds390/peeph.def,
	  src/hc08/peeph.def,
	  src/mcs51/peeph.def,
	  src/stm8/peeph.def,
	  src/z80/peeph-gbz80.def,
	  src/z80/peeph-r2k.def,
	  src/z80/peeph-z80.def:
	  Simplified peephole rules.

2013-08-29 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/peeph.def:
	  Rules for bit setting.
	* src/stm8/peep.c:
	  Implement more of register use check.
	* src/stm8/gen.c:
	  Fix byte skipping in subtraction.

2013-08-28 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Fix generation of temporary labels in dry runs, more efficient shift by
	  literal, subtraction and addition, partially fix recognition of multibyte
	  on-stack operands.
	* src/stm8/peeph.def:
	  Eliminate unreachable jumps (which can be generated by other rules).
	* src/stm8/ralloc2.cc:
	  Tune register allocation heuristic.

2013-08-27 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Fix handling of A in float negation and equality comparison, more flexible
	  addition and subtraction.
	* support/regression/tests/float_single.c:
	  Enable tests for asinf(), atanf(), cosf(), sinf(), sinhf().

2013-08-25 Raphael Neider <rneider AT web.de>

	* device/include/pic16/pic16devices.txt:
	  add flag indicating XINST availability per device
	* src/pic16/device.c:
	  parse XINST flag in pic16devices.txt
	* src/pic16/device.h:
	  add field to store XINST availability per device
	* src/pic16/glue.c:
	  emit warning on code breakage when XINST is supported and not
	  explicitly disabled (#pragma config XINST=OFF).
	* src/pic16/main.c:
	  detect and remember occurrence of #pragma config XINST=OFF
	* support/scripts/optimize_pic16devices.pl:
	  support new XINST flag
	* support/scripts/pic16_update_xinst.sh:
	  update XINST flags is pic16devices.txt from information extracted
	  out of gputils/libgputils/gpprocessor.c

2013-08-21 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Be a little bit more flexible about addition operands - necessary to make
	  Coremark compile.

2013-08-21 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/peep.c,
	  src/stm8/peeph.def:
	  Eliminate dead popw / pushw pairs.

2013-08-20 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  More efficient left shift by literal.

2013-08-20 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/SDCCast.c (decorateType): fixed bug 2205 (return discarded if
	  missing expected operand)

2013-08-20 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  More efficient right shift by literal.

2013-08-08 Borut Razem <borut.razem AT gmail.com>

	* doc/sdccman.lyx: added some STM8 tools info, various fixes

2013-08-07 Borut Razem <borut.razem AT gmail.com>

	* doc/sdccman.lyx: updated Sourceforge URLs

2013-08-05 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/SDCCast.c (decorateType): fixed bug 2201 (spurious limited
	  range warning)

2013-08-04 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/peeph.def:
	  Peepholes for in-place operations.
	* src/stm8/gen.c:
	  More efficient pointer write, fix handling of a in comparison for equality.

2013-08-03 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/peep.c,
	  src/stm8/peeph.def:
	  Infrastructure for notUsed().
	* src/stm8/gen.c:
	  More efficient stack-to-stack copy.

2013-08-02 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  More efficient pcall.

2013-08-02 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/SDCClospre.hpp,
	  src/SDCCopt.c:
	  Fix handling of isaddr flag in optimizations.

2013-08-02 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/SDCCopt.c,
	  src/SDCCicode.c,
	  src/stm8/gen.c,
	  src/z80/gen.c:
	  Fold offset into ADDRESS_OF, RFE #393.

2013-08-02 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/stm8/gen.c:
	  More efficient zeroing of bytes, more efficient addition of constants,
	  fix handling of a in pointer set.
	* src/SDCCpeeph.c:
	  Fix handling of architectures that have absolute jump instructions of
	  different length.
	* src/stm8/peeph.def:
	  More jump-to-jump optimizations.

2013-08-02 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* support/scripts/sdcc.nsi: install/uninstall stm8 related files

2013-08-01 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/stm8/gen.c:
	  Smaller code for GET_VALUE_AT_ADDRESS and signed casts.

2013-07-30 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  More efficient mixed-size addition of on-stack operands, and assignment
	  to parts of x and y.
	* support/regression/tests/bug-136564.c,
	  support/regression/tests/bug3521024.c,
	  support/regression/tests/gcc-torture-execute-980707-1.c:
	  Disable tests affected by bug #2196, 2198.
	* support/regression/tests/float_single.c:
	  Disable failing sinf, cosf tests.
	* src/stm8/peeph.def:
	  Tail call optimization.

2013-07-30 Borut Razem <borut.razem AT gmail.com>

	* support/sdbinutils/*: sync with binutils 2.23.2

2013-07-29 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/peeph.def,
	  src/stm8/gen.c:
	  Enable peepholes for inverse jumps, and labels, fix label reference
	  counting bug #2183.

2013-07-29 Borut Razem <borut.razem AT gmail.com>

	* support/cpp/sdcpp-diagnostic.c, upport/cpp/sdcpp-opts.c: fixed bug
	  #2194 Missing header file produces error, but still zero exit status

2013-07-27 Leland Morrison <enigmalee AT sourceforge.net>

	* sdas/linksrc/lkrloc3.c:
	  prevent NULL ptr dereference when generating error message
	  (fixes bug #2076 core dump from sdldz80
	   if relative jump exceeds range)

2013-07-26 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/peep.c,
	  src/stm8/peeph.def:
	  Enable peephole for jp to jra optimization.

2013-07-24 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* support/regression/tests/bug-927659.c,
	  support/regression/tests/bug1057979.c,
	  support/regression/tests/bug2084206.c,
	  support/regression/tests/funptrs.c,
	  support/regression/tests/gcc-torture-execute-20020219-1.c,
	  support/regression/tests/gcc-torture-execute-20021118-2.c,
	  support/regression/tests/gcc-torture-execute-20021120-3.c,
	  support/regression/tests/gcc-torture-execute-20030626-1.c,
	  support/regression/tests/gcc-torture-execute-20030626-2.c,
	  support/regression/tests/gcc-torture-execute-20050104-1.c,
	  support/regression/tests/gcc-torture-execute-20070201-1.c,
	  support/regression/tests/gcc-torture-execute-20080529-1.c,
	  support/regression/tests/gcc-torture-execute-921208-1.c,
	  support/regression/tests/gcc-torture-execute-930513-1.c,
	  support/regression/tests/gcc-torture-execute-950612-1.c,
	  support/regression/tests/gcc-torture-execute-950915-1.c,
	  support/regression/tests/gcc-torture-execute-960327-1.c,
	  support/regression/tests/gcc-torture-execute-pr42269-2.c,
	  support/regression/tests/snprintf.c:
	  Disabled tests that fail due to linker issue, bug #2196, 2198.
	* support/regression/tests/gcc-torture-execute-20030916-1.c:
	  Disable failing test, bug #2200.

2013-07-24 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c,
	  src/stm8/ralloc2.cc,
	  src/stm8/main.c:
	  More efficient unsigned right shifts by more than 3 bits,
	  implement GETABIT, implement jump from and.
	* src/hc08/gen.c,
	  src/hc08/main.c:
	  Remove support for GETHBIT.

2013-07-23 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  More efficient unsigned right shifts by more than 7 bits.

2013-07-23 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCralloc.hpp,
	  src/hc08/ralloc2.cc,
	  src/stm8/ralloc2.cc
	  src/stm8/gen.h,
	  src/stm8/gen.c,
	  src/z80/ralloc2.cc:
	  Consider ifx optimization in register allocation.
	* device/lib/_mullong.c:
	  Fix typo in comment.

2013-07-23 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/hc08/gen.c (genLeftShift,genRightShift): fixed bug in shifting
	  when result and shift count partially overlapped registers

2013-07-22 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCralloc.hpp,
	  src/stm8/gen.c,
	  src/stm8/ralloc2.cc:
	  Implement direct jump from comparison, eliminating temporary;
	  fix operand handling in multiplication.

2013-07-21 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCglobl.h,
	  src/SDCCmain.c,
	  src/*/ralloc.c,
	  src/SDCCopt.c,
	  src/SDCCast.c,
	  doc/sdccman.lyx:
	  Reorganize debug output dump options.

2013-07-20 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  More efficient zeroing and comparing.

2013-07-19 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/stm8/gen.c,
	  src/stm8/ralloc2.cc:
	  Efficient pushes.

2013-07-19 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/stm8/gen.c:
	  More efficient long and long long shifts by small contants.

2013-07-19 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/stm8/gen.c,
	  support/regression/tests/compare.c:
	  Fix handling of comparisons to immediates for stm8.

2013-07-18 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/_mullong.c:
	  Use 16x16 multiplication instead of 8x8 where faster; patch #133 by Marco
	  Bodrato.

2013-07-18 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/SDCClrange.c,
	  support/regression/tests/bug-2197.c:
	  Fix handling of pointer write in live-range splitting, fixing bug #2197.

2013-07-16 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/ralloc.c,
	  src/z80/ralloc2.cc,
	  support/regression/tests/bug-2195.c,
	  src/hc08/ralloc.c,
	  src/hc08/ralloc2.cc:
	  Unify handling of register survival in old and new register allocator,
	  fixing bug #2195.

2013-07-15 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* support/regression/compact-results.py,
	* support/regression/collate-results.py: Also look for "unknown
	   instruction"
	* sim/ucsim/st7.src/st7.cc,
	* sim/ucsim/hc08.src/hc08.cc,
	* sim/ucsim/hc08.src/inst.cc: Change result code for invalid and
	  incomplete instructions so regression tests scripts detect problem.

2013-07-14 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* sim/ucsim/stm8.src/stm8.cc: Change result code for invalid and
	  incomplete instructions so regression tests scripts detect problem.

2013-07-13 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCerr.c:
	  Change message text for warning on variables being dead at their definitions.

2013-07-11 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/SDCClospre.hpp:
	  Fix lospre forwarding.

2013-07-11 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/SDCCBBlock.c,
	  src/SDCClrange.c,
	  src/SDCClrange.h,
	  src/SDCCopt.c,
	  src/SDCCralloc.hpp,
	  src/*/ralloc.c:
	  Split non-connected live-ranges.

2013-07-05 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCset.h,
	  src/SDCCset.c:
	  Improve const use in sets.
	* src/SDCCglobl.h,
	  src/SDCCBBlock.c,
	  src/SDCCopt.c:
      Allow debug iCode dump after lospre.

2013-07-04 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCbitv.h,
	  src/SDCCbitv.c:
	  Improve const use in bit vectors.

2013-07-03 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCClospre.hpp:
	  Fix invalidation in lospre forwarding.

2013-07-01 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCClospre.cc:
	  Mark receive opcodes as invalidating for losrpe.

2013-06-30 Philipp Klaus Krause <pkk AT spth.de>

	* sdccconf_in.h:
	  Regenerated to make --disable-stm8-port work.

2013-06-27 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCClospre.cc:
	  Disable safety in division for stm8.

2013-06-27 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCnaddr.hpp:
	  Add comment to reference the paper on bank selection.

2013-06-16 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/peeph.def:
	  Reorganize rules, disable rules depending on notUsed() or unimplemented
	  ref count.
	* src/stm8/peep.c,
	  src/SDCCpeeph.c:
	  Fix const, handling of relative jumps, read from uninitialized pointer.

2013-06-16 Valentin Dudouyt <valentin dudouyt AT gmail.com>

	* src/stm8/main.c,
	* src/stm8/peep.c: implemented stm8canAssign and stm8notUsed,
	  fixed handling of label entities in stm8instructionSize,
	  added internal buffer in nextToken.
	* src/stm8/peeph.def: uncommented a few peephole rules.

2013-06-16 Maarten Brock <sourceforge.brock AT dse.nl>

	* device/lib/_mullonglong.c,
	* sdas/as8051/i51adr.c,
	* sdas/linksrc/lkbank.c,
	* sdas/linksrc/lklibr.c,
	* sdas/linksrc/lkrloc.c,
	* sdas/linksrc/aslink.h,
	* src/mcs51/main.c: cosmetic changes
	* sdas/asxxsrc/asmain.c (main): default to 16 bit address width
	* sdas/as8051/i51mch.c (minit): set address width to 24 bit
	* sdas/as8xcxxx/ds8mch.c (machine): validate address width
	* sdas/asxxsrc/asdata.c,
	* sdas/asxxsrc/asxxxx.h: added a_bytes, a_mask, s_mask, v_mask and outradix
	* sdas/asxxsrc/asexpr.c (exprmasks): set a_bytes and masks
	* sdas/asxxsrc/aslist.c: use a_bytes
	* sdas/asxxsrc/asout.c: use a_bytes,
	  (outradix, outgsd): added to output address width
	* sdas/linksrc/lkarea.c,
	* sdas/linksrc/lklist.c: small optimizations
	* sdas/linksrc/lkrloc3.c (relr3): use a_bytes
	* support/sdbinutils/bfd/asxxxx.c (asxxxx_is_rel): fixed get_eol

2013-06-10 Maarten Brock <sourceforge.brock AT dse.nl>

	* sdas/linksrc/lkaomf51.c (GetName, SaveLinkedFilePath): small optimization
	  (OutputAOEMF51, CollectInfoFromCDB, ReadHexFile): fixed bug 2184
	* sdas/linksrc/lkmain.c: cosmetics
	* sdas/linksrc/lkout.c (ixx, iflush): fixed bug 1986
	* sdas/linksrc/lksym.c: comments

2013-06-09 Maarten Brock <sourceforge.brock AT dse.nl>

	* src/sdcc.vcxproj: removed boost library path
	* src/stm8/stm8.vcxproj,
	* src/stm8/stm8.vcxproj.filters: added peep.[ch]
	* src/z80/z80.vcxproj: fixed message typo
	* src/stm8/peep.c: fixed errors for MSVC (C89 compatible only):
	  only declarations at start of block
	* support/packihx/packihx.c: whitespace

2013-06-08 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/peeph.def:
	  Prepare for replacing absolute jumps by relative jumps and inverting jump
	  conditions.
	* src/stm8/peep.c,
	  src/SDCCpeeph.c:
	  Fix buffer overflows, improve error detection.

2013-06-08 Valentin Dudouyt <valentin dudouyt AT gmail.com>

	* src/stm8/main.c,
	* src/stm8/peep.h,
	* src/stm8/peep.c:
	  Implemented stm8instructionSize.

2013-06-07 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCClospre.hpp:
	  Cleanup debugging code in lospre.

2013-06-06 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c,
	  tests/bug-2181.c:
	  Fix bug #2181.

2013-06-03 Maarten Brock <sourceforge.brock AT dse.nl>

	* sdcc.sln,
	* src/stm8/stm8.vcxproj,
	* src/stm8/stm8.vcxproj.filters: added stm8 project
	* src/hc08/hc08.vcxproj,
	* src/z80/z80.vcxproj,
	* src/sdcc.vcxproj: use boost 1.50, the last working installer from boostpro
	* debugger/mcs51/symtab.h,
	* src/ds390/gen.c,
	* src/hc08/gen.c,
	* src/mcs51/gen.c,
	* src/pic14/gen.c,
	* src/pic16/gen.c,
	* src/pic16/glue.c,
	* src/SDCCast.c,
	* src/SDCCdwarf2.c,
	* src/SDCCglue.c,
	* src/SDCCsymt.h,
	* src/z80/gen.c: fixed signed/unsigned comparison warnings
	* src/stm8/gen.c: fixed errors for MSVC (C89 compatible only):
	  don't use snprintf but only SNPRINT,
	  only declarations at start of block,
	  don't use true/false but only TRUE/FALSE
	* src/stm8/main.c (stm8_defaultRules): fixed init error
	* src/stm8/ralloc2.cc (instruction_cost): fixed warning
	* src/SDCCglue.c (glue): removed target dependent code
	* support/regression/fwk/include/testfwk.h: removed ASSERT_FAILED,
	  added ASSERTFALSE
	* support/regression/tests/gcc-torture-execute-20050826-1.c: use ASSERFALSE,
	  enabled test for mcs51
	* support/regression/tests/gcc-torture-execute-920810-1.c: use ASSERTFALSE

2013-06-03 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  More efficient register-to-register assignment using ldw.

2013-06-02 Philipp Klaus Krause <pkk AT spth.de>

	* sim/ucsim/stm8.src/inst.cc:
	  Fix handling of N and Z flags in addw, subw.
	* support/regression/tests/gcc-torture-execute-20021120-1.c:
	  Disable failing test for stm8 (bug #2180).
	* src/stm8/gen.c:
	  More efficient subtraction.
	* support/regression/tests/gcc-torture-execute-pr47337.c:
	  Disable this very colatile test for stm8 for now. See bug #2172 for the
	  longer justification.

2013-06-01 Valentin Dudouyt <valentin dudouyt AT gmail.com>

	* sim/ucsim/stm8.src/inst.cc:
	  Fixed subw y.

2013-05-31 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCcse.c,
	  src/SDCClospre.cc:
	  Fix bug #2167.
	* src/stm8/main.c,
	  src/stm8/gen.c:
	  Implement jump tables.

2013-05-30 Raphael Neider <rneider AT web.de>

	* doc/sdccman.lyx: remove --enable-new-pics, add
	  --no-extended-instructions, adjust section on adding devices

2013-05-30 Raphael Neider <rneider AT web.de>

	* device/lib/pic16/configure.ac,
	* device/non-free/lib/pic16/configure.ac: remove obsolete option
	  --enable-new-pics, use common device support detection from
	  supported-devices.ac and the generated processors.ac
	* device/non-free/lib/pic16/supported-devices.ac: fragment from
	  configure.ac performing detection of devices supported by gputils;
	  device detection also performs linking step for robustness

	* device/lib/pic16/libio/adc.ignore,
	* device/lib/pic16/libio/i2c.ignore,
	* device/lib/pic16/libio/usart.ignore: use full device id (18fxxxx)

	* device/lib/pic16/libio/mkmk.sh,
	* device/non-free/lib/pic16/libdev/mkmk.sh,
	* device/non-free/lib/pic16/libdev/testall.sh:
	  derive device list from files in non-free/lib/pic16/libdev rather
	  than the manually maintained pics.all, enclose each device in
	  ENABLE_<DEVICE> conditionals

	* device/non-free/lib/pic16/update.sh: script to update the build
	  system to be run whenever the set of devices supported by sdcc
	  changed; generates processor.ac and reconfigures all PIC16 libs

	* support/scripts/cinc2h.pl: update instructions regarding adding
	  support for new devices

	* device/lib/pic16/libio/Makefile.am: regenerated from mkmk.sh
	* device/non-free/lib/pic16/libdev/Makefile.am:
	  regenerated from mkmk.sh
	* device/non-free/lib/pic16/pics.all: removed (no longer used)
	* device/non-free/lib/pic16/processors.ac: added, list of automake
	  conditionals for automatic detection of devices supported by
	  gputils, generated from update.sh

	* device/lib/pic16/Makefile.in,
	* device/lib/pic16/aclocal.m4,
	* device/lib/pic16/configure,
	* device/lib/pic16/debug/Makefile.in,
	* device/lib/pic16/libc/Makefile.in,
	* device/lib/pic16/libio/Makefile.in,
	* device/lib/pic16/libm/Makefile.in,
	* device/lib/pic16/libsdcc/Makefile.in,
	* device/lib/pic16/startup/Makefile.in,
	* device/non-free/lib/pic16/Makefile.in,
	* device/non-free/lib/pic16/aclocal.m4,
	* device/non-free/lib/pic16/configure,
	* device/non-free/lib/pic16/libdev/Makefile.in: regenerated

2013-05-30 Raphael Neider <rneider AT web.de>

	* device/lib/pic14/configure.in: remove now obsolete --enable-new-pics,
	  check support for enhanced cores and extended instruction set,
	* device/lib/pic14/Makefile.am: build libsdcce.a iff enhanced cores
	  are supported, use special version avoiding extended instructions
	  if those are not supported by gputils
	* device/lib/pic14/libm/Makefile.am: build libme.a iff enhanced cores
	  are supported, avoid extended instructions if not supported by
	  gputils (0.13.5-6)
	* device/lib/pic14/libsdcc/enhanced-no-xinst/Makefile.am,
	* device/lib/pic14/libsdcc/enhanced-no-xinst/Makefile.in,
	* device/lib/pic14/libsdcc/enhanced-no-xinst/_gptrget1.S,
	* device/lib/pic14/libsdcc/enhanced-no-xinst/_gptrget2.S,
	* device/lib/pic14/libsdcc/enhanced-no-xinst/_gptrget3.S,
	* device/lib/pic14/libsdcc/enhanced-no-xinst/_gptrget4.S,
	* device/lib/pic14/libsdcc/enhanced-no-xinst/_gptrput1.S,
	* device/lib/pic14/libsdcc/enhanced-no-xinst/_gptrput2.S,
	* device/lib/pic14/libsdcc/enhanced-no-xinst/_gptrput3.S,
	* device/lib/pic14/libsdcc/enhanced-no-xinst/_gptrput4.S,
	* device/lib/pic14/libsdcc/enhanced-no-xinst/macros.inc:
	  special version of gptr* for enhanced cores without using extended
	  instructions
	* device/non-free/lib/pic14/configure.in: remove now obsolete option
	  --enable-new-pics, improve gputils device support detection support
	  by also performing linking, export list of supported devices to
	  libdev/Makefile.in
	* device/non-free/lib/pic14/libdev/Makefile.in: accept list of devices
	  to build from configure

	* device/lib/pic14/Makefile.in,
	* device/lib/pic14/aclocal.m4,
	* device/lib/pic14/configure,
	* device/lib/pic14/libm/Makefile.in,
	* device/lib/pic14/libsdcc/enhanced/Makefile.in,
	* device/lib/pic14/libsdcc/regular/Makefile.in,
	* device/non-free/lib/pic14/configure:
	  regenerated

2013-05-30 Raphael Neider <rneider AT web.de>

	* src/pic14/main.c, src/pic14/main.h: add option to avoid generating
	  instructions from the extended instruction set in order to work
	  around issues with gputils-0.13.6
	* src/pic14/gen.c (inc_fsr): avoid generating ADDFSR if
	  --no-extended-instructions is specified

2013-05-30 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c,
	  support/regression/tests/bug-2175.c:
	  Fix bug #2175.

2013-05-29 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  Fix ADDRESS_OF with result in y for variables at sp + 2, more efficient
	  assignment to stack using ldw.

2013-05-29 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/_divsint.c,
	  device/lib/_divslong.c,
	  device/lib/_modsint.c,
	  device/lib/_modslong.c:
	  Remove dependencies of signed division support functions on unsigned
	  division support functions.
	* src/stm8/gen.c,
	  src/stm8/main.c:
	  Fix partial saving of Y in division and multiplication, implement unsigned
	  int division.

2013-05-29 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c,
	  src/stm8/ralloc.c,
	  support/regression/tests/gcc-torture-execute-20010129-1.c,
	  support/regression/tests/gcc-torture-execute-pr28982a.c,
	  support/regression/tests/gcc-torture-execute-930614-2.c,
	  support/regression/tests/gcc-torture-execute-20021120-1.c:
	  Support for calls to functions returning long from functions that use
	  extended stack.

2013-05-28 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/ralloc2.cc,
	  src/stm8/ralloc.c,
	  src/stm8/gen.h,
	  src/stm8/gen.c,
	  support/regression/tests/bp.c,
	  support/regression/tests/gcc-torture-execute-20071030-1.c,
	  support/regression/tests/gcc-torture-execute-990513-1.c,
	  support/regression/tests/gcc-torture-execute-pr47538.c,
	  support/regression/tests/gcc-torture-execute-980707-1.c,
	  support/regression/tests/bug2094505.c,
	  support/regression/tests/gcc-torture-execute-20031012-1.c,
	  support/regression/tests/gcc-torture-execute-20030916-1.c:
	  Support for extended stack on stm8, more efficient ADDRESS_OF.

2013-05-27 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  More efficient pointer access, more efficient loading of constants to
	  stack, fix handling of shift count deadness.
	* sim/ucsim/stm8.src/inst.cc:
	  Fix ldw pointer write (bug #2174).
	* support/regression/tests/gcc-torture-execute-pr47538.c:
	  Disable volatile test affected by bug #2171.
	* src/stm8/ralloc2.cc:
	  Implement heuristic bias for register assignment.

2013-05-26 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  More efficient zeroing by pointer, more efficient unsigned cast,
	  preparations for more efficient pointer access.
	* src/SDCCopt.c:
	  Allow offset in pointer read.
	* sim/ucsim/stm8.src/inst.cc:
	  Fix handling of N and Z flag in ldw.
	* src/stm8/main.c:
	  More efficient initialization.

2013-05-25 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  More efficient addition.

2013-05-25 Borut Razem <borut.razem AT gmail.com>

	* src/SDCCopt.c: fixed bug #2165 - "Broken comparison" by disabling
	  optimization of comparison unsigned with 2^n literal since it is broken
	* support/regression/test/compare_2_n.m4: added test for bug #2165

2013-05-25 Philipp Klaus Krause <pkk AT spth.de>

	* Merged stm8 branch.

2013-05-25 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/float_single.c,
	  support/regression/tests/gcc-torture-execute-20030714-1.c,
	  support/regression/tests/gcc-torture-execute-20050826-1.c:
	  STM8: Disable failing tests.

2013-05-25 Borut Razem <borut.razem AT gmail.com>

	* Makefile.in: applied patch #211 - "sdbinutils is installed twice",
	  thanks to Tijl Coosemans

2013-05-24 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/gcc-torture-execute-20010224-1.c:
	  STM8: Disable test that fails due to known CSE bug #1968.
	* support/regression/ports/stm8/spec.mk:
	  STM8: Remove definition for __reentrant.
	* src/stm8/gen.c:
	  STM8: Fix handling of out-of-range offsets.

2013-05-23 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fix float negation, fix large stack-to-stack copy under high
	  register pressure, fix handling of immediate operands.
	* support/regression/tests/gcc-torture-execute-20030408-1.c:
	  STM8: Disable test for known front-end bug.
	* sim/ucsim/stm8.src/inst.cc:
	  STM8: Fix handling of V and H flags in cpw.
	* sim/ucsim/stm8.src/inst.cc:
	  STM8: Silence some warnings.
	* src/stm8/ralloc.c:
	  STM8: Fix missing include.
	* support/regression/tests/gcc-torture-execute-20050613-1.c:
	  STM8: Disable regression test that fails due to front-end bug.

2013-05-22 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: More efficient xor, or, and. Fix overwriting of shift count in
	  shifts, fix comparison with upper byte in a, fix long comparison stacked
	  offset, fix unsigned long / unsigned long long comparison.

2013-05-22 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCopt.c:
	  STM8: Disable broken optimization of comparisons into and.
	* src/stm8/gen.c:
	  STM8: Slightly more efficient shifts, fix long ifx, fix use of word
	  rotation in copy, fix handling of a in signed cast.

2013-05-21 Valentin Dudouyt <valentin dudouyt AT gmail.com>

	* src/stm8/main.c,
	* src/SDCCglue.c:
	STM8: Fixed init code: some of GSINIT parts aren't executed under certain
	linking conditions.

2013-05-20 Maarten Brock <sourceforge.brock AT dse.nl>

	* support/scripts/sdcc.nsi: added RequestExecutionLevel admin

2013-05-20 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c:
	  More efficient cast from _Bool,
	* src/z80/peep.c:
	  Fix recognition of xor as writing a in peepholes.

2013-05-20 Maarten Brock <sourceforge.brock AT dse.nl>

	* Small Device C Compiler 3.3.0 released
	* .version, doc/sdccman.lyx: changed sdcc version to 3.3.1

2013-05-19 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fix long and long long comparison.

2013-05-19 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/stm8/gen.c:
	  STM8: Give up trying to fix big-endian bit-fields. Make bit-fields
	  little-endian.

2013-05-19 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* sim/ucsim/stm8.src/instcl.h,
	  sim/ucsim/stm8.src/inst.cc,
	  sim/ucsim/stm8.src/stm8mac.h,
	  sim/ucsim/stm8.src/glob.cc,
	  sim/ucsim/stm8.src/stm8.cc,
	  sdas/asstm8/stm8mch.c:
	  STM8: Patches by Valentin Dudouyt to fix simulator.
	* src/stm8/gen.c:
	  STM8: Fix conditional jump, address generation for on-stack variables.
	* device/lib/_mullong.c,
	  device/lib/_mulint.c,
	  device/lib/stm8/Makefile.in,
	  device/lib/_mulschar.c,
	  device/lib/_modschar.c,
	  device/lib/_divschar.c,
	  src/SDCCsymt.c,
	  src/stm8/main.c:
	  STM8: Multiplication and division fixes.

2013-05-18 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fix offset in wide addition, fix handling of a in copy from
	  registers to global, fix stack adjustment for large variables, fix large
	  arithmetic signed right shift.

2013-05-18 Maarten Brock <sourceforge.brock AT dse.nl>

	* doc/INSTALL.txt: small update
	* support/scripts/repack_release.sh: added windows x64 setup

2013-05-17 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fix bit-field access.
	* sim/ucsim/stm8.src/inst.cc:
	  STM8: Fix handling of carry bit in negation in simulator.

2013-05-16 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/main.c:
	  STM8: Fix endianness for initializers.

2013-05-15 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/ports/stm8/support.c:
	  STM8: Remove unneeded global variable that clashes with identifiers in
	  regression tests.
	* support/regression/tests/malloc.c,
	  support/regression/tests/gcc-torture-execute-920810-1.c:
	  STM8: Disable regression tests for unimplemented malloc().
	* src/stm8/gen.c:
	  STM8: Fix saving of a in early stack-to-stack copy, fix offset in stacked
	  register operand, fix handling of operand in wide register in pointer set,
	  fix endless loop in shifts.

2013-05-12 Philipp Klaus Krause <pkk AT spth.de>

	* sim/ucsim/stm8.src/inst.cc:
	  STM8: Fix clr, partially by patch by Valentin Dudouyt.
	* src/stm8/main.c:
	  STM8:  Patch by Valentin Dudouyt to initialize global and static
	  variables to zero.

2013-05-12 Philipp Klaus Krause <pkk AT spth.de>

	* sim/ucsim/stm8.src/inst.cc:
	  STM8: Patch by Valentin Dudouyt to fix ldw.
	* src/stm8/main.c:
	  STM8: Patches by Valentin Dudouyt to fix handling of global variables and
	  startup.

2013-05-11 Philipp Klaus Krause <pkk AT spth.de>

	* sim/ucsim/stm8.src/inst.cc,
	  sim/ucsim/stm8.src/instcl.h,
	  sim/ucsim/stm8.src/stm8.cc,
	  sim/ucsim/stm8.src/stm8mac.h,
	  support/regression/ports/stm8/support.c:
	  STM8: Patches by Valentin Dudouyt: The last bits to enable regression
	  testing, fix bug in wide addition.
	* support/regression/tests/0fail.c,
	  support/regression/tests/0pass.c:
	  Removed dummy tests.
	* src/stm8/gen.c:
	  STM8: Fix handling of large operands partially in x in comparison for
	  equality, be more careful in partial move for cast, fix signed cast.
	* src/hc08/gen.c,
	  src/z80/gen.c:
	  More efficient cast from _Bool.

2013-05-11 Molnar Karoly <molnarkaroly AT users.sf.net>

	* device/include/pic14/pic14devices.txt,
	  device/include/pic14/pic16regs.h,
	  device/non-free/include/pic14/pic16f753.h,
	  device/non-free/include/pic14/pic16hv753.h,
	  device/non-free/lib/pic14/libdev/devices.txt,
	  device/non-free/lib/pic14/libdev/pic16f753.c,
	  device/non-free/lib/pic14/libdev/pic16hv753.c,
	  doc/sdccman.lyx:
	  New devices.

2013-05-10 Maarten Brock <sourceforge.brock AT dse.nl>

	* sdas/doc/asmlnk.txt: updated for all steps towards ASxxxx v5
	* sdas/doc/asxhtm.html: removed
	* .version,
	* doc/INSTALL.txt,
	* doc/sdccman.lyx: version 3.3.0

2013-05-10 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fix endianness in stack / stack copy.

2013-05-09 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fix multibyte false Ifx.

2013-05-07 Borut Razem <borut.razem AT gmail.com>

	* support/scripts/sdcc.nsi: removed dedication to Dennis M. Ritchie,
	  corrected ChangeLog path

2013-05-05 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fix endianness in register / stack copy.

2013-05-04 Maarten Brock <sourceforge.brock AT dse.nl>

	* .version,
	* doc/INSTALL.txt,
	* doc/sdccman.lyx: version 3.3.0 rc1
	* sdcc.spec: version 3.3.0
	* sdas/asxxsrc/asout.c: suppress warning

2013-05-04 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fix stack variable offset.

2013-05-04 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/peep.c:
	  More accurately model behaviour of xor for peepholes.
	* sdas/asstm8/stm8mch.c,
	  sdas/asxxsrc/asout.c:
	  Applied patch from Valentin Dudouyt to make range check stm8-specific.

2013-05-01 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/peeph-z80.def,
	  src/z80/peeph-r2k.def:
	  Fix generation of extra # in peephole.

2013-04-30 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fix memory leak in conditional jump.

2013-04-30 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/gcc-torture-execute-20000314-3.c:
	  STM8: Removed regression test, since it tests for non-standard gcc behaviour.
	* src/stm8/gen.c:
	  STM8: Fix saving of a on stack in binary complement.

2013-04-30 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c,
	  src/stm8/main.c,
	  src/stm8/ralloc2.cc:
	  STM8: Implement unsigned division.

2013-04-30 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/tests/bp.c,
	  support/regression/tests/bug2094505.c,
	  support/regression/tests/bug3475630.c,
	  support/regression/tests/gcc-torture-execute-20010129-1.c,
	  support/regression/tests/gcc-torture-execute-20021120-1.c,
	  support/regression/tests/gcc-torture-execute-20030916-1.c,
	  support/regression/tests/gcc-torture-execute-pr28982a.c,
	  support/regression/tests/gcc-torture-execute-20031012-1.c,
	  support/regression/tests/gcc-torture-execute-20071030-1.c,
	  support/regression/tests/gcc-torture-execute-930614-2.c,
	  support/regression/tests/gcc-torture-execute-930628-1.c,
	  support/regression/tests/gcc-torture-execute-980707-1.c,
	  support/regression/tests/gcc-torture-execute-990513-1.c:
	  STM8: Disable some regression tests that need support for extended stack
	  operands.
	* src/stm8/gen.c:
	  STM8: Improve error reporting for unimplemented extended stack operands,
	  fix pointer write.
	* device/lib/_divschar.c,
	  device/lib/_modschar.c,
	  device/lib/stm8/Makefile.in:
	  STM8: Support routines for signed char divide and modulo.

2013-04-29 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fix stack handling in equality comparison, handle dead code, fix
	  shift to zero.

2013-04-29 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Implement DUMMY_READ_VOLATILE.

2013-04-29 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Implement read from signed bit-field.

2013-04-28 Philipp Klaus Krause <pkk AT spth.de>

	* sdas/asxxsrc/asout.c,
	  src/stm8/main.c:
	  STM8: Applied patched from Valentin Dudouyt to improve error checking in
	  assembler, implement initialization of globals, __interrupt.

2013-04-28 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/main.c,
	  src/stm8/gen.c:
	  STM8: Implement multiplication.

2013-04-28 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fix asmop freeing for GET_VALUE_AT_ADDRESS, do not share symbol
	  aops to fix double free, fix large comparison, implement bit-field writes.

2013-04-28 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fix unsigned cast, implement read from unsigned bit-field.
	* support/regression/tests/0fail.c,
	  support/regression/tests/0pass.c:
	  Dummy tests for debugging regression testing.

2013-04-26 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fix in handling of result in a in addition, minor improvements.

2013-04-26 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fix stack handling in signed cast, fix wide right shift, minor
	  refactoring.

2013-04-26 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fix handling of a in addition, subtraction and negation, more
	  flexible copy, fix comparison.

2013-04-25 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Update TODO/todo comments to reflect known bug vs optimization
	  potential.

2013-04-24 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Various fixes.

2013-04-23 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Make lack of support for bit-fields explicit, implement binary
	  complement, minor improvements.

2013-04-23 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fix large operands in equality comparison of register with literal
	  or stack op.
	* src/stm8/ralloc2.cc:
	  STM8: Fix liveness of registers at parameter pushes.

2013-04-23 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fix parameter stack offset, fix handling of a in GET_VALUE_AT_ADDRESS.

2013-04-22 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fix returning 4-byte values, fix saving of x, y over call, fix
	  handling of registers in stack-to-stack copy.

2013-04-21 Molnar Karoly <molnarkaroly AT users.sf.net>

	* device/include/pic14/pic16regs.h:
	  New common header for the pic14 family.

2013-04-21 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/stm8/Makefile.in:
	  STM8: Add missing integer support functions.
	* src/stm8/gen.c:
	  STM8: Enable inline asm.

2013-04-21 Philipp Klaus Krause <pkk AT spth.de>

	* support/regression/Makefile.in,
	  support/regression/ports/stm8/spec.mk,
	  support/regression/ports/stm8/support.c,
	  support/regression/ports/stm8/uCsim.cmd:
	  STM8: Basic infrastructure for regression tests, partially from a patch
	  by Valentin Dudouyt.
	* src/stm8/gen.c:
	  STM8: Name mangling for address generation.

2013-04-21 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/Makefile.in:
	  STM8: Enable building standard library.

2013-04-21 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c,
	  src/stm8/main.c:
	  STM8: Applied patch from Valentin Dudouyt to implement __critical.

2013-04-19 Philipp Klaus Krause <pkk AT spth.de>

	* device/lib/stm8/Makefile.in:
	  STM8: Disable building some library files.
	* src/stm8/gen.c:
	  STM8: Fix comparison.
	* src/stm8/main.c:
	  STM8: Disable some annoying debug output.

2013-04-19 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/main.c,
	  sdas/asstm8/stm8mch.c:
	  STM8: Applied patch from Valentin Dudouyt to support addw sp, #byte.
	* src/stm8/ralloc2.cc:
	  STM8: Enabled cost function for more iCodes.
	* src/stm8/gen.c:
	  STM8: Fixes for logic ops, RETURN, '-', stack-to-stack copy, implement
	  more operands for comparison.

2013-04-18 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/main.c:
	  STM8: Disable generation of jump tables.
	* src/stm8/gen.c:
	  STM8: Implement more comparison operands, fix for stack-to-stack
	  temporary assignment.

2013-04-18 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Endianness fixes, implement dummy pointer reads, implement '!',
	  implement more operands in logic ops, implement more return operands,
	  implement more operands for cast to _Bool, implement more operands for
	  subtraction.

2013-04-18 Borut Razem <borut.razem AT gmail.com>

	* device/non-free/lib/pic14/libdev/mkall.sh,
	  device/examples/mcs51/simple/test,
	  device/examples/mcs51/simple/go,
	  device/examples/mcs51/simple2/go,
	  device/examples/mcs51/simple2/test,
	  sim/ucsim/conf:
	  use /bin/sh instead of /bin/bash to enable compilation on OpenBSD

2013-04-17 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fix for cast to bool.

2013-04-17 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Implement more shifts, unary minus for float, implement large
	  return values, save regs over calls, coalescing.

2013-04-16 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fix emission of rlwa, fix 16-bit increment with result in x,
	  operand not in x.

2013-04-15 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fixes for reading / writing through pointer, implement more IFX,
	  fix wide subtraction and compariosn.

2013-04-15 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Now that we know more about sp-manipulation, we can do it smarter.

2013-04-14 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl:
	  The overlapped block and instruction it is no longer a fatal error.

2013-04-14 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/main.c:
	  STM8: Applied patch from Valentin Dudouyt to set default code loc.
	* src/stm8/gen.c:
	  STM8: Be more cautious about arithmetic on stack pointer.

2013-04-13 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCglobl.h,
	  src/SDCCglue.c,
	  src/SDCCmain.c,
	  src/pic16/glue.c,
	  src/z80/main.c,
	  doc/sdccman.lyx,
	  src/stm8/main.c:
	  Remove option --main-return, make the behaviour previously invoked by
	  --main-return the default.

2013-04-13 Philipp Klaus Krause <pkk AT spth.de>

	* sdas/asstm8/stm8.h,
	  sdas/asstm8/stm8mch.c,
	  sdas/asstm8/stm8pst.c,
	  src/SDCCglue.c,
	  src/stm8/gen.c,
	  src/stm8/main.c:
	  STM8: Applied patches from Valentin Dudouyt containing various fixes.

2013-04-11 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c,
	  src/stm8/ralloc.c:
	  Fix handling of stack part of local variables.

2013-04-11 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Implement basic pointer writes, fix handling of 16-bit literals.

2013-04-10 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: END_FUNCTION stack adjustment fix, more efficient zeroing, addition
	  fix, return value use.

2013-04-09 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fix for GET_VALUE_AT_ADDRESS, fixes for shift by literal, implement
	  call by pointer, minor improvements.

2013-04-08 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Allow more operands in xor, and, or.

2013-04-08 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Implement integer unary minus, or fix.

2013-04-08 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Implement more comparisons, stack handling fix.
	* src/SDCCsymt.c:
	  STM8: Allow returning long long (not implemented in code genration yet).

2013-04-08 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Stack adjustment fixes, signed cast fix, ifx fix,
	  GET_VALUE_AT_ADDRESS fix.

2013-04-08 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Implement cast to _Bool.
	* device/include/sdcc-lib.h,
	  device/include/asm/stm8/features.h:
	  STM8: Port feature header.
	* device/include/math.h,
	  device/include/stdarg.h:
	  STM8: Port feature configuration.

2013-04-07 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Allow more operand types in Ifx, implement more casts.

2013-04-06 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Fixes for stack pointer handling.

2013-04-06 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* support/regression/tests/literalop.c,
	  support/regression/tests/bitwise.c: Fix host regression failues on
	  64-bit PowerPC
	* support/regression/tests/align.c: do not include stdalign.h on
	  hosts that do not support it

2013-04-06 Philipp Klaus Krause <pkk AT spth.de>

	* src/stm8/gen.c:
	  STM8: Implement comparison for more operand types.

2013-04-02 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCC.lex,
	  src/SDCC.y,
	  src/SDCCerr.h,
	  src/SDCCerr.c,
	  src/SDCCsymt.h,
	  src/SDCCsymt.c,
	  src/SDCCicode.c,
	  src/SDCCval.h,
	  src/SDCCval.c,
	  src/port.h:
	  src/*/main.c:
	  doc/sdccman.lyx,
	  support/regression/tests/assert.c,
	  support/regression/tests/align.c:
	  Support for C11 _Static_assert static assertions and _Alignas alignment
	  specifiers.

2013-04-01 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCsymt.c,
	  src/stm8/gen.c,
	  src/stm8/main.c:
	  STM8: Implement on-stack register passing, taking addresses of on-stack
	  variables, handling of on-stack parameter operands.

2013-03-31 Philipp Klaus Krause <pkk AT spth.de>

	* doc/sdccman.lyx:
	  Update manual.
	* src/SDCCmain.c:
	  Deprecation warning for --small-is-8bits.
	* device/include/assert.h:
	  Prepare for static assertions.
	* src/SDCCast.h:
	  Fix warning.

2013-03-30 Philipp Klaus Krause <pkk AT spth.de>

	* doc/sdccman.lyx:
	  Update and reorganize manual.
	* src/izt:
	  Kill i186 and tcls900h ports.

2013-03-29 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCC.lex,
	  src/SDCCast.c,
	  src/SDCCast.h,
	  src/SDCC.y,
	  device/include/stdalign.h,
	  device/include/stddef.h,
	  device/include/stdnoreturn.h,
	  support/regression/tests/align.c:
	  Support for C11 _Alignof operator.

2013-03-24 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c:
	  Use mlt for multiplication by constant in z180 port.
	* src/SDCCralloc.hpp:
	  Add comment to reference the paper on the register allocator.

2013-03-16 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/gen.c:
	  Fix bug #2145.

2013-03-18 Borut Razem <borut.razem AT gmail.com>

	* support/scripts/gen_known_bugs.pl: use http instead https since the
	  LWP::Protocol::https perl module seems not to be installed by default

2013-03-16 Molnar Karoly <molnarkaroly AT users.sf.net>

	* device/include/pic14/pic14devices.txt,
	  device/non-free/include/pic14/pic16f1788.h,
	  device/non-free/include/pic14/pic16f1789.h,
	  device/non-free/lib/pic14/libdev/Makefile.in,
	  device/non-free/lib/pic14/libdev/devices.txt,
	  device/non-free/lib/pic14/libdev/pic16f1788.c,
	  device/non-free/lib/pic14/libdev/pic16f1789.c,
	  doc/sdccman.lyx:
	  New devices: PIC16F1788, PIC16F1789

2013-03-15 Borut Razem <borut.razem AT gmail.com>

	* support/scripts/gen_known_bugs.pl: adapted for Allura bug tracker

2013-03-14 Philipp Klaus Krause <pkk AT spth.de>

	* src/z80/peep.c:
	  Fix bug #2142 (ld is fixed, upper case still open).

2013-03-12 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl:
	  Filters the invalid instructions and code cleaning.

2013-03-12 Sourceforge

	* Project upgrade: Bug and RFE numbers after this
	  Use a numbering system different from the one
	  used before (also some other changes).
	
2013-03-05 Molnar Karoly <molnarkaroly AT users.sf.net>
	* device/non-free/include/pic14/pic16f1784.h,
	  device/non-free/include/pic14/pic16f1786.h,
	  device/non-free/include/pic14/pic16f1787.h,
	  device/non-free/include/pic16/pic18f65j94.h,
	  device/non-free/include/pic16/pic18f66j60.h,
	  device/non-free/include/pic16/pic18f66j65.h,
	  device/non-free/include/pic16/pic18f66j94.h,
	  device/non-free/include/pic16/pic18f66j99.h,
	  device/non-free/include/pic16/pic18f67j60.h,
	  device/non-free/include/pic16/pic18f67j94.h,
	  device/non-free/include/pic16/pic18f85j94.h,
	  device/non-free/include/pic16/pic18f86j60.h,
	  device/non-free/include/pic16/pic18f86j65.h,
	  device/non-free/include/pic16/pic18f86j94.h,
	  device/non-free/include/pic16/pic18f86j99.h,
	  device/non-free/include/pic16/pic18f87j60.h,
	  device/non-free/include/pic16/pic18f87j94.h,
	  device/non-free/include/pic16/pic18f95j94.h,
	  device/non-free/include/pic16/pic18f96j60.h,
	  device/non-free/include/pic16/pic18f96j65.h,
	  device/non-free/include/pic16/pic18f96j94.h,
	  device/non-free/include/pic16/pic18f96j99.h,
	  device/non-free/include/pic16/pic18f97j60.h,
	  device/non-free/include/pic16/pic18f97j94.h,
	  support/scripts/cinc2h.pl:
	  Updated based on the gputils.

2013-03-03 Raphael Neider <rneider AT web.de>

	* src/pic14/gen.c (popGet): improve debugging output,
	  (SetIrp): handle PO_IMMEDIATES correctly, restructure code,
	  (genUnpackBits): handle dummy reads w/o result correctly,
	  (genNearPointerGet): handle dummy reads w/o result efficiently,
	  together this fixes #3606703
	* src/pic14/gen.c (genConstPointerGet):
	  read AOP_SIZE(result) bytes from source, fixes #3606709

2013-02-25 Raphael Neider <rneider AT web.de>

	* src/pic14/ralloc.c (packRegsForOneuse):
	  prevent NULL ptr dereference (fixes bug #3605966)

2013-02-24 Raphael Neider <rneider AT web.de>

	* device/lib/pic14/libsdcc/ulong2fs.c:
	  prefer 'while (COND) {}' over 'if (COND) do {} while (COND)'
	* src/pic14/gen.c (genAnd):
	  fix for loop condition in ulong2fs.c (fixes #3605855)
	* device/lib/pic14/libm/Makefile.am:
	  fix typo in CFLAGS for libme (fixes #3605860)

2013-02-17 Raphael Neider <rneider AT web.de>

	* device/non-free/lib/pic14/configure.in,
	  device/non-free/lib/pic16/configure.ac:
	  Check and display devices missing in gputils before proceeding
	  and request updating gputils if any to-be-supported is missing
	* device/non-free/lib/pic14/configure,
	  device/non-free/lib/pic16/configure:
	  regenerated

2013-02-13 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl:
	  Use default sfr and sbit names if no header file.

2013-02-11 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/stm8/gen.c:
	  Code generation fixes and refactoring, implement ^, CALL.
	* src/SDCCopt.c:
	  Enable lospre for stm8.
	* src/stm8/main.c:
	  Correctly announce lack of multiplication support.

2013-02-11 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/stm8/gen.c:
	  Basic code generation infrastructure for &, |, RETURN, <, >.

2013-02-10 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: Adds used count to sfr, sbit and bit lists.

2013-02-10 Philipp Klaus Krause <philipp AT informatik.uni-frankfurt.de>

	* src/stm8/gen.c,
	  src/stm8/main.c:
	  Various code generation fixes, improvements, debug messages.
	* device/lib/stm8/Makefile.in:
	  Fix some hc08 leftovers.

2013-02-08 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: bugfix

2013-02-03 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: Improved recognition of jump tables.

2013-02-03 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: Improved recognition of jump tables and
	  bugfix.

2013-02-03 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: Bugfix and count of references in the RAM.

2013-02-01 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: Small refinements.

2013-01-31 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: Use IRAM key in name-list file.

2013-01-29 Philipp Klaus Krause <philipp AT colecovision.eu>

	* src/stm8/gen.c:
	  Use clr for more efficient zeroing.

2013-01-29 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: Use informations of the OSEG area from
	  map file.

2013-01-28 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: New command option: --name-list

2013-01-28 Philipp Klaus Krause <pkk AT spth.de>

	* src/hc08/gen.c,
	  More efficient calls to _Noreturn functions.

2013-01-28 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: Improved finds of stack. Prints into
	  map the iRAM.

2013-01-27 Philipp Klaus Krause <pkk AT spth.de>

	* src/SDCCpeeph.c,
	  src/z80/gen.c,
	  More efficient calls to _Noreturn functions.

2013-01-27 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: Prints the map of RAM, list of bits and
	  start of stack.

2013-01-27 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: Improved recognition of jump tables.

2013-01-26 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: New command option: --recognize-jump-tables

2013-01-24 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: New command option: --find-lost-labels

2013-01-23 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl:
	  New feature in "Public labels" section: (calls: ..., jumps: ...)
	  ("number of calls" and "number of jumps")

2013-01-21 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: Bugfix and more proposal for use.

2013-01-20 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: Additional informations about direction
          of the jumps.

2013-01-20 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: "Public variables" -> "Public labels"

2013-01-20 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: Improved handling of blocks and
	  lists of labels and variables.

2013-01-19 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: Expanded assembly mode and nicer tables.

2013-01-15 Raphael Neider <rneider AT web.de>

	* device/lib/pic16/libsdcc/long/modulong.c:
	  return ~0UL instead of looping endlessly on divide-by-0,
	  addresses #3600983

2013-01-13 Raphael Neider <rneider AT web.de>

	* src/pic14/gen.c (genDataPointerSet): 
	  fix and simplify operand size detection, fixes #3600361
	* src/pic14/main.c (keywords[]):
	  remove unsupported "pdata", fixes #3600724

2013-01-13 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/cinc2h.pl: Canceled the command option: --create-sfr16
	* device/non-free/include/pic16/pic18*.h,
	  device/non-free/lib/pic16/libdev/pic18*.c: Canceled the __sfr16 type.

2013-01-13 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: New command option: --assembly-source

2013-01-13 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/cinc2h.pl: New command option: --create-sfr16
	  (This option is for the time being operates only at the pic16 series.)
	* device/non-free/include/pic16/pic18*.h,
	  device/non-free/lib/pic16/libdev/pic18*.c: Implementation of the __sfr16
	  type.

2013-01-12 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: New command option: --no-explanations

2013-01-12 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: New command option: --hex-constant

2013-01-12 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: Faster the decoding of instructions.

2013-01-11 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: More control characters are recognized.
	  Refinement the align of explanations.

2013-01-11 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/hc08/main.c: Nearly exact instruction sizes for peephole
	  branch optimizations.

2013-01-10 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/mcs51/gen.c (genSend): "fix" for bug #3600343

2013-01-10 Molnar Karoly <molnarkaroly AT users.sf.net>

	* support/scripts/mcs51-disasm.pl: Simplified the code.

2013-01-10 Molnar Karoly <molnarkaroly AT users.sf.net>

	* doc/sdccman.lyx: Expanded the 6.2 (Tools) table.

2013-01-10 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/hc08/ralloc.c (packRegisters),
	* src/hc08/gen.c (aopForRemat): allow more rematerializations of
	  cast pointers
	* src/hc08/ralloc2.cc (operand_is_ax): fixed bug that misidentified
	  some register assignments as the register pair AX

2013-01-09 Erik Petrich <epetrich AT ivorytower.norman.ok.us>

	* src/SDCC.y,
	* src/SDCCast.h,
